/*---------------------------------------------------------------------------------------------------------*/
/*                                                                                                         */
/* Copyright(c) 2010 Nuvoton Technology Corp. All rights reserved.                                         */
/*                                                                                                         */
/*---------------------------------------------------------------------------------------------------------*/
/*-----------------------------------------------------------------------------
  Nuvoton Technoledge Corp creadted by PU20
  XTAL = 12MHz, BPS = 115200
 *-----------------------------------------------------------------------------*/
/*
//-------- <<< Use Configuration Wizard in Context Menu >>> ------------------
//
// <e0> Clock Configuration
//   <h> Enable Clock Source (PWRCON)
//                  <q1.0> Crystal 12MHz
//            <q1.3> Internal RC 10kHz
//                  <q1.2> Internal RC 22MHz
//   </h>
// <e2> Enable PLL (PLLCON)
//    <o3.19> PLL Clock Source Selection
//                  <0=> Crystal 12MHz        <1=> Internal RC 22MHz
// </e2>
//    <o4.0..2> HCLK System Clock Source Selection (CLKSEL0)
//                  <0=> Crystal 12MHz
//                  <2=> PLL Clock            <3=> Internal RC 10KHz
//                  <4=> Internal RC 22MHz
// </e0>
//-------- <<< end of configuration section >>> ------------------------------
*/
#include "include.h"
#include "command_table.h"
#include "DeviceBtj_Header.h"
#include "sys_types.h"
#include "sys_config.h"
#include "tra_uart.h"
#include "hw_lc.h"
#include "app_dmp_module.h"
//#include "le_advertise.h"
static DEVICEBTJ_SERVICE_T spp_service;
//static DEVICEBTJ_SERVICE_T hid_service;
//static DEVICEBTJ_SERVICE_T pnp_service;
DEVICEBTJ_ADAPTER_T btj_adapter;
DEVICEBTJ_ADAPTER_P bt_adapter;
DEV_MEM_ADDR pair_device_addr = {0};
//u_int8 bt_tx_buff[SEND_BUFFER_CNT][SEND_BUFFER_SIZE],tx_buff_len[SEND_BUFFER_CNT];
extern u_int8 mouse_data[6];//key ,Xlow,yHigh,X+Y,wheel,mouse_status
//extern char dBLEAddr ;// remember set again when rf_status change
extern u_int8 Power_mode; // 0:power on  1:wakeup
u_int16 DIS_ST_cnt = 0;
u_int8 write_class_of_device[7] =
{0X01, 0x24, 0x0c, 0x03, 0x12, 0x03, 0x00};
volatile u_int32 sys_flag = 0, sys_flag1 = 0;;
u_int8 pin_code_req, passkey_req, confirm_req;
u_int8 linkkey_buff[24];
//u_int8 Rf_status[2]; //  0:BT status 0:class 1:ble
//u_int8 Rf_statusX[128]; //  0:BT status 0:class 1:ble
u_int8  bt_link_index;
u_int8 maximum_latency;
u_int16 enter_sniff_cnt = 0, start_auto_conect_count = 0;
u_int8 spp_dis_connect_ind_flag = 0;
char auto_connect_cnt;
u_int8 bd_test_addr[6] = {0x11, 0x22, 0x33, 0x44, 0x55, 0x66};
u_int8 addr_tmp[6];
extern u_int8 connecta_request;
//u_int8 BT_mode;
extern u_int8 master_sleep_flag;
//extern u_int8 BLE_ADV_CLOSE,BR_INQPAG_CLOSE;
extern void change_to_BLE_MODE(void);
void delay_ms(unsigned int tt)
{
  unsigned int i, j;

  while(tt--)
  {
    for (j = 0; j < 1000; j++)
    {
      for (i = 0; i < 12; i++)
      {
        ;
      }
    }
  }
}
void int2str( u_int32 input, u_int8 *output)
{
  u_int8 i;
  u_int32 input_temp = input;

  for(i = 5; i > 0; i--)
  {
    output[i] =  (input_temp % 10) + '0';
    input_temp = (input_temp / 10);
  }

  output[0] =  (input_temp % 10) + '0';
  input_temp = (input_temp / 10);
}
void send_HCI_command(const unsigned char *buffer, unsigned char data_len)
{
  u_int8 i;

  for (i = 0; i < data_len; i++)
  {
    TRAhcit_UART_Rx_Char(buffer[i]);
  }
}
void SYS_Host_Initialise(void)
{
  memset((void*)&btj_adapter, 0x00, sizeof(DEVICEBTJ_ADAPTER_T));
  send_HCI_command(Com_Table_Reset, 4);
  {
    memset((void*)&spp_service, 0x00, sizeof(DEVICEBTJ_SERVICE_T));
    DeviceSdpdb_Doreg(&btj_adapter, &spp_service, DEVICEBTJ_OBJECT_SPP);
    spp_service.adapter                        = &btj_adapter;
    spp_service.rfc_context.rfc_mtu            = RFC_FRAME_SIZE;
    spp_service.ctx_state                      = SERVICE_STATE_IDLE;
    btj_adapter.app_service_header             = &spp_service;

  }
  auto_connect_cnt = 0;
}
void enter_sniff(void)
{
  unsigned char i;
  unsigned char comm_table[14];

  if(sys_flag & FLAG_UART_INTERRPUT)
  {
    return;
  }

  if(enter_sniff_cnt > 0)
  {
    enter_sniff_cnt--;
    return;
  }

  for( i = 0; i < 14; i++)
  {
    comm_table[i] = Com_Table_SniffMode[i];
  }

  comm_table[4] = (btj_adapter.hci_context->hci_context_handle) & 0xff;
  comm_table[5] = (btj_adapter.hci_context->hci_context_handle) >> 8;
  send_HCI_command(comm_table, 14);
  sys_flag |= FLAG_BT_SET_SNIFF;
  //bprintf("enter sniff\r\n");
  //delay_ms(2);
#ifdef _KEYBOARD__
  //maximum_latency=8;//sniff2 interval=sniff interval*maximum_latency
#else
  //maximum_latency=0x20;
#endif
}
void exit_sniff(void)
{
  unsigned char i;
  unsigned char comm_table[6];

  for( i = 0; i < 6; i++)
  {
    comm_table[i] = Com_Table_ExitSniff[i];
  }

  comm_table[4] = (btj_adapter.hci_context->hci_context_handle) & 0xff;
  comm_table[5] = (btj_adapter.hci_context->hci_context_handle) >> 8;
  send_HCI_command(comm_table, 6);
  //bprintf("exit_sniff\r\n");
}
char connect_sensor_cnt = 0;// for when connect,the sensor is jump too far
extern void tx_buff_reset(void);
void connect_ind()
{

  if(sys_flag & FLAG_BT_INPAIR)
  {
    sys_flag &= ~FLAG_BT_INPAIR;
//	BLE_ADV_CLOSE=1;                                          //BLE CLOSE
//	LEadv_Set_Advertise_Enable(0x00);                         //CLOSE BLE ADVERTISING
    //Rf_status[0]=0;                 //SET_BR_MODE
    //Rf_status[1]=Rf_status[1]-1;    //BLE ADDRESS-1
    //flash_erase_sector(FLASH_SPACE_TYPE_NVR,0x8080);
    //flash_write(FLASH_SPACE_TYPE_NVR,0x8080,2,Rf_status);    //save_to_flash
  }

  sys_flag |= (FLAG_CONNECTED | FLAG_BT_DISABLE_SCAN);
  sys_flag &= ~(FLAG_BT_INPAIR | FLAG_AUTO_CONNECT_BUSY | FLAG_BT_IN_PAGE
                | FLAG_AUTO_CONNECT_TEST_DONGLE_BUSY);
  //sys_flag1 &= ~(FLAG_BLE_AUTO_CONNECT_BUSY|FLAG_KEY_NOACTIVE_LOW);


  auto_connect_cnt = 0;
  pin_code_req = 0;
  passkey_req = 0;
  confirm_req = 0;
  enter_sleep_cont = 0;
  key_idle_count = 0;
  led_time_cnt = 0;
  connect_sensor_cnt = 0;

  bprintf("connected\r\n");//,Rf_status[0]

  Power_mode = 1;
  tx_buff_reset();
}
void disconnect_ind(void)
{

  pin_code_req = 0;
  passkey_req = 0;
  confirm_req = 0;
  enter_sleep_cont = 0;
  key_idle_count = 0;
  led_time_cnt = 0;
  sys_flag &= ~(FLAG_AUTO_CONNECT_TEST_DONGLE_BUSY | FLAG_AUTO_CONNECT_BUSY);
  sys_flag &= ~(FLAG_CONNECTED | FLAG_BT_SET_LINKPOLICY_IND);
  sys_flag &= ~FLAG_BT_SET_SNIFF;
  sys_flag &= ~FLAG_BT_IN_SNIFF;
  bprintf("disconnected =%x\r\n", DIS_ST_cnt);

//       if(BR_INQPAG_CLOSE==0)
  {
    pin_code_req = 0;
    passkey_req = 0;
    confirm_req = 0;

    if(sys_flag & FLAG_BT_INPAIR)
    {
      send_HCI_command(Com_Table_WriteScanEnable, 5);   //pair
    }
    else
    {
      send_HCI_command(Com_Table_WriteScanEnable_poweron, 5);
    }

    bprintf("disconnected\r\n");
    DEBUG_MSG(0X87);
  }

}
void status_control(
  DEVICEBTJ_ADAPTER_P Adapter,
  DEVICEBTJ_SERVICE_P Service)
{
  static u_int16 time_cnt = 0;

  if((sys_flag & FLAG_CONNECTED) && !(sys_flag & (FLAG_BT_SET_SNIFF | FLAG_L2CAP_SDP_CONNECT)))
  {
    time_cnt++;
  }
  else
  {
    time_cnt = 0;
  }

//---POWER ON BR RE CONNECT(ONLY 1 TIME)---------------------------------------------------------------------
//    if((BR_INQPAG_CLOSE==0)&&(BLE_ADV_CLOSE==1))
  {
    if(start_auto_conect_count < 100)
    {
      start_auto_conect_count++;
    }
    else
    {
      if(start_auto_conect_count < 101)
      {
        sys_flag |= FLAG_AUTO_CONNECT_START;
        sys_flag &= ~(FLAG_AUTO_CONNECT_BUSY);
        sys_flag &= ~(FLAG_AUTO_CONNECT_TEST_DONGLE_BUSY);
        start_auto_conect_count = 111;
      }
    }
  }

//---------------------------------------------------------------------------------------
  if( (time_cnt >= 1000) && (sys_flag & FLAG_BT_DISABLE_SCAN))
  {
    time_cnt = 0;
    sys_flag &= (~FLAG_BT_DISABLE_SCAN);
    send_HCI_command(Com_Table_WriteScanEnable_DisableAll, 5);
  }

  if(( sys_flag & FLAG_BT_SET_LINKPOLICY_IND) && (!(sys_flag & FLAG_BT_IN_SNIFF)) )
  {
    time_cnt = 0;

    if(!(sys_flag & FLAG_BT_SET_SNIFF))
    {
      //  if(0!=gpio_input(((UART_EN>>4)&0x0F),(UART_EN&0x0F)))
      enter_sniff();
    }
  }

}
extern uint8 sniff_latency_count;
extern u_int32 LED_time;
//extern u_int8 Battery_Service_CCC[2] ;
//extern u_int8 SMP_en;
void
DeviceBtj_Event(
  DEVICEBTJ_ADAPTER_P MsgAdapter,
  DEVICEBTJ_SERVICE_P MsgService,
  BTBYTE  MsgEvent,
  BTBYTE  MsgState,
  BTPBYTE MsgBuffer,
  BTWORD  MsgLength
)
{
  unsigned char i, j;
  unsigned char comm_table[26], confirm_num_buff[6];
  unsigned int confirm_number;
  static unsigned char flag_pair = 0;
//    uint8 tmp_buf[3];
  SET_SYS_PARA_P set_sys_para = (SET_SYS_PARA_P)set_sys_buff;
//    u_int8 st0=0;
  u_int8 tmp_buff[48];

  switch (MsgEvent)
  {
  case DEVICEBTJ_EVENT_WRITE_LOCAL_TYPE:
    send_HCI_command(write_class_of_device, 7);
    break;

  case DEVICEBTJ_EVENT_WRITE_SCAN_ENABLE:

  {
    LED_time = 0;
    DIS_ST_cnt = 0;
    uart_rx_buff_header = 0;
    uart_rx_buff_tailor = 0;
    uart_send_length = 0;
    uart_send_cnt = 0;
    uart_cnt_index = 0;
    sys_flag &= ~FLAG_UART_INTERRPUT;

    if((sys_flag & FLAG_BT_INPAIR) == 0)
    {
      send_HCI_command(Com_Table_WriteScanEnable_poweron, 5);
      bprintf("SCAN_ENABLE1\r\n");
    }
    else
    {
      send_HCI_command(Com_Table_WriteScanEnable, 5);
      bprintf("SCAN_ENABLE2\r\n");
    }

  }
  break;

  case DEVICEBTJ_EVENT_WRITE_LOCAL_NAME:
    DeviceHci_WriteLocalName(MsgAdapter, set_sys_para->classic_bt_name, 32);

    break;

  case DEVICEBTJ_EVENT_WRITE_EIR:
    Write_Extended_Inquiry_Response_Command(MsgAdapter, set_sys_para->classic_bt_name, set_sys_para->classic_bt_name_len);

    break;

  case DEVICEBTJ_EVENT_LINKKEY_REQUEST:
    flash_read(FLASH_SPACE_TYPE_NVR, 0x80, 24, tmp_buff);
    bprintf("DEVICEBTJ_EVENT_LINKKEY_REQUEST\r\n");

    memcpy(linkkey_buff, &tmp_buff[0], 24);

    if( (btj_adapter.hci_machine.hci_machine_uart_buf[0] == linkkey_buff[0] )
        && (btj_adapter.hci_machine.hci_machine_uart_buf[1] == linkkey_buff[1] )
        && (btj_adapter.hci_machine.hci_machine_uart_buf[2] == linkkey_buff[2] )
        && (btj_adapter.hci_machine.hci_machine_uart_buf[3] == linkkey_buff[3] )
        && (btj_adapter.hci_machine.hci_machine_uart_buf[4] == linkkey_buff[4] )
        && (btj_adapter.hci_machine.hci_machine_uart_buf[5] == linkkey_buff[5] )
      )
    {
      comm_table[0] = 0x01;
      comm_table[1] = 0x0b;
      comm_table[2] = 0x04;
      comm_table[3] = 22;

      for(j = 0; j < LINK_KEY_SAVE_BUF_LEN; j++)
      {
        comm_table[4 + j] = linkkey_buff[j] ;
      }

      send_HCI_command(comm_table, 26);
    }
    else
    {
      comm_table[0] = 0x01;
      comm_table[1] = 0x0c;
      comm_table[2] = 0x04;
      comm_table[3] = 6;
      comm_table[4] = MsgBuffer[0];
      comm_table[5] = MsgBuffer[1];
      comm_table[6] = MsgBuffer[2];
      comm_table[7] = MsgBuffer[3];
      comm_table[8] = MsgBuffer[4];
      comm_table[9] = MsgBuffer[5];
      send_HCI_command(comm_table, 10);

    }

    break;

  case DEVICEBTJ_EVENT_LINKKEY_NOTIFICATION:
    // MsgBuffer is: 6 bytes of mac address + 16 bytes of link key, MsgLength is 22//linkkey:%02x%02x%02x%02x%02x%02x
    bprintf("%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x\n",
            //MsgBuffer[0],MsgBuffer[1],MsgBuffer[2],MsgBuffer[3],MsgBuffer[4],MsgBuffer[5],
            MsgBuffer[6], MsgBuffer[7], MsgBuffer[8], MsgBuffer[9], MsgBuffer[10],
            MsgBuffer[11], MsgBuffer[12], MsgBuffer[13], MsgBuffer[14], MsgBuffer[15],
            MsgBuffer[16], MsgBuffer[17], MsgBuffer[18], MsgBuffer[19], MsgBuffer[20],
            MsgBuffer[21]);

    if(!(sys_flag & FLAG_AUTO_CONNECT_TEST_DONGLE_BUSY))
    {

      flash_erase_sector(FLASH_SPACE_TYPE_NVR, 0x80);

      for(i = 0; i < 22; i++)
      {
        linkkey_buff[i] = MsgBuffer[i];
      }

      flash_write(FLASH_SPACE_TYPE_NVR, 0x80, 24, MsgBuffer);
    }

    break;

  case DEVICEBTJ_EVENT_SPP_CONNECT_IND:
    if(pin_code_req)
    {
      pin_code_req = 0;
    }

    connect_ind();
    connecta_request = 1;
    spp_dis_connect_ind_flag = 0;
    break;

  case DEVICEBTJ_EVENT_SPP_DISCONNECT_IND:

    //bprintf("SPP_DISCONNECT_IND\r\n");
    if(flag_pair)
    {
      flag_pair = 0;
//            notify_status(EME_PAIR_FAIL);
    }

    //DEBUG_MSG(0X89);
    connecta_request = 0;
    //disconnect_ind();
    spp_dis_connect_ind_flag = 1;
    break;

  case DEVICEBTJ_EVENT_ACL_DISCONNECT_IND:
    bprintf("ACL_DISCONNECT_IND=%x\r\n", MsgState);

    //DEBUG_MSG(0X8A);
    if(pin_code_req)
    {
      pin_code_req = 0;
    }

    if(flag_pair)
    {
      flag_pair = 0;
//            notify_status(EME_PAIR_FAIL);
    }

    connecta_request = 0;
    disconnect_ind();
    break;

case DEVICEBTJ_EVENT_SPP_RECEIVE:
  bprintf("Length:%d\r\n", MsgLength);
  bprintf("M1:%x\r\n", MsgBuffer[0]);
  bprintf("M2:%x\r\n", MsgBuffer[1]);
  bprintf("M3:%x\r\n", MsgBuffer[2]);
  uart_data_send(MsgBuffer, MsgLength);
  sys_flag |= FLAG_KEY_ACTIVE;
  enter_sniff_cnt = 10000;
  break;

  case DEVICEBTJ_EVENT_HID_CONNECT_IND:
    connect_ind();
    break;

  case DEVICEBTJ_EVENT_HID_DISCONNECT_IND:
    bprintf("HID_DISCONNECT_IND=%x\r\n", MsgState);
    sys_flag |= FLAG_KEY_ACTIVE;
    DeviceHci_Disconnect(&btj_adapter, btj_adapter.hci_context->hci_context_handle, HCI_ERR_OETC_USER);
    //disconnect_ind();
    break;

  case DEVICEBTJ_EVENT_HID_RECEIVE:
    break;

  case DEVICEBTJ_EVENT_HID_OUT_REPORT:
    // set_out_report(WRITE_OUT_REPORT,0,MsgBuffer,MsgLength);
    break;

  case DEVICEBTJ_EVENT_HID_GET_REPORT:
    //get report
    //fill report data in MsgBuffer,fill data len in MsgLength




    break;

  case DEVICEBTJ_EVENT_WRITE_LINK_POLICY_SETING:

    Write_Link_Policy_Settings(MsgAdapter, MsgAdapter->hci_context->hci_context_handle, ENABLE_SNIFF_MODE);

    break;

  case DEVICEBTJ_EVENT_MODE_CHANGE:
    bprintf("mode=%x\n", MsgBuffer[3]);

    if(MsgBuffer[3] == 0x00) //active mode
    {
      sys_flag &= ~FLAG_BT_IN_SNIFF;
      sys_flag &= ~FLAG_BT_SET_SNIFF;
      enter_sniff_cnt = 10000;
      sniff_latency_count = 0;
      maximum_latency = 0;
      sys_flag |= FLAG_KEY_ACTIVE;
      //Timer_Start(0,10000);
    }
    else if(MsgBuffer[3] == 0x02) //sniff mode
    {
      enter_sleep_cont = 0;
      led_time_cnt = 0;
      //sys_flag |= FLAG_KEY_ACTIVE;
      sys_flag |= FLAG_BT_IN_SNIFF;
      sys_flag &= ~FLAG_BT_SET_SNIFF;
      maximum_latency = 0x10;
      //Timer_Stop(0);
    }

    break;

  case DEVICEBTJ_EVENT_PIN_CODE_REQUEST:

    if(set_sys_para->classic_bt_pair_mode == 0x00)
    {
//            notify_status(EME_PAIR_REQUEST);
      DeviceHci_PinCodeReply(MsgAdapter, MsgBuffer, set_sys_para->classic_bt_pair_pincode, set_sys_para->classic_bt_pair_pincode_len);
      pin_code_req = 1;
    }


    break;

  case DEVICEBTJ_EVENT_PASSKEY_REQUEST:

    passkey_req = 1;

    memcpy (pair_device_addr, MsgBuffer, LEN_DEV_MEM_ADDR);
    //send_notify_passkey_request();
    break;

  case DEVICEBTJ_EVENT_CONFIRMATION_REQUEST:
    confirm_req = 1;

    memcpy (pair_device_addr, MsgBuffer, LEN_DEV_MEM_ADDR);
    memcpy (&confirm_number, &MsgBuffer[6], 4);

    //DeviceHci_UserConfirmationReply(bt_adapter, pair_device_addr);

    int2str(confirm_number, confirm_num_buff);
//       send_notify_confirm_request(confirm_num_buff,6);
    break;

  case DEVICEBTJ_EVENT_IO_CAPABILITY_REQUEST:
    ////3:no output input//1:display yes or no////2 keyboard only
//        notify_status(EME_PAIR_REQUEST);
    //if(MsgBuffer[8]<2 && set_sys_para->classic_bt_pair_mode>1)
    //    DeviceHci_IoCapabilityNegativeReply(MsgAdapter, MsgBuffer,HCI_ERR_REJECT_SECURITY_REASON);
    //else
    DeviceHci_IoCapabilityReply(MsgAdapter, MsgBuffer);
    flag_pair = 1;

    break;

  case DEVICEBTJ_EVENT_SIMPLE_PAIRING_COMPLETE:

    bprintf("MsgState=%x\r\n", MsgState);

    if(flag_pair)
    {
      flag_pair = 0;

      if(MsgState == 0)
      {
//                notify_status(EME_PAIR_SUCCEED);
      }
      else
      {
//                notify_status(EME_PAIR_FAIL);
      }
    }

    break;

    /*
      case DEVICEBTJ_EVENT_AUTO_CONNECT:

         if(auto_connect_cnt--)
         {
             DeviceHci_Connect(MsgAdapter, MsgBuffer);
         }
         else
         {
             DeviceHid_Reset(MsgAdapter, MsgAdapter->app_service_header->l2c_context);
             DeviceRfc_Reset(MsgAdapter,&spp_service);
             disconnect_ind();
         }

         break;
     case DEVICEBTJ_EVENT_HID_CONTROL_UNPLUG:

         bprintf("bt_3.0 unplug\r\n");
         memset(linkkey_buff, 0xff, LINK_KEY_LEN);
         flash_write(FLASH_SPACE_TYPE_NVR,0x80,24,linkkey_buff);

         break;
    */
  default:
    break;
  }
}


BTBOOL
DeviceBtj_Adapter_Write(
  DEVICEBTJ_ADAPTER_P adapter,
  BTPBYTE buffer,
  BTWORD length
)
{
  BTBOOL result = BTTRUE;

  if(buffer[0x00] == 0x02)
  {
    if(adapter->acl_packets_num > 0x00)
    {
      {
        if(!(sys_flag & FLAG_CONNECTED))
        {
          delay_us(4000);
        }
      }

      while (length > 0x00)
      {
        enter_sniff_cnt = 10000;
        TRAhcit_UART_Rx_Char(*buffer);
        buffer++;
        length--;
      }

      adapter->acl_packets_num--;
    }
    else
    {
      result = BTFALSE;
    }
  }
  else
  {
    while (length > 0x00)
    {
      TRAhcit_UART_Rx_Char(*buffer);
      buffer++;
      length--;
    }
  }

  return result;
}





DEVICEBTJ_API
DEVICEBTJ_STATE
DEVICEBTJ_STDCALL
DeviceBtj_Connect(
  DEVICEBTJ_ADAPTER_P Adapter,
  DEVICEBTJ_SERVICE_P Service,
  DEV_MEM_ADDR DevMemAddr
)
{
  DEVICEBTJ_STATE state = DEVICEBTJ_STATE_FAILURE_INVALID;

  if (Service->ctx_state != SERVICE_STATE_IDLE)
  {
    state = DEVICEBTJ_STATE_FAILURE_ALREADY_CONNECTING;
  }
  else if (Service->sdp_database.busy)
  {
    state = DEVICEBTJ_STATE_FAILURE_ALREADY_CONNECTED;
  }
  else
  {
    BTBYTE hci_index = 0x00;
    HCI_CONTEXT_P hci_context = BTNULL;

    /* Check hci_context */
    for (hci_index = 0x00; hci_index < DEVICEMAX_HCI_CONTEXT && hci_context == BTNULL; hci_index++)
    {
      HCI_CONTEXT_P tmp_context = &Adapter->hci_context[hci_index];

      if (DeviceBtj_Utils_DevMemAddr_ChkSame(DevMemAddr, tmp_context->hci_context_devaddr))
      {
        hci_context = tmp_context;
      }
      else if (tmp_context->hci_context_handle > 0x0000)
      {
        state = DEVICEBTJ_STATE_FAILURE_INSTANCE;
      }
    }

    if (state != DEVICEBTJ_STATE_FAILURE_INSTANCE)
    {
      if (hci_context == BTNULL)
      {
        //bprintf("send connect cmd\n");
        /* Start hci */
        DeviceHci_Connect(Adapter, DevMemAddr);
        /* Makes flags */
        Service->ctx_state = SERVICE_STATE_CONNECTING_START;
        /* Makes current service is busy */
        Service->sdp_database.busy = BTTRUE;
        /* Store request adress */
        memcpy((void*)Service->dev_mem_addr, DevMemAddr, sizeof(DEV_MEM_ADDR));
      }
      else
      {
        /* Start l2c */
        DeviceL2c_Send_ConnectionReq(Adapter, Service, hci_context, L2C_PSM_SDP);
        /* Makes current service is busy */
        Service->sdp_database.busy = BTTRUE;
        /* Store request adress */
        memcpy((void*)Service->dev_mem_addr, DevMemAddr, sizeof(DEV_MEM_ADDR));
      }

      state = DEVICEBTJ_STATE_SUCCESS;
    }
  }

  return state;
}
DEVICEBTJ_SERVICE_P
DeviceBtj_Adapter_GetService(
  DEV_MEM_ADDR DevMemAddr
)
{
  if (DevMemAddr != BTNULL)
  {
    DEVICEBTJ_SERVICE_P app_service_header = btj_adapter.app_service_header;

    /* Only one instance between adapter and remote device */
    while (app_service_header != BTNULL)
    {
      if (app_service_header->ctx_state == SERVICE_STATE_CONNECTING_START || app_service_header->ctx_state == SERVICE_STATE_CONNECTING_RETRY)
      {
        if (DeviceBtj_Utils_DevMemAddr_ChkSame(app_service_header->dev_mem_addr, DevMemAddr))
        {
          return app_service_header;
        }
      }

      app_service_header = app_service_header->next;
    }
  }

  return BTNULL;
}

void Device_HCI_Rx(u_int8 *head_buf, u_int32 head_len, u_int8 *pdu_buf, u_int32 pdu_len)
{
  DeviceHci_Callback(&btj_adapter, head_buf, head_len);
  DeviceHci_Callback(&btj_adapter, pdu_buf, pdu_len);
}

uint8 spp_data_send(uint8 *buff, uint8 len)
{

  if(btj_adapter.acl_packets_num > PRH_BS_CFG_SYS_NUM_OUT_ACL_PACKETS - 4)
  {
    if(DeviceRfc_Send(&btj_adapter, btj_adapter.app_service_header, buff, len))
    {
      return 1;
    }
  }

  return 0;

}
void FAST_CALL Host_Loop()
{
  if (btj_adapter.acl_packets_num > 0x00)
  {
    if (btj_adapter.uih_credits_l2c != BTNULL && btj_adapter.uih_credits_rfc != BTNULL)
    {
      L2C_CONTEXT_P l2c_context = btj_adapter.uih_credits_l2c;
      RFC_CONTEXT_P rfc_context = btj_adapter.uih_credits_rfc;
      /* Construct hci, l2cap and rfcomm header */
      DeviceRfc_UihHeader(btj_adapter.uih_credits_buf, l2c_context, RFC_PF_SET(RFC_FRA_UIH), RFC_CR_FRA_UIH_VAL(rfc_context->rfc_init), rfc_context->rfc_sc, RFC_FRAME_UIH_LENGTH + 0x01);
      /* Assign credit */
      btj_adapter.uih_credits_buf[sizeof(HCI_COMMON_T) + RFC_FRAME_UIH_OFFSET] = rfc_context->rfc_lcredit;

      /* Write packet */
      if(DeviceBtj_Adapter_Write(&btj_adapter, btj_adapter.uih_credits_buf, sizeof(btj_adapter.uih_credits_buf)))
      {
        /* Clear local credit */
        rfc_context->rfc_lcredit = 0x00;
        btj_adapter.uih_credits_l2c = BTNULL;
        btj_adapter.uih_credits_rfc = BTNULL;
      }

    }

    if(rfcomm_dis_fail)
    {
      rfcomm_dis_fail = 0;
      DeviceBtj_Adapter_Write(&btj_adapter, backup_buffer, 13);
    }

    if(l2cap_dislink_fail)
    {
      l2cap_dislink_fail = 0;
      DeviceBtj_Adapter_Write(&btj_adapter, backup_buffer, 17);
    }
  }

  status_control(&btj_adapter, &spp_service);
}

void Clear_Class_BT_Status(void)
{
  spp_service.ctx_state = SERVICE_STATE_IDLE;
}
