#ifndef __DEVICEBTJ_HANDLER_H_
#define __DEVICEBTJ_HANDLER_H_
#include "sys_types.h"
#include "include.h"
#define HID_REPORT_SIZE 10
#define SEND_BUFFER_CNT  6
#define SEND_BUFFER_SIZE  10
#define DATA_LENGTH    8
#define LINK_KEY_SAVE_BUF_LEN 23
#define BT1_C_MODE      0x02
#define BT1_B_MODE      0x03
#define BT2_C_MODE      0x04
#define BT3_B_MODE      0x05
#define RF24_MODE       0x08
typedef enum _UART_CMD_STATE
{
    UART_CMD_STATE_HEAD_ONE,
    UART_CMD_STATE_HEAD_TWO,
    UART_CMD_STATE_HEAD_THREE,
    UART_CMD_STATE_HEAD_FOUR,
    UART_CMD_STATE_OPCODE,
    UART_CMD_STATE_LENGTH,
    UART_CMD_STATE_ERROR,
    UART_CMD_STATE_ERROR_ONE,
    UART_CMD_STATE_ERROR_TWO,
    UART_CMD_STATE_ERROR_THREE,
    UART_CMD_STATE_ERROR_FOUR,
    UART_CMD_STATE_PACKET
    
} UART_CMD_STATE;

#define LINK_KEY_LEN 22
#define BT_DEVICE_CNT 3


extern volatile u_int32 sys_flag;
extern u_int8 set_sys_buff[sizeof(SET_SYS_PARA_T)];
extern volatile u_int32 sys_flag1;;
extern u_int8 bd_addr[6];
extern u_int8 bt_tx_buff[SEND_BUFFER_CNT][SEND_BUFFER_SIZE],tx_buff_len[SEND_BUFFER_CNT];
extern u_int8 tx_buff_head,tx_buff_tail,tx_buff_count;
extern u_int8 backup_buffer[17],rfcomm_dis_fail,l2cap_dislink_fail;
extern u_int8 stan_key[8];
extern u_int8 pin_code_req,passkey_req,confirm_req;
extern DEV_MEM_ADDR pair_device_addr;
extern DEVICEBTJ_ADAPTER_T btj_adapter;
extern DEVICEBTJ_ADAPTER_P bt_adapter;
extern volatile u_int8 b_26M_colsed;
extern volatile u_int16 uart_rx_buff_header,uart_rx_buff_tailor;
extern volatile char uart_rx_tx_buff[UART_BUFF_LEN];
extern u_int8 uart_send_buff[UART_SEND_LENGTH];
extern u_int8 uart_send_length,uart_send_cnt,uart_cnt_index;
extern u_int8 key_lock;
extern u_int16 enter_sleep_cont,key_idle_count,led_time_cnt;
extern u_int8 bt_time_tick;
void SYS_Host_Initialise(void);
void FAST_CALL Host_Loop(void);
void disconnect_ind(void);
void reset_bt(void);
uint8 spp_data_send(uint8 *buff,uint8 len);
void Device_uart_rx(void);
#endif
