/************************************************************
Copyright (C), 1988-1999, Tech. Co., Ltd.
FileName: uart_protocol.c
Author:
Version :
Date:
Description: uart command protocol module
Version:
Others:
History:
<author> <time> <version > <desc>
Simon 17/03/11 1.0 build this moudle
***********************************************************/
#include "include.h"
#include "DeviceBtj_Header.h"
#include "DeviceBtj_Handler.h"
#include "le_connection.h"
#include "le_att.h"
#include "le_gap.h"
#include "le_const.h"
#include "le_config.h"
#include "app_dmp_module.h"
#include "Le_smp.h"
#include "bt_init.h"
#include "le_cts_app.h"
#include "tra_queue.h"
#define RUN_APP   0
u_int8 platform_reset_flag=0;
u_int8 bt_default_open=1;
#if(RUN_APP)
u_int8 uart_flow_control=1;
u_int8 adc_enable_control=0;
u_int8 adc_value;
RW_RAM u_int8 dmp_tx_buffer[138];
RW_RAM u_int8 ble_data_buff[MAX_BUF_ROW][MAX_BUF_CNT],ble_data_len[MAX_BUF_ROW];
RW_RAM u_int8 ble_data_write,ble_data_read,ble_data_cnt;
u_int32 uart_conf_value;
#define FILL_BUFF_LEN  300
RW_RAM u_int8 notify_buffer[FILL_BUFF_LEN]; //bufferֹȴʱݶʧ
RW_RAM u_int8 notify_data[138];
static  u_int16 fill_data_header=0,fill_data_tailor=0;
#endif
extern u_int16 connection_handle_back;
extern u_int8 ble_passkey_req;
extern t_LE_Config LE_config;
extern u_int8 write_class_of_device[7];
//fireware release version string
char release_version[12] = "fw_v2.80";  //fireware release version string
void send_notify(u_int8 *p_data, dmp_len_t len);
//void gpio_wakeup_enable(void);
void enable_16M_clock_output(void)
{
}
void enable_32K_clock_output(void)
{
}
void disable_32K_clock_output(void)
{
}
void disable_16M_clock_output(void)
{
}
void start_500ms_window(void)
{
    sys_flag|=FLAG_TIMER_WORK;
    REG_APB_TIMER_CTRL &= ~bit_PT1_ENABLE;
    delay_us(50);
    Timer_Start(TIMER_1,50000); //50ms
    REG_AHB0_ICU_INT_ENABLE|=INT_STATUS_TIMER1;
}
void timer1_callback(void)
{
    sys_flag &= ~FLAG_TIMER_WORK;
    Timer_Stop(TIMER_1);
    REG_AHB0_ICU_INT_ENABLE&=~INT_STATUS_TIMER1;
}
//: pD -- Ҫ, len -- ֽ
//: 16 bit crc 
static u_int16 crc16 (u_int8 *pD, u_int32 len)
{
    u_int32 i,j;
    u_int8 ds;
    u_int16 crc = 0xffff;
    static u_int16 poly[2]= {0, 0xa001};
    for(j=len; j>0; j--)
    {
        ds = *pD++;
        for(i=0; i<8; i++)
        {
            crc = (crc >> 1) ^ poly[(crc ^ ds ) & 1];
            ds = ds >> 1;
        }
    }
    return crc;
}
void  updata_memset32(void * dest, uint32 value, uint8 size)
{
    uint32 *_u8_dest = (uint32 *)dest;
    uint32 *_u8_end  = (uint32 *)dest+size*4;
    while (_u8_dest < _u8_end)
    {
        *_u8_dest++ = value;
    }
}
void init_notify_variable()
{
#if(RUN_APP)
    fill_data_header=0;
    fill_data_tailor=0;
#endif
}
void fill_data_to_buff(u_int8 *p_data, u_int8 len)
{
#if(RUN_APP)
    u_int8 i;
//   DEBUG_MSG(0XFB);
    sys_flag |= FLAG_UART_TX_DATA;
    GPIO_output((WAKUP_EXTERN_MCU_PIN>>4)&0x0f, WAKUP_EXTERN_MCU_PIN&0x0f, 0); //p36,
    if(sys_flag&FLAG_WAKEUP_EXTERN_MCU)//״̬ͻ
    {
        enable_16M_clock_output();
        enable_32K_clock_output();
        delay_us(10);
        sys_flag &= ~FLAG_WAKEUP_EXTERN_MCU;
    }
#if(XGD_DEFINE)
    for(i=0; i<3; i++)
    {
        notify_buffer[fill_data_header++]=0X02;
        fill_data_header = (fill_data_header%FILL_BUFF_LEN);
    }
#endif
    for(i=0; i<len; i++)
    {
        notify_buffer[fill_data_header++]=p_data[i];
        fill_data_header = (fill_data_header%FILL_BUFF_LEN);
    }
#if(XGD_DEFINE)
    notify_buffer[fill_data_header++]=0X03;
#endif
    fill_data_header = (fill_data_header%FILL_BUFF_LEN);
#endif
}
void notify_data_callback( u_int8 * buff, u_int16 len)
{
#if(RUN_APP)
    static uint8 cmd_status=0;
    static uint8 index=0;
    while(len>0)
    {
        switch(cmd_status)
        {
        case UART_CMD_STATE_HEAD_ONE:
        {
            if(buff[0]==0x02)
            {
                cmd_status=UART_CMD_STATE_HEAD_TWO;
                index=0;
                notify_data[index++]=buff[0];
            }
            else
            {
                cmd_status=UART_CMD_STATE_HEAD_ONE;
            }
        }
        break;
        case UART_CMD_STATE_HEAD_TWO:
        {
            if(buff[0]==0x02)
            {
                cmd_status=UART_CMD_STATE_HEAD_THREE;
                notify_data[index++]=buff[0];
            }
            else
            {
                cmd_status=UART_CMD_STATE_HEAD_ONE;
            }
        }
        break;
        case UART_CMD_STATE_HEAD_THREE:
        {
            if(buff[0]==0x02)
            {
                cmd_status=UART_CMD_STATE_HEAD_FOUR;
                notify_data[index++]=buff[0];
            }
            else
            {
                cmd_status=UART_CMD_STATE_HEAD_ONE;
            }
        }
        break;
        case UART_CMD_STATE_HEAD_FOUR:
        {
            if(buff[0]==0x04)
            {
                cmd_status=UART_CMD_STATE_OPCODE;
                notify_data[index++]=buff[0];
            }
            else
            {
                cmd_status=UART_CMD_STATE_HEAD_ONE;
            }
        }
        break;
        case UART_CMD_STATE_OPCODE:
        {
            notify_data[index++]=buff[0];
            cmd_status=UART_CMD_STATE_LENGTH;
        }
        break;
        case UART_CMD_STATE_LENGTH:
        {
            notify_data[index++]=buff[0];
            if(index==notify_data[5]+9)//3==2bytes crc+1bytesβ
            {
                if(buff[0]==0x03)
                {
                    cmd_status=UART_CMD_STATE_HEAD_ONE;
                    uart_send_length=index;
                    send_notify(notify_data,uart_send_length);
                    if(sys_flag & FLAG_ENTER_DEEPSLEEP)
                    {
                        sys_flag &= ~FLAG_ENTER_DEEPSLEEP;
                        delay_ms(10);
                        enter_deep_sleep( );
                    }
                    else if(sys_flag & FLAG_ENTER_LOW_POWER)
                    {
                        sys_flag &= ~FLAG_ENTER_LOW_POWER;
                        disable_16M_clock_output();
                        disable_32K_clock_output();
                    }
                    if(sys_flag & FLAG_SET_UART_BAUDRATE)
                    {
                        delay_ms(5);
                        REG_APB3_UART_CFG = uart_conf_value;
                        sys_flag &= ~FLAG_SET_UART_BAUDRATE;
                    }
                }
            }
        }
        break;
        }
        len--;
        buff++;
    }
#endif
}
void notify_data_to_mcu(void)
{
#if(RUN_APP)
    static u_int16 fill_buff_temp;
    if(uart_flow_control)
    {
        if(0==gpio_input(((UART_EN>>4)&0x0F),(UART_EN&0x0F)))
        {
            fill_buff_temp=fill_data_header;
            if (fill_data_tailor < fill_buff_temp)
            {
                notify_data_callback(notify_buffer + fill_data_tailor, fill_buff_temp - fill_data_tailor);
                fill_data_tailor = fill_buff_temp;
            }
            else if (fill_data_tailor > fill_buff_temp)
            {
                notify_data_callback(notify_buffer + fill_data_tailor, sizeof(notify_buffer) - fill_data_tailor);
                notify_data_callback(notify_buffer, fill_buff_temp);
                fill_data_tailor = fill_buff_temp;
            }
        }
    }
    else
    {
        fill_buff_temp=fill_data_header;
        if (fill_data_tailor < fill_buff_temp)
        {
            notify_data_callback(notify_buffer + fill_data_tailor, fill_buff_temp - fill_data_tailor);
            fill_data_tailor = fill_buff_temp;
        }
        else if (fill_data_tailor > fill_buff_temp)
        {
            notify_data_callback(notify_buffer + fill_data_tailor, sizeof(notify_buffer) - fill_data_tailor);
            notify_data_callback(notify_buffer, fill_buff_temp);
            fill_data_tailor = fill_buff_temp;
        }
    }
#endif
}
//ģ鷢ݸⲿMCUĵײӿ
void send_notify(u_int8 *p_data, dmp_len_t len)
{
#if(RUN_APP)
    start_500ms_window();
    uart_data_send(p_data, len);
#endif
}
//һЭ
//: p_buff -- buffer, pack -- ɰԪ
dmp_len_t ganerate_package(u_int8 *p_buff, DMP_package_t pack)
{
#if(RUN_APP)
    dmp_len_t package_len = 0;
    u_int16 crc = 0;
    memset(p_buff,0,pack.data_len+sizeof(u_int16)); //package len + crc len
    p_buff[DMP_CMD_TYPE_OFFSET] = pack.cmd_type;
    p_buff[DMP_CMD_ID_OFFSET] = pack.cmd_id;
    p_buff[DMP_CMD_LEN_OFFSET] = pack.data_len-DMP_HEADER_LENGTH;
    package_len = DMP_HEADER_LENGTH;
    if((pack.data_len-DMP_HEADER_LENGTH)!=0)
    {
        memcpy(&p_buff[DMP_CMD_DATA_OFFSET],pack.content,pack.data_len-DMP_HEADER_LENGTH);
        package_len = pack.data_len;
    }
    crc = crc16(p_buff,pack.data_len);
    p_buff[pack.data_len] = (u_int8)(crc&0xFF);
    p_buff[pack.data_len+1] = (u_int8)((crc>>8)&0xFF);
    package_len += 2;
    return package_len;
#endif
}
//ģ鷵ִн
//: result -- ؽ, err_code -- Ĵ
void send_notify_device_ready(u_int8 status)
{
#if(RUN_APP)
    u_int8 data[1] = {0};
    DMP_package_t pack = {DMP_TYPE_NOTIFY,NOTIFY_DEVICE_READY,4,NULL};
    dmp_len_t len = 0;
    data[0] = status;
    pack.content = &data[0];
    len = ganerate_package(&dmp_tx_buffer[0],pack);
    fill_data_to_buff(&dmp_tx_buffer[0],len);
#endif
}
//ģ鷵طSPPִн
//: result -- ؽ, err_code -- Ĵ
void notify_spp_send_result(u_int8 result, u_int8 err_code)
{
#if(RUN_APP)
    u_int8 data[2] = {0};
    DMP_package_t pack = {DMP_TYPE_NOTIFY,NOTIFY_SPP_SEND_RESULT,5,NULL};
    dmp_len_t len = 0;
    data[0] = result;
    data[1] = err_code;
    pack.content = &data[0];
    len = ganerate_package(&dmp_tx_buffer[0],pack);
    fill_data_to_buff(&dmp_tx_buffer[0],len);
#endif
}
//ģ鷵طBLEִн
//: result -- ؽ, err_code -- Ĵ
void notify_ble_send_result(u_int8 result, u_int8 err_code)
{
#if(RUN_APP)
    u_int8 data[2] = {0};
    DMP_package_t pack = {DMP_TYPE_NOTIFY,NOTIFY_BLE_SEND_RESULT,5,NULL};
    dmp_len_t len = 0;
    data[0] = result;
    data[1] = err_code;
    pack.content = &data[0];
    len = ganerate_package(&dmp_tx_buffer[0],pack);
    fill_data_to_buff(&dmp_tx_buffer[0],len);
#endif
}
void notify_status(u_int8 emEvent)
{
#if(RUN_APP)
    u_int8 data[1] = {0};
    DMP_package_t pack = {DMP_TYPE_NOTIFY,NOTIFY_STATUS,4,NULL};
    dmp_len_t len = 0;
    bprintf("nofify sta:%d\n",emEvent);
    data[0] = emEvent;
    pack.content = &data[0];
    len = ganerate_package(&dmp_tx_buffer[0],pack);
    fill_data_to_buff(&dmp_tx_buffer[0],len);
#endif
}
static void cmd_response(u_int8 result, u_int8 err_code)
{
#if(RUN_APP)
    u_int8 data[2] = {0};
    DMP_package_t pack = {DMP_TYPE_NOTIFY,NOTIFY_OPERATION_RESULT,5,NULL};
    dmp_len_t len = 0;
    data[0] = result;
    data[1] = err_code;
    pack.content = &data[0];
    len = ganerate_package(&dmp_tx_buffer[0],pack);
    fill_data_to_buff(&dmp_tx_buffer[0],len);
#endif
}
//ģ鷵3.0״̬
static void send_bt_status(u_int8 status)
{
#if(RUN_APP)
    u_int8 data[1] = {0};
    DMP_package_t pack = {DMP_TYPE_NOTIFY,NOTIFY_BT_CONN_STATUS,4,NULL};
    dmp_len_t len = 0;
    data[0] = status;
    pack.content = &data[0];
    len = ganerate_package(&dmp_tx_buffer[0],pack);
    fill_data_to_buff(&dmp_tx_buffer[0],len);
#endif
}
//ģ鷵BLE״̬
static void send_ble_status(u_int8 status)
{
#if(RUN_APP)
    u_int8 data[1] = {0};
    DMP_package_t pack = {DMP_TYPE_NOTIFY,NOTIFY_BLE_CONN_STATUS,4,NULL};
    dmp_len_t len = 0;
    data[0] = status;
    pack.content = &data[0];
    len = ganerate_package(&dmp_tx_buffer[0],pack);
    fill_data_to_buff(&dmp_tx_buffer[0],len);
#endif
}
//
void send_notify_passkey_request(void)
{
#if(RUN_APP)
    //u_int8 data[1] = {0};
    DMP_package_t pack = {DMP_TYPE_NOTIFY,NOTIFY_PASSKEY_REQUEST,3,NULL};
    dmp_len_t len = 0;
    len = ganerate_package(&dmp_tx_buffer[0],pack);
    fill_data_to_buff(&dmp_tx_buffer[0],len);
#endif
}
//ȷ
void send_notify_confirm_request(u_int8 *passkey,u_int8 dataLen)
{
#if(RUN_APP)
    DMP_package_t pack = {DMP_TYPE_NOTIFY,NOTIFY_CONFIRM_REQUEST,9,NULL};
    dmp_len_t len = 0;
    pack.data_len = DMP_HEADER_LENGTH+dataLen;
    pack.content = passkey;
    len = ganerate_package(&dmp_tx_buffer[0],pack);
    fill_data_to_buff(&dmp_tx_buffer[0],len);
#endif
}
//ģ鷵3.0Ͽִָгɹ
void notify_bt_disconnect(void)
{
#if(RUN_APP)
    DMP_package_t pack = {DMP_TYPE_NOTIFY,NOTIFY_BT_DISCONNECTED,3,NULL};
    dmp_len_t len = 0;
    len = ganerate_package(&dmp_tx_buffer[0],pack);
    fill_data_to_buff(&dmp_tx_buffer[0],len);
#endif
}
//ģ鷵BLEϿִָгɹ
void notify_ble_disconnect(void)
{
#if(RUN_APP)
    DMP_package_t pack = {DMP_TYPE_NOTIFY,NOTIFY_BLE_DISCONNECTED,3,NULL};
    dmp_len_t len = 0;
    len = ganerate_package(&dmp_tx_buffer[0],pack);
    fill_data_to_buff(&dmp_tx_buffer[0],len);
#endif
}
//ģϴ̼汾
void notify_release_version(void)
{
#if(RUN_APP)
    DMP_package_t pack = {DMP_TYPE_NOTIFY,NOTIFY_RELEASE_VERSION,0,(u_int8 *)release_version};
    dmp_len_t len = 0;
    pack.data_len = strlen(release_version)+3;
    len = ganerate_package(&dmp_tx_buffer[0],pack);
    fill_data_to_buff(&dmp_tx_buffer[0],len);
#endif
}
//ģ鷵BT3.0豸
void notify_bt_dev_name(void)
{
#if(RUN_APP)
    SET_SYS_PARA_P set_sys_para=(SET_SYS_PARA_P)set_sys_buff;
    DMP_package_t pack = {DMP_TYPE_NOTIFY,NOTIFY_BT_NAME,0,NULL};
    dmp_len_t len = 0;
    pack.data_len = DMP_HEADER_LENGTH+set_sys_para->classic_bt_name_len;
    pack.content = set_sys_para->classic_bt_name;
    len = ganerate_package(&dmp_tx_buffer[0],pack);
    fill_data_to_buff(&dmp_tx_buffer[0],len);
#endif
}
//ģ鷵BLE豸
void notify_ble_dev_name(void)
{
#if(RUN_APP)
    SET_SYS_PARA_P set_sys_para=(SET_SYS_PARA_P)set_sys_buff;
    DMP_package_t pack = {DMP_TYPE_NOTIFY,NOTIFY_BLE_NAME,0,NULL};
    dmp_len_t len = 0;
    pack.data_len = DMP_HEADER_LENGTH+set_sys_para->ble_bt_name_len;
    pack.content = set_sys_para->ble_bt_name;
    len = ganerate_package(&dmp_tx_buffer[0],pack);
    fill_data_to_buff(&dmp_tx_buffer[0],len);
#endif
}
//ģ鷵BT3.0MACַ
void notify_bt_mac_addr(void)
{
#if(RUN_APP)
    //SET_SYS_PARA_P set_sys_para=(SET_SYS_PARA_P)set_sys_buff;
    DMP_package_t pack = {DMP_TYPE_NOTIFY,NOTIFY_BT_MAC_ADDR,9,NULL};
    dmp_len_t len = 0;
    pack.data_len = DMP_HEADER_LENGTH+6;
    pack.content = bd_addr;//g_sys_config.local_device_address.bytes;
    len = ganerate_package(&dmp_tx_buffer[0],pack);
    fill_data_to_buff(&dmp_tx_buffer[0],len);
#endif
}
//ģ鷵BLEMACַ
void notify_ble_mac_addr(void)
{
#if(RUN_APP)
//    SET_SYS_PARA_P set_sys_para=(SET_SYS_PARA_P)set_sys_buff;
    DMP_package_t pack = {DMP_TYPE_NOTIFY,NOTIFY_BLE_MAC_ADDR,9,NULL};
    dmp_len_t len = 0;
    pack.data_len = DMP_HEADER_LENGTH+6;
    pack.content = bd_addr;//g_sys_config.local_device_address.bytes;
    len = ganerate_package(&dmp_tx_buffer[0],pack);
    fill_data_to_buff(&dmp_tx_buffer[0],len);
#endif
}
//ģ鷵3.0ģʽ
void notify_bt_pair_mode(void)
{
#if(RUN_APP)
    SET_SYS_PARA_P set_sys_para=(SET_SYS_PARA_P)set_sys_buff;
    DMP_package_t pack = {DMP_TYPE_NOTIFY,NOTIFY_BT_PAIR_MODE,DMP_HEADER_LENGTH+1,NULL};
    u_int8 content[1];
    dmp_len_t len = 0;
    content[0] = set_sys_para->classic_bt_pair_mode;
    pack.content = content;
    len = ganerate_package(&dmp_tx_buffer[0],pack);
    fill_data_to_buff(&dmp_tx_buffer[0],len);
#endif
}
//ģ鷵BLEģʽ
void notify_ble_pair_mode(void)
{
#if(RUN_APP)
    SET_SYS_PARA_P set_sys_para=(SET_SYS_PARA_P)set_sys_buff;
    DMP_package_t pack = {DMP_TYPE_NOTIFY,NOTIFY_BLE_PAIR_MODE,DMP_HEADER_LENGTH+1,NULL};
    u_int8 content[1];
    dmp_len_t len = 0;
    content[0] = set_sys_para->ble_pair_mode;
    pack.content = content;
    len = ganerate_package(&dmp_tx_buffer[0],pack);
    fill_data_to_buff(&dmp_tx_buffer[0],len);
#endif
}
//ģ鷵3.0 PINCODE
void notify_bt_pin_code(void)
{
#if(RUN_APP)
    SET_SYS_PARA_P set_sys_para=(SET_SYS_PARA_P)set_sys_buff;
    DMP_package_t pack = {DMP_TYPE_NOTIFY,NOTIFY_BT_PIN_CODE,0,NULL};
    u_int8 content[6];
    dmp_len_t len = 0;
    memcpy(content,set_sys_para->classic_bt_pair_pincode,set_sys_para->classic_bt_pair_pincode_len);
    pack.content = content;
    pack.data_len = DMP_HEADER_LENGTH+set_sys_para->classic_bt_pair_pincode_len;
    len = ganerate_package(&dmp_tx_buffer[0],pack);
    fill_data_to_buff(&dmp_tx_buffer[0],len);
#endif
}
//ģ鷵BLE PINCODE
void notify_ble_pin_code(void)
{
#if(RUN_APP)
    SET_SYS_PARA_P set_sys_para=(SET_SYS_PARA_P)set_sys_buff;
    DMP_package_t pack = {DMP_TYPE_NOTIFY,NOTIFY_BLE_PIN_CODE,0,NULL};
    u_int8 content[6];
    dmp_len_t len = 0;
    memcpy(content,set_sys_para->ble_pair_pincode,set_sys_para->ble_pair_pincode_len);
    pack.content = content;
    pack.data_len = DMP_HEADER_LENGTH+set_sys_para->ble_pair_pincode_len;
    len = ganerate_package(&dmp_tx_buffer[0],pack);
    fill_data_to_buff(&dmp_tx_buffer[0],len);
#endif
}
//ģ鷵SPPյݵMCUҪģⲿ
void notify_spp_received(u_int8 *data, dmp_len_t dataLen)
{
#if(RUN_APP)
    DMP_package_t pack = {DMP_TYPE_NOTIFY,NOTIFY_SPP_RECEIVED_DATA,0,NULL};
    dmp_len_t len = 0;
    pack.data_len = DMP_HEADER_LENGTH+dataLen;
    pack.content = data;
    len = ganerate_package(&dmp_tx_buffer[0],pack);
    fill_data_to_buff(&dmp_tx_buffer[0],len);
#endif
}
//ģ鷵BLE͸յݵMCUҪģⲿ
void notify_ble_received(u_int8 *data, dmp_len_t dataLen)
{
#if(RUN_APP)
    DMP_package_t pack = {DMP_TYPE_NOTIFY,NOTIFY_BLE_RECEIVED_DATA,0,NULL};
    dmp_len_t len = 0;
    pack.data_len = DMP_HEADER_LENGTH+dataLen;
    pack.content = data;
    len = ganerate_package(&dmp_tx_buffer[0],pack);
    fill_data_to_buff(&dmp_tx_buffer[0],len);
#endif
}
//ģ鷵Ƿ͹ģʽɹ
void notify_enter_lowpwr(u_int8 status)
{
#if(RUN_APP)
    u_int8 data[1] = {0};
    DMP_package_t pack = {DMP_TYPE_NOTIFY,NOTIFY_ENTER_LOWPWR_RESULT,4,NULL};
    dmp_len_t len = 0;
    data[0] = status;
    pack.content = &data[0];
    len = ganerate_package(&dmp_tx_buffer[0],pack);
    fill_data_to_buff(&dmp_tx_buffer[0],len);
#endif
}
void notify_input_gpio_status(u_int8 status)
{
#if(RUN_APP)
    u_int8 data[1] = {0};
    DMP_package_t pack = {DMP_TYPE_NOTIFY,NOTIFY_GPIO_STATUS,4,NULL};
    dmp_len_t len = 0;
    data[0] = status;
    pack.content = &data[0];
    len = ganerate_package(&dmp_tx_buffer[0],pack);
    fill_data_to_buff(&dmp_tx_buffer[0],len);
#endif
}
void notify_voltage(void)
{
#if(RUN_APP)
    DMP_package_t pack = {DMP_TYPE_NOTIFY,NOTIFY_VOLTAGE,4,NULL};
    dmp_len_t len = 0;
    pack.content = &adc_value;
    len = ganerate_package(&dmp_tx_buffer[0],pack);
    fill_data_to_buff(&dmp_tx_buffer[0],len);
#endif
}
void platform_reset()
{
    void (*pReset)(void);
    // Disable interrupts
    REG_AHB0_ICU_IRQ_ENABLE=0;
    pReset = (void * )(0x0);
    pReset();
}
//ģյ
//: data -- , len -- ĳ
void dmp_cmd_dispath(u_int8 *p_data, dmp_len_t len)
{
#if(RUN_APP)
    SET_SYS_PARA_P set_sys_para=(SET_SYS_PARA_P)set_sys_buff;
    u_int16 crc = (u_int16)((p_data[len-1]<<8)|(p_data[len-2]));
    u_int8 err_code = 0;
    u_int8 i;
    u_int32 passkey=0;
    //check crc
    if(crc16(p_data, len-sizeof(u_int16)/*crc len*/) != crc)
    {
        //err_code = CRC_FAILDED;
    }
    //check cmd type
    if(p_data[DMP_CMD_TYPE_OFFSET]!=DMP_TYPE_CMD)
    {
        err_code = UNRECOGNIZED_COMMAND;
    }
    if(err_code == 0)
    {
        //check package total length
        if(p_data[DMP_CMD_LEN_OFFSET] != (len-DMP_HEADER_LENGTH-sizeof(u_int16)/*crc len*/))
        {
            err_code = INVALID_DATA_LENGTH;
        }
        else
        {
            /* package content handle */
            dmp_len_t pack_content_len = p_data[DMP_CMD_LEN_OFFSET];
            u_int8 *pack_content = &p_data[DMP_CMD_DATA_OFFSET];
            switch(p_data[DMP_CMD_ID_OFFSET])
            {
            case CMD_SET_BT_NAME:
                if((pack_content_len>=1)&&(pack_content_len<=32))
                {
                    //3.0ƽӿ
                    bprintf("CMD_SET_BT_NAME\r\n");
                    REG_AHB0_ICU_IRQ_ENABLE=0;
                    flash_erase_sector(FLASH_SPACE_TYPE_NVR,0x8000);
                    memset(set_sys_para->classic_bt_name,0,32);
                    memcpy(set_sys_para->classic_bt_name,pack_content,pack_content_len);
                    set_sys_para->classic_bt_name_len=pack_content_len;
                    flash_write(FLASH_SPACE_TYPE_NVR,0x8000, sizeof(SET_SYS_PARA_T),set_sys_buff);
                    REG_AHB0_ICU_IRQ_ENABLE=INT_IRQ_BIT|FIQ_IRQ_BIT;
                }
                else
                {
                    err_code = INVALID_DATA_LENGTH;
                }
                break;
            case CMD_SET_BLE_NAME:
                if((pack_content_len>=1)&&(pack_content_len<=20))
                {
                    //bleƽӿ
                    bprintf("CMD_SET_BLE_NAME\r\n");
                    REG_AHB0_ICU_IRQ_ENABLE=0;
                    flash_erase_sector(FLASH_SPACE_TYPE_NVR,0x8000);
                    memset(set_sys_para->ble_bt_name,0,20);
                    memcpy(set_sys_para->ble_bt_name,pack_content,pack_content_len);
                    set_sys_para->ble_bt_name_len=pack_content_len;
                    flash_write(FLASH_SPACE_TYPE_NVR,0x8000, sizeof(SET_SYS_PARA_T),set_sys_buff);
                    REG_AHB0_ICU_IRQ_ENABLE=INT_IRQ_BIT|FIQ_IRQ_BIT;
                }
                else
                {
                    err_code = INVALID_DATA_LENGTH;
                }
                break;
            case CMD_SET_PAIR_MODE:
                if(pack_content_len==2)
                {
                    if(pack_content[0]==0x00&&pack_content[1]<4)
                    {
                        //ģʽӿ
                        bprintf("CMD_SET_CLASSIC_PAIR_MODE\r\n");
                        REG_AHB0_ICU_IRQ_ENABLE=0;
                        flash_erase_sector(FLASH_SPACE_TYPE_NVR,0x8000);
                        set_sys_para->classic_bt_pair_mode=pack_content[1];
                        flash_write(FLASH_SPACE_TYPE_NVR,0x8000, sizeof(SET_SYS_PARA_T),set_sys_buff);
                        REG_AHB0_ICU_IRQ_ENABLE=INT_IRQ_BIT|FIQ_IRQ_BIT;
                    }
                    else if(pack_content[0]==0x01&&(pack_content[1]<3||pack_content[1]==4)) //not support "confirm mode"
                    {
                        //ģʽӿ
                        bprintf("CMD_SET_BLE_PAIR_MODE\r\n");
                        REG_AHB0_ICU_IRQ_ENABLE=0;
                        flash_erase_sector(FLASH_SPACE_TYPE_NVR,0x8000);
                        // set_sys_para->ble_pair_mode=pack_content[1];
                        flash_write(FLASH_SPACE_TYPE_NVR,0x8000, sizeof(SET_SYS_PARA_T),set_sys_buff);
                        REG_AHB0_ICU_IRQ_ENABLE=INT_IRQ_BIT|FIQ_IRQ_BIT;
                    }
                    else
                    {
                        err_code = INCRRECT_DATA;
                    }
                }
                else
                {
                    err_code = INVALID_DATA_LENGTH;
                }
                break;
            case CMD_INPUT_PASSKEY:
                for(i=0; i<6; i++)
                {
                    passkey = passkey*10 + pack_content[i] - '0';
                }
                if(passkey_req)
                {
                    bprintf("CMD_INPUT_PASSKEY\r\n");
                    passkey_req=0;
                    DeviceHci_PassKeyReply(bt_adapter, pair_device_addr, passkey);
                }
                else if(ble_passkey_req==2)
                {
                    ble_passkey_req=0;
                    LEsmp_Passkey_Entry(connection_handle_back,passkey);
                }
                break;
            case CMD_ADV_ONOFF:
                if(pack_content_len==1)
                {
                    bprintf("pack_content[0]=%x\r\n",pack_content[0]);
                    if(pack_content[0]==1 )
                    {
                        sys_flag &= ~FLAG_UART_INTERRPUT;
                        REG_AHB0_ICU_IRQ_ENABLE=0;
                        REG_AHB0_ICU_CEVA_CLKCON=0x02;
                        delay_ms(5);
                        SYSconfig_Initialise();
                        bprintf("x1\r\n");
                        BT_Initialise();
                        REG_AHB0_ICU_IRQ_ENABLE=INT_IRQ_BIT|FIQ_IRQ_BIT;;
                        SYS_Host_Initialise();
                        bt_default_open=1;
                        sys_flag|=FLAG_BT_ENABLE;
                        cmd_response(RESULT_SUCCESS,0x00);
                        return;
                    }
                    else if(pack_content[0]==0)
                    {
                        if(bt_default_open)
                        {
                            //ùر
                            bt_default_open=0;
                            sys_flag&=~FLAG_BT_ENABLE;
                            cmd_response(RESULT_SUCCESS,0x00);
                            return;
                        }
                        else
                        {
                            cmd_response(RESULT_SUCCESS,0x00);
                            return;
                        }
                    }
                    else if(pack_content[0]==2)
                    {
                        if(bt_default_open)
                        {
                            //bt3.0 in page
                            //GAP_Discoverable_Mode(GAP_NON_DISCOVERABLE,ADV_IND);
                            cmd_response(RESULT_SUCCESS,0x00);
                            sys_flag |= FLAG_BT_SET_PAGE;
                            return;
                        }
                        else
                        {
                            err_code = NO_PERMISION;
                        }
                    }
                    else
                    {
                        err_code = INCRRECT_DATA;
                    }
                }
                else
                {
                    err_code = INVALID_DATA_LENGTH;
                }
                break;
            case CMD_SET_CLASSIC_BT_PINCODE:
                if((pack_content_len==4)||(pack_content_len==6))
                {
                    u_int8 i;
                    for(i=0; i<pack_content_len; i++)
                    {
                        if((pack_content[i]<0x30)||(pack_content[i]>0x39))
                        {
                            err_code = INCRRECT_DATA;
                            break;
                        }
                    }
                    if(err_code == 0)   //num 0~9
                    {
                        //PIN CODEӿ
                        bprintf("CMD_SET_PINCODE\r\n");
                        REG_AHB0_ICU_IRQ_ENABLE=0;
                        flash_erase_sector(FLASH_SPACE_TYPE_NVR,0x8000);
                        memset(set_sys_para->classic_bt_pair_pincode,0,sizeof(set_sys_para->classic_bt_pair_pincode));
                        memcpy(set_sys_para->classic_bt_pair_pincode,pack_content,pack_content_len);
                        set_sys_para->classic_bt_pair_pincode_len=pack_content_len;
                        flash_write(FLASH_SPACE_TYPE_NVR,0x8000, sizeof(SET_SYS_PARA_T),set_sys_buff);
                        REG_AHB0_ICU_IRQ_ENABLE=INT_IRQ_BIT|FIQ_IRQ_BIT;
                    }
                }
                else
                {
                    err_code = INVALID_DATA_LENGTH;
                }
                break;
            case CMD_SET_BLE_PINCODE:
                if(pack_content_len==6)
                {
                    u_int8 i;
                    for(i=0; i<pack_content_len; i++)
                    {
                        if((pack_content[i]<0x30)||(pack_content[i]>0x39))
                        {
                            err_code = INCRRECT_DATA;
                            break;
                        }
                    }
                    if(err_code == 0)   //num 0~9
                    {
                        bprintf("CMD_SET_PINCODE\r\n");
                        REG_AHB0_ICU_IRQ_ENABLE=0;
                        flash_erase_sector(FLASH_SPACE_TYPE_NVR,0x8000);
                        memset(set_sys_para->ble_pair_pincode,0,sizeof(set_sys_para->ble_pair_pincode));
                        memcpy(set_sys_para->ble_pair_pincode,pack_content,pack_content_len);
                        set_sys_para->ble_pair_pincode_len=pack_content_len;
                        flash_write(FLASH_SPACE_TYPE_NVR,0x8000, sizeof(SET_SYS_PARA_T),set_sys_buff);
                        REG_AHB0_ICU_IRQ_ENABLE=INT_IRQ_BIT|FIQ_IRQ_BIT;
                    }
                }
                else
                {
                    err_code = INVALID_DATA_LENGTH;
                }
                break;
            case CMD_SET_GPIO:
                if(pack_content_len==2)
                {
                    if(pack_content[1]==1)
                    {
                        GPIO_config((pack_content[0]>>4),(pack_content[0]&0x0f),1,1);
                    }
                    else if(pack_content[1]==0)
                    {
                        //GPIOӿ
                        GPIO_config((pack_content[0]>>4),(pack_content[0]&0x0f),1,0);
                    }
                    else
                    {
                        err_code = INCRRECT_DATA;
                    }
                }
                else
                {
                    err_code = INVALID_DATA_LENGTH;
                }
                break;
            case CMD_BT_REQUEST_STATUS:
                if(pack_content_len==0)
                {
                    u_int8 status = 0;
                    //ûȡ״̬ӿ
                    if(sys_flag&FLAG_CONNECTED)
                    {
                        status=1;
                    }
                    send_bt_status(status);
                    return;
                }
                else
                {
                    err_code = INVALID_DATA_LENGTH;
                }
                break;
            case CMD_BLE_REQUEST_STATUS:
                if(pack_content_len==0)
                {
                    u_int8 status = 0;
                    //ûȡBLE״̬ӿ
                    if(sys_flag&FLAG_BLE_CONNECTED)
                    {
                        status=1;
                    }
                    send_ble_status(status);
                    return;
                }
                else
                {
                    err_code = INVALID_DATA_LENGTH;
                }
                break;
            case CMD_SEND_SPP_DATA:
                if((pack_content_len>=1)&&(pack_content_len<=DMP_SPP_MAX_DATALEN))
                {
                    //ӷ3.0ݽӿ
                    if(0==spp_data_send(pack_content,pack_content_len))
                    {
                        err_code = REQUEST_FAILD;
                    }
                    if(err_code != 0)
                    {
                        notify_spp_send_result(0,err_code);
                    }
                    else
                    {
                        notify_spp_send_result(1,err_code);
                    }
                    return;
                }
                else
                {
                    err_code = INVALID_DATA_LENGTH;
                }
                break;
            case CMD_SEND_BLE_DATA:
                if((pack_content_len>=1)&&(pack_content_len<=DMP_BLE_MAX_DATALEN))
                {
                    if(!(sys_flag&FLAG_BLE_CONNECTED))
                    {
                        err_code = BT_NO_CONNECT;
                    }
                    else if(ble_data_cnt>=MAX_BUF_ROW)
                    {
                        err_code = QUEUE_FULL;
                    }
                    if(err_code != 0)
                    {
                        notify_ble_send_result(0,err_code);
                    }
                    else
                    {
                        ble_data_len[ble_data_write]=pack_content_len;
                        memcpy( &ble_data_buff[ble_data_write][0],pack_content,pack_content_len);
                        ble_data_write++;
                        ble_data_write = ble_data_write%MAX_BUF_ROW;
                        ble_data_cnt++;
                        notify_ble_send_result(1,err_code);
                    }
                    return;
                }
                else
                {
                    err_code = INVALID_DATA_LENGTH;
                }
                break;
            case CMD_BT_DISCONN:
                if(pack_content_len==0)
                {
                    //ӶϿ3.0ӿ
                    if(sys_flag&FLAG_CONNECTED)
                    {
                        DeviceHci_Disconnect(&btj_adapter, btj_adapter.hci_context->hci_context_handle, HCI_ERR_OETC_POWERING_OFF);
                    }
                    notify_bt_disconnect();
                    return;
                }
                else
                {
                    err_code = INVALID_DATA_LENGTH;
                }
                break;
            case CMD_BLE_DISCONN:
                if(pack_content_len==0)
                {
                    //ӶϿBLEӿ
                    sys_flag|=FLAG_BLE_GAP_DISCONNECT;
                    notify_ble_disconnect();
                    return;
                }
                else
                {
                    err_code = INVALID_DATA_LENGTH;
                }
                break;
            case CMD_DEEP_SLEEP:
                if(pack_content_len==0)
                {
                    sys_flag |= FLAG_ENTER_DEEPSLEEP;
                    cmd_response(RESULT_SUCCESS,0x00);
                }
                else
                {
                    err_code = INVALID_DATA_LENGTH;
                }
                break;
            case CMD_REQUEST_VERSION:
                if(pack_content_len==0)
                {
                    notify_release_version();
                    return;
                }
                else
                {
                    err_code = INVALID_DATA_LENGTH;
                }
                break;
            case CMD_REQUEST_BT_NAME:
                notify_bt_dev_name();
                return;
            case CMD_REQUEST_BLE_NAME:
                notify_ble_dev_name();
                return;
            case CMD_REQUEST_BT_MAC_ADDR:
                notify_bt_mac_addr();
                return;
            case CMD_REQUEST_BLE_MAC_ADDR:
                notify_ble_mac_addr();
                return;
            case CMD_REQUEST_BT_PAIR_MODE:
                notify_bt_pair_mode();
                return;
            case CMD_REQUEST_BLE_PAIR_MODE:
                notify_ble_pair_mode();
                return;
            case CMD_REQUEST_BT_PIN_CODE:
                notify_bt_pin_code();
                return;
            case CMD_REQUEST_BLE_PIN_CODE:
                notify_ble_pin_code();
                return;
            case CMD_SET_UUID_SERVICE:
                if(pack_content_len==16)
                {
                    bprintf("CMD_SET_UUID_SERVICE\r\n");
                    REG_AHB0_ICU_IRQ_ENABLE=0;
                    flash_erase_sector(FLASH_SPACE_TYPE_NVR,0x8000);
                    memcpy(set_sys_para->service_uuid,pack_content,pack_content_len);
                    flash_write(FLASH_SPACE_TYPE_NVR,0x8000, sizeof(SET_SYS_PARA_T),set_sys_buff);
                    REG_AHB0_ICU_IRQ_ENABLE=INT_IRQ_BIT|FIQ_IRQ_BIT;
                }
                else
                {
                    err_code = INVALID_DATA_LENGTH;
                }
                break;
            case CMD_SET_UUID_NOTIFY:
                if(pack_content_len==16)
                {
                    bprintf("CMD_SET_UUID_NOTIFY\r\n");
                    REG_AHB0_ICU_IRQ_ENABLE=0;
                    flash_erase_sector(FLASH_SPACE_TYPE_NVR,0x8000);
                    memcpy(set_sys_para->characteristic_notify_uuid,pack_content,pack_content_len);
                    flash_write(FLASH_SPACE_TYPE_NVR,0x8000, sizeof(SET_SYS_PARA_T),set_sys_buff);
                    REG_AHB0_ICU_IRQ_ENABLE=INT_IRQ_BIT|FIQ_IRQ_BIT;
                }
                else
                {
                    err_code = INVALID_DATA_LENGTH;
                }
                break;
            case CMD_SET_UUID_WRITE:
                if(pack_content_len==16)
                {
                    bprintf("CMD_SET_UUID_WRITE\r\n");
                    REG_AHB0_ICU_IRQ_ENABLE=0;
                    flash_erase_sector(FLASH_SPACE_TYPE_NVR,0x8000);
                    memcpy(set_sys_para->characteristic_write_uuid,pack_content,pack_content_len);
                    flash_write(FLASH_SPACE_TYPE_NVR,0x8000, sizeof(SET_SYS_PARA_T),set_sys_buff);
                    REG_AHB0_ICU_IRQ_ENABLE=INT_IRQ_BIT|FIQ_IRQ_BIT;
                }
                else
                {
                    err_code = INVALID_DATA_LENGTH;
                }
                break;
            case CMD_RESET_BT:
                sys_flag &= ~FLAG_UART_INTERRPUT;
                bprintf("CMD_RESET_BT\r\n");
                REG_AHB0_ICU_IRQ_ENABLE=0;
                REG_AHB0_ICU_CEVA_CLKCON=0x02;
                delay_ms(5);
                SYSconfig_Initialise();
                bprintf("x2\r\n");
                BT_Initialise();
                REG_AHB0_ICU_IRQ_ENABLE=INT_IRQ_BIT|FIQ_IRQ_BIT;;
                SYS_Host_Initialise();
                cmd_response(RESULT_SUCCESS,0x00);
                bt_default_open=1;
                sys_flag|=FLAG_BT_ENABLE;
                return;
            case CMD_INQURIY_DEVICE_STATUS:
                if(sys_flag&FLAG_POWER_ON)
                {
                    send_notify_device_ready(0x01);
                }
                else
                {
                    send_notify_device_ready(0x00);
                }
                return;
            case CMD_PASSKEY_CONFIRM:
                if(confirm_req)
                {
                    if(pack_content_len==1)
                    {
                        bprintf("CMD_PASSKEY_CONFIRM=%x\r\n",pack_content[0]);
                        if(pack_content[0]==1)
                        {
                            confirm_req=0;
                            DeviceHci_UserConfirmationReply(bt_adapter, pair_device_addr);
                        }
                        else if(pack_content[0]==0)
                        {
                            DeviceHci_UserConfirmationNegativeReply(bt_adapter, pair_device_addr);
                            confirm_req=0;
                        }
                        else
                        {
                            err_code = INCRRECT_DATA;
                        }
                    }
                    else
                    {
                        err_code = INVALID_DATA_LENGTH;
                    }
                }
                break;
            case CMD_REQUEST_ENTER_LOWPWR:
                if(pack_content_len==0)
                {
                    if(sys_flag&FLAG_TIMER_WORK)
                    {
                        notify_enter_lowpwr(0);
                    }
                    else
                    {
                        notify_enter_lowpwr(1);
                        sys_flag |= FLAG_WAKEUP_EXTERN_MCU;
                        sys_flag |= FLAG_ENTER_LOW_POWER;
                    }
                    return;
                }
                break;
            case CMD_SET_BAUDRATE:
                if(pack_content_len==3)
                {
                    u_int32 uart_clk_div,recevicea_config;
                    recevicea_config=(pack_content[0]|(pack_content[1]<<8)|(pack_content[2]<<16));
                    if((921600 >= recevicea_config)&&(4800 <= recevicea_config))
                    {
                        uart_clk_div    = 16000000/recevicea_config;
                        uart_conf_value  = REG_APB3_UART_CFG ;
                        uart_conf_value  = (uart_conf_value & (~SET_UART_CLK_DIVID)) | (uart_clk_div << BIT_UART_CLK_DIVID) ;
                        sys_flag |= FLAG_SET_UART_BAUDRATE;
                    }
                    else
                    {
                        err_code = REQUEST_FAILD;
                    }
                }
                else
                {
                    err_code = INVALID_DATA_LENGTH;
                }
                break;
            case CMD_ENTER_UART_UPDATA:
                //flash_read_data (fix_version, 0xd8c0, 8);
                //if(0==strncmp(fix_version,"fix_v2.0",8))
            {
                REG_AHB0_ICU_IRQ_ENABLE=0;
                p_data[0]=0x00;
                p_data[1]=0x00;
                p_data[2]=0x00;
                p_data[3]=0x00;
                flash_write(FLASH_SPACE_TYPE_MAIN,0x402,4,p_data);
                wdt_enable(0x10);
                while(1)
                {
                    ;
                }
                //platform_reset();
            }
            //break;
            case CMD_REQUEST_GPIO_STATUS:
                if(pack_content_len==1)
                {
                    if(0==gpio_input((pack_content[0]>>4),(pack_content[0]&0x0f)))
                    {
                        notify_input_gpio_status(0x00);
                    }
                    else
                    {
                        notify_input_gpio_status(0x01);
                    }
                }
                else
                {
                    err_code = INVALID_DATA_LENGTH;
                }
                break;
            case CMD_FLOW_CONTROL_ON_OFF:
                if(pack_content_len==1)
                {
                    if(pack_content[0]==0)
                    {
                        uart_flow_control=0;
                    }
                    else
                    {
                        uart_flow_control=1;
                    }
                }
                else
                {
                    err_code = INVALID_DATA_LENGTH;
                }
                break;
#if 1
            case CMD_REQUEST_VOLTAGE:
                if(adc_enable_control)
                {
                    notify_voltage();
                }
                else
                {
                    err_code = NO_PERMISION;
                }
                break;
            case CMD_SET_COD:
                if(pack_content_len==3)
                {
                    REG_AHB0_ICU_IRQ_ENABLE=0;
                    write_class_of_device[4]=pack_content[0];
                    write_class_of_device[5]=pack_content[1];
                    write_class_of_device[6]=pack_content[2];
                    REG_AHB0_ICU_IRQ_ENABLE=INT_IRQ_BIT|FIQ_IRQ_BIT;
                }
                else
                {
                    err_code = INVALID_DATA_LENGTH;
                }
                break;
            case CMD_SET_ADV_DATA:
                if((pack_content_len>=1)&&(pack_content_len<=31))
                {
                    REG_AHB0_ICU_IRQ_ENABLE=0;
                    set_sys_para->advisting_data_len=pack_content_len;
                    memset(set_sys_para->advisting_data,0,pack_content_len);
                    memcpy(set_sys_para->advisting_data,pack_content,pack_content_len);
                    REG_AHB0_ICU_IRQ_ENABLE=INT_IRQ_BIT|FIQ_IRQ_BIT;
                }
                else
                {
                    err_code = INVALID_DATA_LENGTH;
                }
                break;
            case CMD_SET_ADV_RESPONSE_DATA:
                if((pack_content_len>=1)&&(pack_content_len<=31))
                {
                    REG_AHB0_ICU_IRQ_ENABLE=0;
                    set_sys_para->scan_response_data_len=pack_content_len;
                    memset(set_sys_para->scan_response_data,0,pack_content_len);
                    memcpy(set_sys_para->scan_response_data,pack_content,pack_content_len);
                    REG_AHB0_ICU_IRQ_ENABLE=INT_IRQ_BIT|FIQ_IRQ_BIT;
                }
                else
                {
                    err_code = INVALID_DATA_LENGTH;
                }
                break;
            case CMD_SET_VOLTAGE_CHECK_ONOFF:
                if(pack_content_len==1)
                {
                    if(pack_content[0]==0)
                    {
                        adc_enable_control=0;
                        ADC_Deinit(1);
                    }
                    else if(pack_content[0]==1)
                    {
                        adc_enable_control=1;
                        ADC_Init(1,1);
                    }
                    else
                    {
                        err_code = INCRRECT_DATA;
                    }
                }
                else
                {
                    err_code = INVALID_DATA_LENGTH;
                }
                break;
            case CMD_SET_BT_ADDR:
                if(pack_content_len==6)
                {
                    REG_AHB0_ICU_IRQ_ENABLE=0;
                    memcpy(bd_addr,pack_content,6);
                    REG_AHB0_ICU_IRQ_ENABLE=INT_IRQ_BIT|FIQ_IRQ_BIT;
                }
                else
                {
                    err_code = INVALID_DATA_LENGTH;
                }
                break;
#endif
            default:
                err_code = UNRECOGNIZED_COMMAND;
                return;
            }
        }
    }
    if(err_code != 0)
    {
        cmd_response(RESULT_FAILD,err_code);
    }
    else
    {
        cmd_response(RESULT_SUCCESS,0x00);
    }
#endif
}
/*
void gpio_wakeup_enable(void)
{
    if((gpio_input(((UART_EN>>4)&0x0F),(UART_EN&0x0F))))
    {
        REG_APB5_GPIO_WUATOD_ENABLE |= 1<<(8*(UART_EN>>4)+(UART_EN&0x0f));
        REG_APB5_GPIO_WUATOD_TYPE=0xffffffff;
        REG_APB5_GPIO_WUE_TYPE=0x000000ff;
        REG_APB5_GPIO_WUATOD_STAT = 0xffffffff ;
        REG_APB5_GPIO_WUE_STAT = 0xff ;
        REG_AHB0_ICU_INT_ENABLE |= (INT_STATUS_GPIO);
    }
}
*/
void gpio_wakeup_set(void)
{
    if(!(sys_flag1 & FLAG_24_CONNECT))
    {   
        REG_APB5_GPIO_WUATOD_ENABLE = 0;
    }

    REG_APB5_GPIO_WUATOD_STAT = 0xffffffff ;
    REG_APB5_GPIO_WUE_STAT = 0xff ;
	REG_AHB0_ICU_INT_ENABLE |= INT_STATUS_GPIO;
    
}
/*
void gpio_wakeup_disable(void)
{
//    REG_AHB0_ICU_INT_ENABLE &= ~(INT_STATUS_GPIO|INT_STATUS_GPIO_WAKEUP);
}
*/
extern u_int8 mouse_data[6];//key ,Xlow,yHigh,X+Y,wheel,mouse_status
void check_key_active(u_int16 threashold)
{
//    if((sys_flag&FLAG_BLE_CONNECTED)||(sys_flag & sys_flag&FLAG_CONNECTED))
//    {
//        if(sys_flag&FLAG_KEY_ACTIVE)
//        {
//            if(!(sys_flag1 & FLAG_KEY_NOACTIVE_LOW))
//            {
//                if(enter_sleep_cont >= threashold)
//                {
//                    enter_sleep_cont = 0;
//                    if( sys_flag1 & FLAG_LOW_BATTERY)
//                    {
//                        sys_flag1 |=FLAG_KEY_NOACTIVE_LOW;
//                        bprintf("low rel");
//                        return;
//                    }
//                    sys_flag &= ~FLAG_KEY_ACTIVE;
//                    if(driver_RW_byte(CMD_EN_WAKEUP,mouse_data,0))
//                    {
//                        sys_flag1 |= FLAG_EN_WAKEUP;
//                        bprintf("123");
//                    }
//                    bprintf("key rel\n");
//                    //  gpio_wakeup_enable();
//                }
//            }
//        }
//        else
//        {
//            if(!(sys_flag1 & FLAG_EN_WAKEUP))
//            {
//                bprintf("w\n");
//                if(driver_RW_byte(CMD_EN_WAKEUP,mouse_data,0))
//                {
//                    sys_flag1 |= FLAG_EN_WAKEUP;
//                    bprintf("34\n");
//                }
//            }
//            
//        }
//    }
}
void uart_flow_ctrl(void)
{
    u_int8 l2cap_entry,lmp_entry;
    extern u_int8 le_mode ;
    //if(le_mode)
    {
        l2cap_entry=BTq_Get_Queue_Number_Of_Entries(L2CAP_OUT_Q, 0);
        lmp_entry=BTq_Get_Queue_Number_Of_Entries(LMP_OUT_Q, 0);
        if( ((l2cap_entry+lmp_entry)>(PRH_BS_CFG_SYS_NUM_OUT_ACL_PACKETS-6))||(sys_flag & FLAG_UART_TX_DATA))
        {
            GPIO_output((WAKUP_EXTERN_MCU_PIN>>4)&0x0f, WAKUP_EXTERN_MCU_PIN&0x0f, 0);
            //   DEBUG_MSG(0XFD);
        }
        else if( !(sys_flag & FLAG_UART_TX_DATA) )
        {
            GPIO_output((WAKUP_EXTERN_MCU_PIN>>4)&0x0f, WAKUP_EXTERN_MCU_PIN&0x0f, 1);
        }
    }
}
