/***********************************************************************
 *
 * MODULE NAME:    le_cts_app.c
 * PROJECT CODE:   CEVA Low Energy Single Mode
 * DESCRIPTION:    Implementation of the Services required for Simple Server App and HID App.
 * MAINTAINER:     Gary Fleming
 * CREATION DATE:  June 2012
 *
 *
 * LICENSE:
 *     This source code is copyright (c) 2011-2012 Ceva Inc.
 *     All rights reserved.
 *
 ***********************************************************************/
// Only required for Terasic Demo of SM Peripheral
//#include "system.h"
#include "sys_types.h"
#include "sys_features.h"
#include "hc_const.h"
#include "hw_lc.h"
#include "hw_le_lc.h"
#include <stdio.h>
#include "le_connection.h"
#if(PRH_BS_CFG_SYS_LE_GATT_INCLUDED==1)
#include "le_att.h"
#include "le_gatt_server.h"
#endif
#if(PRH_BS_CFG_SYS_LE_GAP_INCLUDED==1)
#include "le_gap.h"
#include "le_gap_const.h"
#endif
#include "le_const.h"
#include "hc_const.h"
#include "hc_event_gen.h"
#include "tra_queue.h"
#include "bt_timer.h"
#include "sys_mmi.h"
#include "hw_le_lc_impl.h"
#include "LE_link_layer.h"
#if (PRH_BS_CFG_SYS_LE_SMP_INCLUDED==1)
#include "le_smp.h"
#endif
#if (PRH_BS_CFG_SYS_LE_GAP_INCLUDED==1)
#include "le_gap.h"
#endif
#if (PRH_BS_CFG_SYS_LE_L2CAP_INCLUDED==1)
#include "le_l2cap.h"
#endif
#include "le_config.h"
#include "le_cts_app.h"
#include "lmp_utils.h"
#include "driver_uart.h"
#include "DeviceBtj_Header.h"
#include "DeviceBtj_Handler.h"
#include "app_dmp_module.h"
#include "hw_radio.h"
#include "lslc_irq.h"
#include "sys_irq.h"


APP_CONTROL LEapp_Config;
APP_CHARACTERISTIC app_charactr;
//static u_int8  hid_protocol_mode_array[1] = { 0x01 /* Report Protocol mode - Default */};
//static u_int8  hid_input_report_array[5] = { 0x00,0x00,0x00,0x00,0x00};//mouse
//hid_input_report_array[8] = { 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};// kewyboard
//static u_int8  hid_KB_output_report_array[1] = {0x00};/* Num Lock,Caps Lock,Scoll Lock,Compose,Kana */
//u_int8 Battery_Service_CCC[2] = {0x00,0x00};
//static u_int8  hid_input_report_reference_value[2];
////static u_int8  hid_output_report_reference_value[2];
////static u_int8  hid_feature_report_reference_value[2]= {0};
//static u_int8  hid_boot_keyboard_input_report_array[8] = { 0xAA,0xBB,0xCC,0xDD,0xEE,0xFF,0x11,0x22 };
////static u_int8  hid_boot_keyboard_output_report_array[2] = { 0x11,0x44};
////static u_int8  hid_feature_report_array[2] = {0x00, 0x00};
//static u_int8  hid_control_point_array[1] = {0x00};
////static u_int8  hid_Feature_ReportID = 2;//0x03;  ???y??ID?????DDo??o????1??̡??a????D?y?Y???a???????2?y??????3??
//static u_int8  hid_Input_ReportID = 1;//0x01; ?䨦????a
////static u_int8  hid_Output_ReportID = 1;//0x02;?䨦????a
//u_int16  hid_input1_handle,change_mode_delay_count;
//u_int16  hid_input2_handle;
//u_int16 hid_information_handle;
//_int8 Device_Manufac[20];
//u_int8 Device_Model_Number[20];
extern u_int8 Power_mode; // 0:power on  1:wakeup,BLE_ADV_CLOSE,BR_INQPAG_CLOSE,
extern u_int16 DIS_ST_cnt;
//extern u_int8 SMP_en;
extern u_int8 PAIR_scan_START,CKECK_PAIR_scan_START;
//extern u_int8 direct_advertising_address[6];
u_int8  BR_NO_SYNC_TO_PAIR;

u_int8 gap_connection_complete_flag=0;
u_int8 gap_connection_complete_flag_1=0;
u_int8 Service_Change_Range[4] = {0x01,0x00,0x4F,0x01};
//static u_int8 gap_name_array[12]="BK3231S_DM";
//static u_int8 gap_appearance_array[2] = {0x03,0xC2};// C2 mouse ; //{0x03,0xC1}  Hid Keyboard C3 joystick
//static u_int8 gap_connection_params[8] = {6,0,9,0,LATENCY_VALUE_PARAM,0,0x2c,01};//{0x10,0x00,0x30,0x00,0x0a,0x00,0xd0,0x07};// min,max,lantecy,timeout, low high//(0xFFFF,8,7,15,0x12c)
u_int32 GAP_Adv_Interval = 28;//40;//50mS //160; 100mS
u_int8 manufacturer_name_string[10] = "CEVA";
u_int8 pnp_id[7] = {0x01,0x0E,0x00,0x12,0x34,0x01,0x67};
u_int8 GATT_service_change_CCC[2] = {0x00,0x00};
extern u_int8 need_to_check_PKA;

//const unsigned char Com_Table_WriteScanEnable_DisableAll2[] =
//{0X01,0x1a, 0x0c, 0x01, 0x00};
//const unsigned char Com_Table_WriteScanEnable2[] = 
//{0x01, 0x1a, 0x0c, 0x01, 0x03};
//const unsigned char Com_Table_WriteScanEnable3[] = 
//{0x01, 0x1a, 0x0c, 0x01, 0x02};
extern void send_HCI_command(const unsigned char *buffer,unsigned char data_len);
u_int32 str2int( u_int8 *src)
{
    u_int8 i;
    u_int32 ret = 0;
    for(i=0; i<6; i++)
    {
        ret = ret*10 + src[i] - '0';
    }
    return ret;
}
u_int32 SET_CURRENT_TIME(u_int32 current_clk, u_int32 CURRENTX_TIME)
{
	u_int32 CURRENT_TIMEXX;
	
            if( (current_clk+CURRENTX_TIME)>BT_CLOCK_MAX_TICKS )
            {
                CURRENT_TIMEXX=(current_clk+CURRENTX_TIME)-BT_CLOCK_MAX_TICKS;
            }
            else
            {
                CURRENT_TIMEXX = current_clk+CURRENTX_TIME;
            }
	return CURRENT_TIMEXX;
}

void LE_App_Clear_Count(void)
{
    LEapp_Config.empty_packet_cnt=0;
}
extern char connect_sensor_cnt ;// for when connect,the sensor is jump too far

extern  void Clear_Class_BT_Status(void);
const unsigned char Com_Table_WriteScanEnablex[] =
{0x01, 0x1a, 0x0c, 0x01, 0x03};
void User_App_Check_Timers(void)
{
//    static u_int16 sch_ble_cnt=0;
    u_int32 current_clk = HW_Get_Native_Clk_Avoid_Race();
//    SET_SYS_PARA_P set_sys_para=(SET_SYS_PARA_P)set_sys_buff;
//    u_int8 tmp_buf[3],addr_en=0;
	
    //---------------PAIR_FUNCTION------------------------------------------------------
    if(PAIR_scan_START==1)
    {
	    PAIR_scan_START=0;
	    LEapp_Config.PAIR_KEY_timer_out= SET_CURRENT_TIME(current_clk,3200);  //PAIR_KRY_HOW_LONG_TIME_TO_PAIR(3200=1s)
	    bprintf("PAIR_START1\r\n");
    }
    else
    {
	   if((CKECK_PAIR_scan_START)==0)
          {
		   LEapp_Config.PAIR_KEY_timer_out= BT_TIMER_OFF;
	   }
    }
    if  ((LEapp_Config.PAIR_KEY_timer_out !=  BT_TIMER_OFF) &&
         (((LEapp_Config.PAIR_KEY_timer_out - current_clk - 1) & BT_CLOCK_MAX_TICKS) >= BT_CLOCK_MAX_TIMEOUT))
    {
	  LEapp_Config.PAIR_KEY_timer_out= BT_TIMER_OFF;
	  LEapp_Config.PAIR_TIME_OUT_SLEEP_timer=SET_CURRENT_TIME(current_clk,192000);  //PAIR_TIME_OUT 60s(3200=1s)
	  
	     if(!(sys_flag&FLAG_BT_INPAIR))
	     {
		 sys_flag |=FLAG_BT_INPAIR;
		  
			if(sys_flag&FLAG_CONNECTED)  //BR SYNC TO PAIR
			{
//				Rf_status[1]=Rf_status[1]+1; //BLE ADDRESS+1
				DeviceHci_Disconnect(&btj_adapter, btj_adapter.hci_context->hci_context_handle, HCI_ERR_OETC_USER);
				bprintf("PAIR_br_c\r\n");
			}
			else //BR NO_SYNC TO PAIR                         
			{
				//DeviceHci_Disconnect(&btj_adapter, btj_adapter.hci_context->hci_context_handle, HCI_ERR_OETC_USER);
				//DeviceHci_Disconnect(&btj_adapter,btj_adapter.hci_context[0].hci_context_handle, HCI_ERR_OETC_USER);
				sys_flag &= ~FLAG_AUTO_CONNECT_BUSY;
			       sys_flag &= ~FLAG_AUTO_CONNECT_START;
				sys_flag &= ~FLAG_AUTO_CONNECT_TEST_DONGLE_BUSY;
				send_HCI_command(Com_Table_WriteScanEnablex,5);
				bprintf("PAIR_START2\r\n");
			} 
		        
	     }		 
      
    }
//-----------------------------------PAIR_TIME_OUT_SLEEP_timer----------------------------------------------
    if((sys_flag&FLAG_CONNECTED)&&(~(sys_flag&FLAG_BT_INPAIR)))
    {
	 LEapp_Config.PAIR_TIME_OUT_SLEEP_timer= BT_TIMER_OFF;
    }
    if  ((LEapp_Config.PAIR_TIME_OUT_SLEEP_timer !=  BT_TIMER_OFF) &&
         (((LEapp_Config.PAIR_TIME_OUT_SLEEP_timer - current_clk - 1) & BT_CLOCK_MAX_TICKS) >= BT_CLOCK_MAX_TIMEOUT))
    {
	    LEapp_Config.PAIR_TIME_OUT_SLEEP_timer= BT_TIMER_OFF;
	    
//		    
//		    
//		    Rf_status[Rf_status[0]+3]=Rf_status[Rf_status[0]+3]-1;    //BLE ADDRESS-1 or go_to_sleep
//          
    }
//-----------------------------------------------------------------------------------------------------------    
//    if ((LEapp_Config.TAPP_POWERON_STANDBY_Timer !=  BT_TIMER_OFF) &&
//            (((LEapp_Config.TAPP_POWERON_STANDBY_Timer - current_clk) & BT_CLOCK_MAX_TICKS) >= BT_CLOCK_MAX_TIMEOUT))
//    {
//        LEapp_Config.TAPP_POWERON_STANDBY_Timer = BT_TIMER_OFF;
//    }
//    if(ble_passkey_req==1)
//    {
//        ble_passkey_req=2;
//        //send_notify_passkey_request();
//    }
//    if(sys_flag&FLAG_BLE_GAP_DISCONNECT)
//    {
//        //  if(sch_ble_cnt++>=2000)
//        {
//            //    sch_ble_cnt=0;
//            sys_flag &= ~FLAG_BLE_GAP_DISCONNECT;
//            if(sys_flag &FLAG_BLE_CONNECTED)
//            {
//                GAP_Disconnect(0);
//            }
//        }
//    }
    

}

//void delay_change_mode(void)
//{
//	if(BR_NO_SYNC_TO_PAIR==1)
//	{
//		change_mode_delay_count++;
//		if(change_mode_delay_count>6000)
//		{
//			BR_NO_SYNC_TO_PAIR=0;
//			send_HCI_command(Com_Table_WriteScanEnable2,5);
//			change_to_BLE_MODE();
//			GAP_Discoverable_Mode(GAP_GENERAL_DISCOVERABLE,ADV_IND,PAIR_ADVERTISING_INTERVAL,direct_advertising_address);
//			//bprintf("BR_NO_SYNC_TO_PAIR\r\n");
//		}
//	}
//}

