#include "include.h"
#include "sys_irq.h"
#include "bt_init.h"
#include "hc_event_gen.h"
#include "tra_hcit.h"
#include "bt_test.h"
#include "bt_test_impl.h"
#include "sys_power.h"
#include "DeviceBtj_Header.h"
#include "DeviceBtj_Handler.h"
#include "bt_mini_sched.h"
#include "le_cts_app.h"
#include "app_dmp_module.h"

//u_int8 direct_advertising_address[6]={0x12,0x34,0x56,0x78,0x9A,0xBC};
u_int8 bd_addr[6];
u_int8 env_config_buff[sizeof(ENV_CONFIG_T)];
RW_RAM u_int8 set_sys_buff[sizeof(SET_SYS_PARA_T)];
//u_int8 le_mode = 0;  //0--Classic BT   1--LE BT
extern u_int32 uart_conf_value;
extern u_int8 linkkey_buff[24];
extern u_int8 mouse_data[6];//key ,Xlow,yHigh,X+Y,wheel,mouse_status
//extern u_int8 Rf_status[2]; //  Rf_status[0]=0:class 1:ble   Rf_status[1]=BLE  ADDRESS-->BT ADDRESS[3]
//u_int8 BLE_ADV_CLOSE=0,BR_INQPAG_CLOSE=0;
u_int8 Power_mode = 0; // 0:power on  1:wakeup
void delay_us(uint32 num)
{
  //for 48M clock
  //100=12.5us
  //16=2us
  //8=1us
  //for 32.768 clock
  //8=1.6ms
  //16M clock
  //100=120us
  u_int32 i, j;

  for(i = 0; i < num; i++)
    for(j = 0; j < 3; j++)
    {
      ;
    }
}
void delay_for_32k(uint32 num)
{
  //for 32.768 clock
  //num=1; 0.25ms
  //num=5;1.5ms
  //num=100;19ms
  u_int32 i;

  for(i = 0; i < num; i++)
  {
    ;
  }
}
static void Stack_Integrity_Check(void)
{
  extern u_int32 FIQ_STACK;
  extern u_int32 IRQ_STACK;
  extern u_int32 SVC_STACK;
  extern u_int32 USR_STACK;

  if(FIQ_STACK != (u_int32)0xDEADBEEF)
  {
    while(1)
    {
      bprintf("fiq stack over flow\r\n");
      DEBUG_MSG(0XFC);
    }
  }

  if(SVC_STACK != (u_int32)0xDEADBEEF)
  {
    while(1)
    {
      bprintf("svc stack over flow\r\n");
      DEBUG_MSG(0XFD);
    }
  }

  if(IRQ_STACK != (u_int32)0xDEADBEEF)
  {
    while(1)
    {
      bprintf("irq stack over flow\r\n");
      DEBUG_MSG(0XFE);
    }
  }

  if(USR_STACK != (u_int32)0xDEADBEEF)
  {
    while(1)
    {
      bprintf("user stack over flow\r\n");
      DEBUG_MSG(0XFF);
    }
  }
}
void rw_ram_init(void)
{
  u_int32 i;
  BLE_DEEPSLCNTL_ADDR = 0x0f;
  BLE_DEEPSLWKUP_ADDR = 0;
  BLE_RW_CTRL = 0;

  for(i = 0; i < 1024; i++)
  {
    (*((volatile unsigned long *)  0x814000 + i)) = 0;
  }
}
//extern uint8 Rf_statusX[128];
void read_env_config()
{
  uint8 tmp_buf[2];
  ENV_CONFIG_P env_config = (ENV_CONFIG_P)env_config_buff;
  SET_SYS_PARA_P set_sys_para = (SET_SYS_PARA_P)set_sys_buff;
// get BT addr
  flash_read(FLASH_SPACE_TYPE_MAIN, 0x9ffc, 6, env_config_buff);

  if(   env_config->bt_addr[0] == 0xff || env_config->bt_addr[1] == 0xff
        || env_config->bt_addr[2] == 0xff || env_config->bt_addr[3] == 0xff
        || env_config->bt_addr[4] == 0xff || env_config->bt_addr[5] == 0xff
    )
  {
    env_config->bt_addr[0] = 0xd1 ;
    env_config->bt_addr[1] = 0xbd ;
    env_config->bt_addr[2] = 0x2e ;
    env_config->bt_addr[3] = 0x8c ;
    env_config->bt_addr[4] = 0x73 ;
    env_config->bt_addr[5] = 0xc3 ;

  }

  memcpy(bd_addr, env_config->bt_addr, 6);

//get BT name
  memcpy(set_sys_para->classic_bt_name, "AT32WB415_SPP", sizeof("AT32WB415_SPP"));
  set_sys_para->classic_bt_name_len = sizeof("AT32WB415_SPP") - 1;
  memcpy(set_sys_para->ble_bt_name, "AT32WB415_SPP", sizeof("AT32WB415_SPP"));
  set_sys_para->ble_bt_name_len = sizeof("AT32WB415_SPP") - 1;
//get class pincode
  memcpy(set_sys_para->classic_bt_pair_pincode, "123456", 6);
  set_sys_para->classic_bt_pair_pincode_len = 6;
//get pair mode

  //if(set_sys_para->classic_bt_pair_mode>4)
  {
    set_sys_para->classic_bt_pair_mode = 1;
  }

//get BT addr
  flash_read(FLASH_SPACE_TYPE_NVR, 0x8000, 2, tmp_buf);

// set first BLE addr
  if(tmp_buf[0] == 0xff && tmp_buf[1] == 0xff)
  {
    tmp_buf[0] = bd_addr[0] + 1;
    tmp_buf[1] = bd_addr[0] + 2;
    flash_erase_sector(FLASH_SPACE_TYPE_NVR, 0x8000);
    flash_write(FLASH_SPACE_TYPE_NVR, 0x8000, 2, tmp_buf);
  }

}

#if 1
void user_timer_cb(unsigned char ucChannel)
{
	gpio_triger(0x11);
}

void user_timer_init(void)
{
	PWM_DRV_DESC timer_desc;

	timer_desc.channel = 4;
	timer_desc.mode = 1 << 0 | 0 << 1 | 0 << 2 | 1 << 4;
	timer_desc.end_value = 2;
	timer_desc.duty_cycle = 1;
	timer_desc.p_Int_Handler = user_timer_cb;

	REG_AHB0_ICU_PWMCLKCON |= (1 << 1);
	REG_AHB0_ICU_PWMCLKCON &= ~(7 << 12);
	REG_AHB0_ICU_PWMCLKCON |= (8 << 12);
	pwm_init(&timer_desc);
}
#endif

void SYS_Initialise(void)
{
  u_int32 flags;
  SYSirq_Disable_Interrupts_Save_Flags(&flags);
  icu_init();
  flash_init();
  GPIO_Initial();

  UART_Initial();

#if (UART2_LOG)
  uart2_init(256000);
#endif

  xver_initial();
  bt_clk_init();
  Timer_Initial();
  rw_ram_init();
  read_env_config();

  SYSconfig_Initialise();
  TRAhcit_Set_Register_Function(TRAhcit_Register_UART_Driver);

  bprintf("x5\r\n");
  BT_Initialise();
  REG_AHB0_ICU_INT_STATUS_FLAG = 0xffffffff;
  bprintf("start\r\n");
  SYSirq_Enable_Interrupts_Save_Flags(&flags);
  Enable_ICU_Intr();
}
//extern u_int8 sys_mouse_key;
extern u_int16 enter_sniff_cnt;
extern void exit_sniff(void);
extern uint8 spp_data_send(uint8 *buff, uint8 len);
int main(void)
{
  delay_ms(2);
  sys_flag |= FLAG_POWER_ON;

  Power_mode = system_reset_reson();

  if(Power_mode == 1)
  {
    sys_flag |= FLAG_KEY_ACTIVE;
  }

  SYS_Initialise();

  SYS_Host_Initialise();
  
  user_timer_init();

  delay_ms(1);

  while(1)
  {
    // BT mode
    BTms_Sched();
    driver_mouse_key_scan_paired();
    User_App_Check_Timers();

    Host_Loop();

if((sys_flag & FLAG_UART_INTERRPUT) && (sys_flag & FLAG_CONNECTED))
{
  sys_flag &= ~FLAG_UART_INTERRPUT;
  bprintf("buff length: %d\r\n", uart_rx_buff_header);
  spp_data_send((uint8 *)uart_rx_tx_buff, uart_rx_buff_header);
  uart_rx_buff_header = 0;
  sys_flag |= FLAG_KEY_ACTIVE;
}

    if((sys_flag & FLAG_CONNECTED) && (((REG_APB5_GPIO1_DATA >> 8) & 0x01) == 0x00))
    {

      sys_flag |= FLAG_KEY_ACTIVE;
      enter_sniff_cnt = 10000;
    }

//-----------------------deepsleep-------------------------------------------------------
    if(sys_flag & FLAG_ENTER_DEEPSLEEP)
    {
      {
        bprintf("cmd\r\n");
        REG_AHB0_ICU_INT_ENABLE = 0;
        REG_AHB0_ICU_IRQ_ENABLE = 0;

        gpio_Deepsleep_enable();
        delay_ms(100);

        bprintf("sleep\r\n");
        delay_ms(1);
        enter_deep_sleep();
      }
    }

//-------------------------------------------------------------------------------
    Stack_Integrity_Check();
  }
}
