#ifndef __DEVICEBTJ_HEADER_DOT_H_
#define __DEVICEBTJ_HEADER_DOT_H_
#include "DeviceBtj.h"
#if defined(WIN32)
typedef unsigned char              BITBYTE;
typedef unsigned short             BITWORD;
#elif defined(C30)
typedef unsigned char              BITBYTE;
typedef unsigned short             BITWORD;
#else
typedef unsigned                   BITBYTE;
typedef unsigned                   BITWORD;
#endif
//sys_flag BT status
#define FLAG_L2CAP_SDP_CONNECT                  0X00000001
#define FLAG_POWER_ON                           0X00000002
#define FLAG_ENTER_DEEPSLEEP                    0X00000004
#define FLAG_BT_INPAIR                          0X00000008
#define FLAG_BT_ENABLE                          0X00000010
#define FLAG_BLE_GAP_DISCONNECT                 0X00000020
#define FLAG_BT_SET_LINKPOLICY_IND              0X00000040
#define FLAG_BT_DISABLE_SCAN                    0X00000080
#define FLAG_AUTO_CONNECT_START                 0X00000100
#define FLAG_AUTO_CONNECT_BUSY                  0X00000200
#define FLAG_CONNECTED                          0X00000400
#define FLAG_AUTHENTICATION_REQ                 0X00000800
#define FLAG_BT_IN_SNIFF                        0X00001000
#define FLAG_BT_SET_SNIFF                       0X00002000
#define FLAG_ENTER_SLEEP                        0X00004000
#define FLAG_ENTER_SLEEP_CNT_END                0X00008000
#define FLAG_KEY_ACTIVE                         0X00010000
#define FLAG_LOW_POWER                          0X00020000
#define FLAG_AUTO_CONNECT_TEST_DONGLE_BUSY      0X00040000
#define FLAG_ADC_BUZY                           0X00080000
#define FLAG_BLE_CONNECTED                      0X00100000
#define FLAG_UART_INTERRPUT                     0X00200000
#define FLAG_BT_SET_PAGE                        0X00400000
#define FLAG_BT_IN_PAGE                         0X00800000
#define FLAG_GPIO_INTERRUPT                     0X01000000
#define FLAG_START_CONNECT_UPDATA               0X02000000
#define FLAG_PWM_OPEN                           0x04000000
#define FLAG_UART_TX_DATA                       0x08000000
#define FLAG_TIMER_WORK                         0x10000000
#define FLAG_WAKEUP_EXTERN_MCU                  0x20000000
#define FLAG_ENTER_LOW_POWER                    0x40000000
#define FLAG_SET_UART_BAUDRATE                  0x80000000

//sys_flag1  user status
#define FLAG_SNIFF_CHECK						0X00000001
#define FLAG_LATENCY_EN						0X00000002
#define FLAG_PAIRED							0x00000004
#define FLAG_CLASS_INPAIRED						0x00000008
#define FLAG_LOW_BATTERY						0x00000010
#define FLAG_SHOW_MODE						0x00000020
#define FLAG_KEY_DOWN						0x00000040
#define FLAG_BT_CONNECT_OK						0x00000080
#define FLAG_CHG_24							0x00000100
#define FLAG_KEY_DIS							0x00000200
#define FLAG_KEY_DIS_ST						0x00000400
#define FLAG_INIT_OK							0x00000800
#define FLAG_POWEER_ON_FIRST					0x00001000
#define FLAG_LINKKEY_EN						0X00002000
#define FLAG_BLE_AUTO_CONNECT_BUSY					0x00004000
#define FLAG_BLE_SAVE						0x00008000
#define FLAG_NO_ACTIVE_FLAG						0x00010000
#define FLAG_24_CONNECT						0x00020000
#define FLAG_BT_ACTIVE						0x00080000
#define FLAG_EN_WAKEUP						0x00100000
#define FLAG_KEY_NOACTIVE_LOW					0x00200000
#define FLAG_24_CN_PAIR						0x00400000


#define FLAG_CONFIG_SSP_ENBALE                  0X01
#define FLAG_CONFIG_UART_OPEN_ENBALE            0X02
#define FLAG_CONFIG_IO_PAIR_ENBALE              0X04
#define FLAG_CONFIG_POWER_ON_OFF_ENBALE         0X08
#define FLAG_CONFIG_ADC_ENBALE                  0X10
#define FLAG_CONFIG_ENTER_SINGLE_CARRY          0X20
#define FLAG_CONFIG_ENTER_DUT_TEST              0X40



#define BTFIELD(x)                 (((0x01 << x)))
#define DEVICEMAX_HCI_CONTEXT      (0x01)
#define DEVICEMAX_L2C_CONTEXT      (0x03)
#define DEVICELEN_LMP_FEATURE      (0x08)
#define DEVICELEN_CMD_FEATURE      (0x08)
#define DEVICELEN_HCI_MACHINE_UART (0x0090)
#define DEVICELEN_HCI_PACKETS_POOL (0x0110)
#define DEVICELEN_APP_PACKETS_POOL (190)//monster
#define btfree(x)                  {free(x); x=BTNULL;}
#define btsimplemalloc(length)     (BTPBYTE)malloc(sizeof(BTBYTE)*length)
#define btstructmalloc(bttype)     (bttype *)malloc(sizeof(BTBYTE)*sizeof(bttype))
#define btrealloc(ptr, length)     (BTPBYTE)realloc(ptr, sizeof(BTBYTE)*length)
#define btmemzero(ptr, length)     (memset(ptr, 0x00, sizeof(BTBYTE)*length))
#define btuse(x)                   (x=x)
#define BAUDRATE_W         0X01
#define BT_NAME_W          0X02
#define BT_PINCODE_W       0X04
#define BT_ADDR_W          0X08

void adc_isr(void);

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "DeviceBtj_Stack_Hci_All.h"
#include "DeviceBtj_Stack_Hci_Cmd.h"
#include "DeviceBtj_Stack_Hci_Evt.h"
#include "DeviceBtj_Stack_L2c.h"
#include "DeviceBtj_Stack_Rfc.h"
#include "DeviceBtj_Stack_Hid.h"
#include "DeviceBtj_Stack_Sdp.h"
#include "DeviceBtj_Stack_Sdpdb.h"
#include "DeviceBtj_Stack_Sdpdb_Parser.h"
#include "DeviceBtj_Utils.h"
#include "DeviceBtj_Utils_Key.h"
#include "DeviceBtj_Fcs.h"
#include "DeviceBtj_Adapter.h"
#include "DeviceBtj_Debuger.h"
#include "DeviceBtj_Endians.h"
#include "DeviceBtj_Service.h"
#include "DeviceBtj_Handler.h"

#ifdef WIN32
#include <windows.h>
#include "DeviceEvt.h"
#include "DeviceLib_Com.h"
#include "DeviceLib_Usb.h"
#endif
#endif /* __DEVICEBTJ_HEADER_DOT_H_ */
