#ifndef _CEVA_LE_CTS_APP_H__
#define _CEVA_LE_CTS_APP_H__
#include "app_dmp_module.h"


#define L2CAP_PARA_UPDATE_TIME      3200*2//Ӽʱ (38400+19200)// 3200=1S
#define SMP_SECURITY_REQUEST_TIME   3600//1800
#define LATENCY_VALUE_PARAM         64
#define Update_VALUE_Max     	 9//7
#define Update_VALUE_Min	        9//
#define ADVERTISING_INTERVAL             24
#define PAIR_ADVERTISING_INTERVAL        100

typedef struct _APP_CONTROL
{
       u_int32 TAPP_POWERON_STANDBY_Timer;
	u_int32 TAPP_L2CAP_PARA_UPDATE_Timer;
	u_int32 SMP_security_request_timer;
	u_int32 ancs_config_start_timer;
       u_int32 check_pka_timer;
       u_int16 empty_packet_cnt;
       u_int8  empty_packet_flag;
	u_int32 ble_re_timer;
	u_int32 ble_connect_timer;
	u_int32 key_no_active__timer;
	u_int32 PAIR_KEY_timer_out;
	u_int32 PAIR_TIME_OUT_SLEEP_timer;
} APP_CONTROL;

typedef struct _APP_CHARACTERISTIC
{

    u_int8  notify_value[DMP_BLE_MAX_DATALEN];
    u_int8  notify_config[2];
    u_int8  write_value[DMP_BLE_MAX_DATALEN];
    u_int16  notify_handle;
    u_int16  write_handle;

} APP_CHARACTERISTIC;



extern volatile u_int16 uart_rx_buff_header,uart_rx_buff_tailor;
extern volatile char uart_rx_tx_buff[UART_BUFF_LEN];
extern u_int8 uart_send_buff[UART_SEND_LENGTH];
extern u_int8 uart_send_length,uart_send_cnt,uart_cnt_index;
//extern const u_int8 default_service_uuid[16];
//extern const u_int8 default_characteristic_uuid_notify[16];
//extern const u_int8 default_characteristic_uuid_write[16];
extern APP_CHARACTERISTIC app_charactr;




u_int16 App_Setup_GAP_GATT_DB(void);
u_int16 App_Setup_GATT_GATT_DB(void);
u_int16 App_Setup_DEV_INFO_GATT_DB(void);
u_int16 App_Setup_IAS_GATT_DB(void);
u_int16 App_Setup_TX_POWER_GATT_DB(void);
u_int16 App_Setup_LINK_LOSS_GATT_DB(void);
u_int16 App_Setup_BATTERY_SERVICE_GATT_DB(void);
u_int16 App_Setup_SCAN_PARAMETERS_GATT_DB(void);

u_int16 App_Setup_CURRENT_TIME_GATT_DB(void);
u_int16 App_Setup_REFERENCE_TIME_GATT_DB(void);
u_int16 App_Setup_NEXT_DST_GATT_DB(void);

u_int16 App_Setup_HID_GATT_DB(void);
u_int16 App_Setup_HRS_GATT_DB(void);
u_int16 App_Setup_HT_GATT_DB(void);
u_int16 App_Setup_CSC_GATT_DB(void);
u_int16 App_Setup_RSC_GATT_DB(void);
u_int16 App_Setup_BLOOD_PRESSURE_GATT_DB(void);
u_int16 App_Setup_BLOOD_GLUCOSE_GATT_DB(void);
u_int16 App_Setup_FFE0_GATT_DB(void);
u_int16 App_Setup_FFA0_GATT_DB(void);
void LE_App_Discover_Services_By_UUID_Event(u_int8 attrib_len, u_int8 value_payload_len, u_int8* p_pdu);
void LE_App_Command_Complete(u_int16 handle,u_int8 operation_id,u_int8 status);
void LE_App_Discover_Chars_Event(u_int8 attrib_len, u_int8 value_payload_len, u_int8* p_pdu);
u_int8 LE_App_Local_Event_Indication(u_int16 attrib_handle, u_int8 status);
u_int8 LE_App_Peer_Event_Indication(u_int16 attrib_handle, u_int8 status, u_int8 length, u_int8* p_data);
void LE_App_Read_Response(u_int8 length,u_int8* p_data);
u_int8 LE_App_Local_Disconnect_Indication(t_error reason);
void Trans_ADC_Battery_Cap(void);
void User_App_Check_Timers(void);
#ifdef BATTERY_DETECT
void Restart_Battery_Detect_Timer(void);
#endif
void LE_APP_Init(void);
#ifdef BATTERY_DETECT
void Save_Battery_level(void);
u_int16 Get_Battery(void);
void Save_Power_on_Battery(u_int8 value);
u_int8 Battery_level_to_Percentage(u_int16 level);
#endif

void hid_send_keycode( void );
u_int8 user_define_data_send(u_int8* data, u_int8 len);
u_int8 user_define_data_send(u_int8* data, u_int8 len);
void user_define_data_revice(u_int8* p_attrib_value,u_int8 length,u_int8 index);
void Save_BLE_Addr(void);


#endif
