//======================================================
// File Name:     BK_ADC_Api.c.c
// Author:        yubei
// Created Date:  @2015-03-20
// Description:   Project BK3231S - Test Firmware for Massive Production
//                ADC protocol
//                 Main code of Firmware Test of BK3231S
//======================================================
#include "include.h"
#include "DeviceBtj_Header.h"


void adc_init(u_int8 channel,u_int8 mode)
{
	u_int32 cfg;

	//enable adc clk
	REG_AHB0_ICU_ADCCLKCON &= ~(0x01 << 0);
	//adc div
	REG_AHB0_ICU_ADCCLKCON = (0x5 << 1);
		
	//set special as peripheral func
	GPIO_config(3,channel,2,0); 

	//set adc mode/channel/wait clk
	cfg  = ( (mode << BIT_ADC_MODE ) | (channel << BIT_ADC_CHNL) | (0x01 << BIT_ADC_WAIT_CLK_SETTING));
	REG_APB7_ADC_CFG =  cfg;

	//set adc sample rate/pre div
	cfg |= ((18 << BIT_ADC_SAMPLE_RATE) | (3 << BIT_ADC_PRE_DIV)|(0x0 << BIT_ADC_DIV1_MODE));

	REG_APB7_ADC_CFG =  cfg;
	
	cfg |= (0x0 << BIT_ADC_FILTER);
	REG_APB7_ADC_CFG =  cfg;

	REG_APB7_ADC_CFG |= (0x01 << BIT_ADC_INT_CLEAR);
	//REG_APB7_ADC_CFG |= (0x01 << BIT_ADC_EN);//ʹADCȻADC FIFOʱûжٴADCͲж
	
	REG_AHB0_ICU_INT_ENABLE |= (0x01 << 8); 
}

void adc_deinit(u_int8 channel)
{
    REG_APB7_ADC_CFG &= ~(SET_ADC_EN+(0x03 << BIT_ADC_MODE ));
    REG_AHB0_ICU_ADCCLKCON |= (0x01 << 0);
    REG_AHB0_ICU_INT_ENABLE &= ~(0x01 << 8); 
}


u_int8 g_adc_value=0xff,adc_flag;

void adc_isr(void)
{
    REG_APB7_ADC_CFG |= (0x01 << BIT_ADC_INT_CLEAR);

    adc_flag=1;	
}

u_int8 adc_get_value(void)
{
    u_int16 adc_cnt;
    adc_cnt=0;
    adc_flag =0;
    REG_APB7_ADC_CFG |= SET_ADC_EN+(0x01 << BIT_ADC_MODE );
    adc_flag=0;
    while ( !adc_flag)
    {
        adc_cnt++;       
        if(adc_cnt>300)
        {
            bprintf("g_adc_value_timeout\r\n");
            break;			
        }
        delay_us(10);
    } 
    if(adc_flag)
    {
        g_adc_value=(REG_APB7_ADC_DAT>>2);
        
    }	
   
    //bprintf("g_adc_value=%x\r\n",g_adc_value);
    REG_APB7_ADC_CFG &= ~(SET_ADC_EN+(0x03 << BIT_ADC_MODE )); //ADCֵȡɺʹλ       
    return g_adc_value;     
}

void checkBattery(u_int16 adc_check_cnt)
{
    static u_int16 tmp_cnt=0;
    u_int8 tmp;
    if(tmp_cnt++>=adc_check_cnt)
    {
        tmp_cnt=0;
        //Vadc =1V  
        tmp = adc_get_value();
        //bprintf("tmp=%x\r\n",tmp);
        
        if(tmp <0xe5) // 0.9*256/1V
        {
            sys_flag1 |= FLAG_LOW_BATTERY;
            sys_flag |= FLAG_KEY_ACTIVE;
        }
        else
            sys_flag1 &= ~FLAG_LOW_BATTERY;
    }
}


