
#ifndef _DRIVER_FLASH_H_
#define _DRIVER_FLASH_H_
#include "include.h"




enum 
{
	FLASH_SPACE_TYPE_MAIN = 0x00,
	FLASH_SPACE_TYPE_NVR = 0x01,
	FLASH_SPACE_TYPE_INVALID = 0XFF,
};


#define FLASH_TYPE_EMBEN        FLASH_SPACE_TYPE_NVR
#define FLASH_MAIN_SIZE              0x00028000
#define FLASH_NVR_SIZE               0x00000200
#define FLASH_WRITE_ECC_DATA0 0XA3
#define FLASH_WRITE_ECC_DATA1 0X56




uint8 flash_read_qe(void);
uint8 read_lmecc_pointq_status(void);
void flash_erase_sector(u_int8 type,u_int32 address);
void flash_write(u_int8 flash_space, u_int32 address, u_int32 length, u_int8 *buffer);
void flash_read(u_int8 flash_space, u_int32 address, u_int32 length, u_int8 *buffer);
void flash_init(void);



#endif





