#include "include.h"


volatile unsigned long * GPIO_DATA[] = 
{
    &REG_APB5_GPIO0_DATA,
    &REG_APB5_GPIO1_DATA,
    &REG_APB5_GPIO2_DATA,
    &REG_APB5_GPIO3_DATA,
    &REG_APB5_GPIO4_DATA
};

void GPIO_Initial(void)  // As GPIO Output
{

  REG_APB5_GPIO0_CFG  = 0x000000FF ;
  REG_APB5_GPIO0_DATA = 0x00000000 ;
  REG_APB5_GPIO1_CFG  = 0x000000FF ;
  REG_APB5_GPIO1_DATA = 0x00000000 ;

  REG_APB5_GPIO3_CFG  = 0x000000FF ;
  REG_APB5_GPIO3_DATA = 0x00000000 ;


  REG_APB5_GPIO_WUATOD_TYPE = 0xffffffff;
  REG_APB5_GPIO_WUE_TYPE = 0x000000ff;
  REG_APB5_GPIO_WUATOD_ENABLE = 0x00000000 ;
  REG_APB5_GPIO_WUE_ENABLE = 0x00000000 ;
  REG_APB5_GPIO_WUATOD_STAT = 0xffffffff ;
  REG_APB5_GPIO_WUE_STAT = 0xff ;

  GPIO_config(0, 6, 0, 1); //control_MODE(06) //PULL_HI
  GPIO_config(0, 7, 0, 1); //PAIR_MODE(07)  //PULL_HI

  GPIO_config(1, 2, 1, 0); //IO(12) led
}

void gpio_sleep(void)
{
  REG_APB5_GPIO0_CFG  = 0x0000FFFF ;
  REG_APB5_GPIO0_DATA = 0x00000000 ;
  REG_APB5_GPIO1_CFG  = 0x0000FFFF ;
  REG_APB5_GPIO1_DATA = 0x00000000 ;
  REG_APB5_GPIO2_CFG  = 0x0000FFFF ;
  REG_APB5_GPIO2_DATA = 0x00000000 ;
  REG_APB5_GPIO3_CFG  = 0x0000FFFF ;
  REG_APB5_GPIO3_DATA = 0x00000000 ;
  REG_APB5_GPIO4_CFG  = 0x0000FFFF ;
  REG_APB5_GPIO4_DATA = 0x00000000 ;
}
void app_gpio_sleep(void)
{
//    REG_APB5_GPIO_WUATOD_TYPE = ((1<<( (KEY_LEFT>>4)*8)+(KEY_LEFT&0x0f)))
//                                |((1<<((KEY_RIGHT>>4)*8)+(KEY_RIGHT&0x0f)))
//                                |((1<<( (KEY_MIDDLE>>4)*8)+(KEY_MIDDLE&0x0f)))
//                                |((1<<( (KEY_PAIR>>4)*8)+(KEY_PAIR&0x0f)))
//                                |((1<<( (WHEEL_B>>4)*8)+(WHEEL_B&0x0f)))
//                                |((1<<( (WHEEL_A>>4)*8)+(WHEEL_A&0x0f)))
//                                |((1<<( (PAW3205_MOTSWK_PIN>>4)*8)+(PAW3205_MOTSWK_PIN&0x0f)));
//    REG_APB5_GPIO_WUATOD_ENABLE = ((1<<( (KEY_LEFT>>4)*8)+(KEY_LEFT&0x0f)))
//                                |((1<<((KEY_RIGHT>>4)*8)+(KEY_RIGHT&0x0f)))
//                                |((1<<( (KEY_MIDDLE>>4)*8)+(KEY_MIDDLE&0x0f)))
//                                |((1<<( (KEY_PAIR>>4)*8)+(KEY_PAIR&0x0f)))
//                                |((1<<( (WHEEL_B>>4)*8)+(WHEEL_B&0x0f)))
//                                |((1<<( (WHEEL_A>>4)*8)+(WHEEL_A&0x0f)))
//                                |((1<<( (PAW3205_MOTSWK_PIN>>4)*8)+(PAW3205_MOTSWK_PIN&0x0f)));
  REG_APB5_GPIO_WUATOD_TYPE |= 1 << 8;
  REG_APB5_GPIO_WUATOD_STAT |= 1 << 8;
  REG_APB5_GPIO_WUATOD_ENABLE |= 1 << 8;
  REG_APB5_GPIO_WUATOD_STAT = 0xffffffff ;
  REG_AHB0_ICU_INT_ENABLE |= INT_STATUS_GPIO;

}
void gpio_wakeup_set(void)
{
  REG_APB5_GPIO_WUATOD_ENABLE = 0x00000000;
  REG_APB5_GPIO_WUATOD_STAT = 0xffffffff ;
  REG_APB5_GPIO_WUE_STAT = 0xff ;
  REG_AHB0_ICU_INT_ENABLE &= (~(0x01 << 9));

}

// port:0~4;  gpio:0~7;
// index:0 -input & pullup, 1-output, 2--second function,3--no input output
void GPIO_config( uint8 port, uint8 gpio, uint8 index, uint8 outputdata )
{
  volatile unsigned long *ptr0, *ptr1;
  uint32 val = 0;


  ptr0 = (volatile unsigned long *)(APB_GPIO_BASE + 8 * port);
  ptr1 = (volatile unsigned long *)(APB_GPIO_BASE + (8 * port + 4));

  if( index  == 0 )
  {
    val = *ptr0;

    if(outputdata == 1)
    {
      val |= (1 << (0 + gpio)) + (1 << (8 + gpio)) + (1 << (16 + gpio));
      val &=  ~(1 << (24 + gpio));
    }
    else if(outputdata == 0)
    {
      val |= (1 << (0 + gpio)) + (1 << (8 + gpio)) + (1 << (24 + gpio));
      val &=  ~(1 << (16 + gpio));
    }
    else
    {
      val |= (1 << (0 + gpio)) + (1 << (8 + gpio)) ;
      val &=  ~(1 << (16 + gpio));
      val &=  ~(1 << (24 + gpio));
    }



    *ptr0 = val;
    val = 1 << (16 + gpio);
    *ptr1 |= val;
  }
  else if( index == 1 )
  {
    val = *ptr1;
    val &= ~( 1 << gpio );
    val |= ((outputdata & 0x01) << gpio) + (1 << (16 + gpio));
    *ptr1 = val;
    val = 1 << (0 + gpio);
    *ptr0 |= val;
    val = 1 << (8 + gpio);
    *ptr0 &= (~val);

  }
  else if( index == 2 )
  {
    val = 1 << (0 + gpio);
    *ptr0 &= (~val);

  }
  else if(index == 3)
  {
    val = (1 << (0 + gpio)) + (1 << (8 + gpio));
    *ptr0 |= val;
    val = 1 << (16 + gpio) + 1 << (24 + gpio);
    *ptr0 &= (~val);
    val = 1 << (16 + gpio);
    *ptr1 &= (~val);

  }
  else if(index == 4)
  {
    val = 1 << (0 + gpio);
    *ptr0 &= (~val);
    val = 1 << (port * 8 + gpio);
//        REG_AHB0_ICU_PERI_2ND_EN |= val;

  }
}
void GPIO_output( uint8 port, uint8 gpio, uint8 val )
{
  volatile unsigned long *ptr;
  uint32 data;
  ptr = (volatile unsigned long *)(APB_GPIO_BASE + (8 * port + 4));
  data = *ptr;
  data &= ~( 1 << gpio );
  data |= (val & 0x01) << gpio;
  *ptr = data;
  return;
}

void GPIO_output_neg( uint8 port, uint8 gpio)
{
  volatile unsigned long *ptr;
  //uint32 data;
  ptr = (volatile unsigned long *)(APB_GPIO_BASE + (8 * port + 4));
  *ptr ^= ( 1 << gpio );
  return;
}

uint32 gpio_input( uint8 port, uint8 gpio )
{
  volatile unsigned long *ptr;
  ptr = (volatile unsigned long *)(APB_GPIO_BASE + (8 * port + 4));

  return (*ptr) & ( 1 << (gpio + 8) );
}

void gpio_set(uint8 gpio, uint8 val)
{
    uint32 temp;
    uint8 port = (gpio&0xf0)>>4;
    uint8  pin = gpio&0xf;
    
    temp = *(GPIO_DATA[port]);
    if(val)
    {
        temp |= 1<<pin;
    }
    else
    {
        temp &= ~(1<<pin);
    }

    *(GPIO_DATA[port]) = temp;
}

void gpio_triger(uint8 gpio)
{
	gpio_set(gpio, 1);
	gpio_set(gpio, 0);
}

void DEBUG_MSG(uint32 x)
{

#if (DEBUG_MODE)

  GPIO_config(3, 3, GPIO_DIR_OUTPUT, 0);
  REG_APB5_GPIO3_DATA &= 0xffffffef;
  REG_APB5_GPIO1_DATA = x & 0xFF;

  if(x & 0x20)
  {
    REG_APB5_GPIO3_DATA |= 0X08;
  }
  else
  {
    REG_APB5_GPIO3_DATA &= ~0X08;
  }

  REG_APB5_GPIO3_DATA |= 0x00000010;

#else
  return;
#endif
}

void DEBUG_MSG1(uint32 x)
{

#if 0// (DEBUG_MODE)

  REG_APB5_GPIO3_DATA &= 0xffffffef;
  REG_APB5_GPIO1_DATA = x & 0xFF;

  if(x & 0x20)
  {
    REG_APB5_GPIO3_DATA |= 0X08;
  }
  else
  {
    REG_APB5_GPIO3_DATA &= ~0X08;
  }

  REG_APB5_GPIO3_DATA |= 0x00000010;

#else
  return;
#endif
}




