#include "include.h"
#include "sys_irq.h"
#include "driver_icu.h"
#include "DeviceBtj_Header.h"

volatile uint8 close_xtal_set=0;


void icu_init(void)
{
#if DEBUG_HW
	REG_AHB0_ICU_LPO_CLK_ON |= (0x01 << 2);
#endif

#if (USE_LDO_MODE)
       REG_AHB0_ICU_ANALOG1_PWD|=((1<<12)|(1<<28));//LDO mode
#endif

    REG_AHB0_ICU_FLASH &= ~(0xff << 16);
    REG_AHB0_ICU_FLASH |= (0x15 << 16);

    REG_AHB0_ICU_CPU_STATUS  = 0x661;


	REG_AHB0_ICU_DIGITAL_PWD = REG_AHB0_ICU_DIGITAL_PWD & (~0X02);

	REG_AHB0_ICU_CORECLKCON = 0X00;

	REG_AHB0_ICU_CLKSRCSEL = 0X01b1; //usr 16M,

    REG_AHB0_ICU_ANA_CTL |= (0X01 << 6);   

    REG_AHB0_ICU_BLE_CLKCON=0x00;
    //REG_AHB0_ICU_CEVA_CLKCON=0x02;

    switch_clk(MCU_CLK_32M);

}
void bt_clk_init(void)
{
    REG_AHB0_ICU_BLE_CLKCON=0x01;
    REG_AHB0_ICU_CEVA_CLKCON=0x02;
}
uint32 REG_temp=0;
extern void gpio_wakeup_set(void);
extern void app_gpio_sleep(void);
void cpu_close_xtal_sleep(void)
{
    close_xtal_set=1;
    //REG_AHB0_ICU_DIGITAL_PWD |= 0x80 ;
    REG_AHB0_ICU_IRQ_ENABLE=0x00;
    REG_temp=REG_AHB0_ICU_DIGITAL_PWD;
    REG_AHB0_ICU_DIGITAL_PWD = REG_AHB0_ICU_DIGITAL_PWD & (~0X02);
    //REG_AHB0_ICU_FLASH  &= ~0xffff;
    //REG_AHB0_ICU_FLASH  |= 0x04;
    //REG_AHB0_ICU_FLASH=0x1d300002;
    REG_AHB0_ICU_FLASH=0x00100004;
    REG_AHB0_ICU_SLEEP_TIME=0x04;
    app_gpio_sleep();
	
    REG_AHB0_ICU_CORECLKCON = 0x00; //clk div 3
    REG_AHB0_ICU_CLKSRCSEL  = 0x1b0;
    //REG_AHB0_ICU_DIGITAL_PWD |= SET_CLK48M_PWD;
    //REG_AHB0_ICU_DIGITAL_PWD |= SET_CB_BAIS_PWD;
    //REG_AHB0_ICU_DIGITAL_PWD |= SET_CLK16M_PWD;//can not power dn 16M, or flash cant nor be read
    //REG_AHB0_ICU_DIGITAL_PWD |=SET_HP_LDO_PWD;
    REG_AHB0_ICU_DIGITAL_PWD=0x8f;
    REG_AHB0_ICU_IRQ_ENABLE=0x03;
	
    REG_AHB0_ICU_CORECLKCON  = 0x1; // Power down MCU
	
}


void cpu_wakeup(void)
{
  
    if(close_xtal_set==1)
    {
		close_xtal_set=0;
	    
		//REG_AHB0_ICU_DIGITAL_PWD = 0x80;
	       //REG_AHB0_ICU_DIGITAL_PWD = 0x82;
	       REG_AHB0_ICU_DIGITAL_PWD = REG_AHB0_ICU_DIGITAL_PWD & (~0X02);
		REG_AHB0_ICU_CLKSRCSEL  = 0x1b1;
	       REG_AHB0_ICU_DIGITAL_PWD=REG_temp;
              //REG_AHB0_ICU_CLKSRCSEL = 0X000001b1; //usr 16m,VN=7,VD=3
	    
		//REG_AHB0_ICU_FLASH  &= ~0xffff;
		//REG_AHB0_ICU_FLASH  |= 0xff;
		REG_AHB0_ICU_FLASH=0x001000ff;
              REG_AHB0_ICU_SLEEP_TIME=0xff;

		//DEBUG_MSG(0X16);
    }
}

void cpu_idle_sleep(void)
{
    REG_AHB0_ICU_CORECLKCON |= 0x01;//MCU sleep
}
void enter_deep_sleep(void)
{
    REG_AHB0_ICU_INT_ENABLE=0;
    REG_AHB0_ICU_IRQ_ENABLE=0;

    REG_AHB0_ICU_DEEP_SLEEP_SEL=0x5a;

    REG_AHB0_ICU_DEEP_SLEEP_WORD&= 0x0000FFFF;
    REG_AHB0_ICU_DEEP_SLEEP_WORD|=( 0x3432<<16);
    delay_us(10);
    while(1);
}





void switch_clk(uint8 clk)
{
    REG_AHB0_ICU_DIGITAL_PWD = REG_AHB0_ICU_DIGITAL_PWD & (~0X02);

    if (clk == MCU_CLK_16M )
    {
    	REG_AHB0_ICU_CORECLKCON = 0X00; //clk div 0

    	REG_AHB0_ICU_CLKSRCSEL = 0X000001b1; //usr 16m,VN=7,VD=3
       //REG_AHB0_ICU_CLKSRCSEL = 0X000001f9; //usr 16m,VN=7,VD=3
    }
    else if (clk == MCU_CLK_64M )
    {
    	REG_AHB0_ICU_CORECLKCON = 0X00; //clk div 0

    	REG_AHB0_ICU_CLKSRCSEL = 0X000005b3; //usr PLL CLK SELT 64M

     }

    else if (clk == MCU_CLK_32M )
    {
    	REG_AHB0_ICU_CORECLKCON = 0x04; //clk div 2

    	REG_AHB0_ICU_CLKSRCSEL = 0X000005b3; //usr PLL CLK SELT 64M

    }
	   else if (clk == MCU_CLK_21M )
    {
    	REG_AHB0_ICU_CORECLKCON = 0x06; //clk div 3

    	REG_AHB0_ICU_CLKSRCSEL = 0X000005b3; //usr PLL CLK SELT 64M

    }


}


uint8 system_reset_reson(void)
{
    if(REG_AHB0_ICU_CPU_STATUS&0x02)
        return 1;//deepsleep wake
    else
        return 0;//power on
}

void Enable_ICU_Intr(void)
{
    REG_AHB0_ICU_INT_ENABLE |= INT_STATUS_CEVA|INT_STATUS_ADC;

    REG_AHB0_ICU_IRQ_ENABLE = INT_IRQ_BIT|FIQ_IRQ_BIT;
}


void CLK32K_AutoCali_Enable(uint16  sleep_time)
{
 /*   uint32  rdata;

    // 16MHz XTAL Sleep (Power-down) Time is 2048*31.25us=64ms
    REG_AHB0_ICU_SLEEP_TIME  = sleep_time ;

    // 32KHz Clock calibration config
    rdata = REG_AHB0_ICU_RC32K_CONFG ;
    rdata &= SET_MANU_EN  ;  //Manually calibration is disable
    rdata |= SET_CALI_MODE;  //Mode=1 --> calibrate to 32KHz
    rdata |= SET_SPI_TRIG ;  //SPI_Trigger=1 --> enable calibration
    REG_AHB0_ICU_RC32K_CONFG = rdata ;
    */
}



