//======================================================
// File Name:     BK_TIMER_API.c
// Author:        yubei
// Created Date:  @2015-02-12
// Description:   Project BK3231S - Test Firmware for Massive Production
//                GPIO protocol
//                Source from BK3231  firmware: bk3000_timer.c
//======================================================
#include "include.h"
#include "app_dmp_module.h"


volatile uint8 bk_timer_hit=0x00;
volatile uint16	bk_timer_T0_cnt,bk_timer_T1_cnt,bk_timer_T2_cnt;

//#define TIMER_CLK_IS_1M

void Timer_Initial(void)//timer_sel:1:16M,0:32k
{
	uint32 intr_v;
	intr_v = REG_AHB0_ICU_TIMER_CLKCON;
	intr_v &= ~(0x01<<BIT_TIMER_CLK_PWD);	//open Timer clk
#ifdef TIMER_CLK_IS_1M
	intr_v |= 1<<BIT_TIMER_CLK_SEL;	//set timer clk
#else
       intr_v &= ~(1<<BIT_TIMER_CLK_SEL);	//set timer clk
#endif
	REG_AHB0_ICU_TIMER_CLKCON = intr_v;
	REG_APB_TIMER_CTRL = 0;

}
/*
min time = 62.5ns(16M)	31.25us(32k)
max time = 4.096ms(16M)  2.048s(32k)
only 16M and 32k sel
note:@16M:the max ability is 13uS @no ather function
//sck:T_16M or T_32K
//for T_32K:time is us
//for T_16M:time is ns
*/
void Timer_Start(uint8 index,uint32 cnt)
{
    uint32 count;
#ifdef TIMER_CLK_IS_1M
    count = (cnt*16 )/1000;
#else
    count = (cnt*32)/1000;
#endif
    //g_bk_timer_func[index]=func;
   	switch(index)
	{
		case 0:
			REG_APB_TIMER0_TIMETO = (count<<16);
			bk_timer_T0_cnt = (count<<16);
			REG_APB_TIMER_CTRL |=( bit_PT0_ENABLE );
			REG_AHB0_ICU_INT_ENABLE|=INT_STATUS_TIMER0;
			break;
		case 1:
			bk_timer_hit &= ~0x02;
			REG_APB_TIMER1_TIMETO = (count<<16);
			bk_timer_T1_cnt = (count<<16);
			REG_APB_TIMER_CTRL |= (bit_PT1_ENABLE );
			REG_AHB0_ICU_INT_ENABLE|=INT_STATUS_TIMER1;
			break;
              case 2:
			REG_APB_TIMER2_TIMETO = (count&0xffff);
			bk_timer_T1_cnt = (count&0xffff);
			REG_APB_TIMER_CTRL |= (bit_PT2_ENABLE );
			REG_AHB0_ICU_INT_ENABLE|=INT_STATUS_TIMER2;
			break;
		default:
			break;
	}
}


void Timer_Stop(uint8 index)
{
    uint32 intr_v;

    if(index==0)
    {
        intr_v = REG_APB_TIMER_CTRL;
        intr_v &= ~bit_PT0_ENABLE;

        REG_APB_TIMER_CTRL = intr_v;
		REG_AHB0_ICU_INT_ENABLE&=~INT_STATUS_TIMER0;
        bk_timer_hit &= ~0x01;

    }
    else if (index == 1)
    {
        intr_v = REG_APB_TIMER_CTRL;
        intr_v &= ~bit_PT1_ENABLE;

        REG_APB_TIMER_CTRL = intr_v;
		REG_AHB0_ICU_INT_ENABLE&=~INT_STATUS_TIMER1;
        bk_timer_hit &= ~0x02;
    }
    else if (index == 2)
    {
        intr_v = REG_APB_TIMER_CTRL;
        intr_v &= ~bit_PT2_ENABLE;

        REG_APB_TIMER_CTRL = intr_v;
		REG_AHB0_ICU_INT_ENABLE&=~INT_STATUS_TIMER2;
        bk_timer_hit &= ~0x04;
    }
}


void Timer_ISR0(void)
{
  //  uint32 timer_status;
  //  timer_status=REG_APB_TIMER_CTRL;

    bk_timer_hit |= 0x01;
    REG_APB_TIMER0_TIMETO = bk_timer_T0_cnt;

    REG_APB_TIMER_CTRL |= bit_PT0_INT_FLAG;
}
void Timer_ISR1(void)
{
//    uint32 timer_status;
  //  timer_status=REG_APB_TIMER_CTRL;

    //timer1_callback();

    bk_timer_hit |= 0x02;
    REG_APB_TIMER1_TIMETO = bk_timer_T1_cnt;

    REG_APB_TIMER_CTRL |= bit_PT1_INT_FLAG;//timer_status;
}
void Timer_ISR2(void)
{

    bk_timer_hit |= 0x04;
    REG_APB_TIMER2_TIMETO = bk_timer_T2_cnt;

    REG_APB_TIMER2_TIMETO |= bit_PT2_INT_FLAG;
}



void Delay(int num)/* charles modify */
{
    int x, y;
    for(y = 0; y < num; y ++ )
    {
            for(x = 0; x < 50; x++);
    }
}




