#include "include.h"
#include "Hw_jal_defs.h"
#include "hw_lc_impl.h"
volatile uint32 *p_APB_XVER_ADDR   = (volatile uint32*)  APB_XVER_BASE ;

void xver_soft_reset(void);
void CLK32K_AutoCali_init(void);

void Delay_ms(int num) //sync from svn revision 18
{
    int x, y;
    for(y = 0; y < num; y ++ )
    {
        for(x = 0; x < 3260; x++);
    }

}

static u_int32 XVR_ANALOG_REG_BAK[5] = {0};

void kmod_calibration(void)
{


    u_int32 value;
    u_int32 value_kcal_result;

    XVR_REG24  |= (0x1 << 20);

    XVR_REG24  |= (0xf << 7);
    XVR_REG24  &= ~(0x1 << 17);
    XVR_REG24  &= ~(0x7f);
    XVR_REG25 |= (1<<12);
    Delay_ms(10);
    XVR_REG25 |= (1<<13);

    Delay_ms(50);

    XVR_ANALOG_REG_BAK[3] &= ~(0x1 << 6);
    XVR_REG03 = XVR_ANALOG_REG_BAK[3];
    Delay_ms(10);

    XVR_ANALOG_REG_BAK[3] |= (0x1 << 7);
    XVR_REG03 = XVR_ANALOG_REG_BAK[3];
    Delay_ms(10);
    XVR_REG25 |= (1<<16);

    Delay_ms(100);
    value = XVR_REG12;

    value = ((value >> 16) & 0x1fff);


    value_kcal_result =  ((256*250/value)&0x1ff) ;  //2M :((256*250/value)&0x1ff); 1M:((256*125/value)&0x1ff)
    if(value_kcal_result>0x100)
        value_kcal_result=0x100;

    //	uart_printf_test("value = 0x%x,value_kcal_result = 0x%x\r\n",value,value_kcal_result);
    XVR_REG30 &= (~(0x1ff<<8));
    XVR_REG30 |= (value_kcal_result<<8);
    Delay_ms(100);
    XVR_REG25 &= (~(1<<12));
    XVR_REG25 &= (~(1<<13));

    XVR_ANALOG_REG_BAK[3] &= ~(0x1 << 7);
    XVR_REG03 = XVR_ANALOG_REG_BAK[3];
    Delay_ms(10);

    XVR_ANALOG_REG_BAK[3] |= (0x1 << 6);
    XVR_REG03 = XVR_ANALOG_REG_BAK[3];

    XVR_REG25 &= (~(1<<16));

    XVR_REG24 |= (0x1 << 17);
    XVR_REG24  &= ~(0x1 << 20);

    XVR_REG30 |= (0x01 << 0);
    Delay_ms(100);
    XVR_REG24  &= ~(0x1 << 17);


    XVR_ANALOG_REG_BAK[4]=XVR_REG30;
    DEBUG_MSG(0xf2);



}


void xver_initial(void)
{
    Delay_ms(10);
    XVR_REG00 = 0XC4B03210;//0XC4B03210; // REG_0     
    XVR_REG01 = 0X8295C200;//0X8295C300; // REG_1
    XVR_REG02 = 0X2F22A000;//0X2F22A000; // REG_2
    XVR_REG03 = 0X2F62A262;//0X2F62A462; // REG_3
    XVR_REG04 = 0X5F915ECB; // REG_4
    XVR_REG05 = 0X48205213;//0X48205211; // REG_5
    XVR_REG06 = 0XE4FA0A00;//0X847A8A00; // REG_6
    XVR_REG07 = 0XAA007FC4;//0XAA007DC4;//0XAA003DC4; // REG_7
    XVR_REG08 = 0X07C08005;//0X7C1C00d ; // REG_8
    XVR_REG09 = 0X70203C48; // REG_9     
#if (USE_LDO_MODE)
        XVR_REG0A = 0X9C03786b;//0X9C275847; // REG_A
#else
        XVR_REG0A = 0X9C03786F;//0X9C275847; // REG_A
#endif

    XVR_REG0B = 0X0E67BF23;//0X0FD93F23; // REG_B
    XVR_REG0C = 0X8000D008; // REG_C
    XVR_REG0D = 0X00000000; // REG_D
    XVR_REG0E = 0X00000000; // REG_E
    XVR_REG0F = 0X00000000; // REG_F


    XVR_ANALOG_REG_BAK[0x0] = 0XC4B03210; // REG_0  
    XVR_ANALOG_REG_BAK[0x1] = 0X8295C200; // REG_1
    XVR_ANALOG_REG_BAK[0x2] = 0X2F22A000; // REG_2
    XVR_ANALOG_REG_BAK[0x3] = 0X2F62A262; // REG_3  


    XVR_REG10 = 0x00083435; // REG_10
    XVR_REG11 = 0x16810020; // REG_11
    XVR_REG12 = 0x00003C00; // REG_12
    XVR_REG13 = 0x00000000; // REG_13
    XVR_REG14 = 0x00080000; // REG_14
    XVR_REG15 = 0x00000000; // REG_15
    XVR_REG16 = 0x00000000; // REG_16
    XVR_REG17 = 0x00000000; // REG_17
    XVR_REG18 = 0x000001FF; // REG_18
    XVR_REG19 = 0x00000000; // REG_19
    XVR_REG1A = 0x00000000; // REG_1A
    XVR_REG1B = 0x00000000; // REG_1B
    XVR_REG1C = 0x00000000; // REG_1C
    XVR_REG1D = 0x00000000; // REG_1D
    XVR_REG1E = 0X00000000; // REG_1E
    XVR_REG1F = 0X00000000; // REG_1F



   //reg0x2a = 0x120840d;  reg0x2c = 0x006a404d ;
    XVR_REG20 = 0x8E89BED6;// REG_20
    XVR_REG21 = 0x96000000;//0x96000000;// REG_21
    XVR_REG22 = 0x78000000;// REG_22
    XVR_REG23 = 0xA0000000;// REG_23
    XVR_REG24 = 0x00080082;//0x00080082;// REG_24
    XVR_REG25 = 0X00200000;// REG_25
    XVR_REG26 = 0x10840505;// REG_26
    XVR_REG27 = 0x0008C900;// REG_27
    XVR_REG28 = 0x01011010;// REG_28
    XVR_REG29 = 0x3C104E00;// REG_29
    XVR_REG2A = 0x0e10304d;//0x0e10404d;//0x0e103D68;// REG_2A   
    XVR_REG2B = 0x00000408;// REG_2B
    XVR_REG2C = 0x006A404d;// REG_2C   //0x006a404d
    XVR_REG2D = 0x082CC446;// REG_2D 0x082CC444
    XVR_REG2E = 0x00000000;// REG_2E
    XVR_REG2F = 0X00000000;// REG_2F
    XVR_REG30 = 0x10010001;// REG_30
    XVR_REG31 = 0X00000000;// REG_31
    XVR_REG32 = 0X00000000;// REG_32
    XVR_REG33 = 0X00000000;// REG_33
    XVR_REG34 = 0X00000000;// REG_34
    XVR_REG35 = 0X00000000;// REG_35
    XVR_REG36 = 0X00000000;// REG_36
    XVR_REG37 = 0X00000000;// REG_37
    XVR_REG38 = 0X00000000;// REG_38
    XVR_REG39 = 0X00000000;// REG_39
    XVR_REG3A = 0x00128000;// REG_3A
    XVR_REG3B =0x3b341048; //0x36341048;// REG_3B 0x22341048  
    XVR_REG3C = 0x01FF1c00;// REG_3C
    XVR_REG3D = 0x00000000;// REG_3D
    XVR_REG3E = 0X00000000;// REG_3E
    XVR_REG3F = 0X00000000;// REG_3F
    XVR_REG40 = 0x01000000;// REG_40
    XVR_REG41 = 0x07050402;// REG_41
    XVR_REG42 = 0x120F0C0A;// REG_42
    XVR_REG43 = 0x221E1A16;// REG_43
    XVR_REG44 = 0x35302B26;// REG_44
    XVR_REG45 = 0x4B45403A;// REG_45
    XVR_REG46 = 0x635D5751;// REG_46
    XVR_REG47 = 0x7C767069;// REG_47
    XVR_REG48 = 0x968F8983;// REG_48
    XVR_REG49 = 0xAEA8A29C;// REG_49
    XVR_REG4A = 0xC5BFBAB4;// REG_4A
    XVR_REG4B = 0xD9D4CFCA;// REG_4B
    XVR_REG4C = 0xE9E5E1DD;// REG_4C
    XVR_REG4D = 0xF5F3F0ED;// REG_4D
    XVR_REG4E = 0xFDFBFAF8;// REG_4E
    XVR_REG4F = 0xFFFFFFFE;// REG_4F

    kmod_calibration();
/*
    XVR_REG00 = 0XC4B03210;//0XC4B03210; // REG_0
    XVR_REG01 = 0X8295C200;//0X8295C300; // REG_1
    XVR_REG02 = 0X2F22A000;//0X2F22A000; // REG_2
    XVR_REG03 = 0X2F62A262;//0X2F62A462; // REG_3

    XVR_REG07 = 0XAA007FC4;//0XAA003DC4; // REG_7
    
#if (USE_LDO_MODE)
    XVR_REG0A = 0X9C03786b;//0X9C275847; // REG_A
#else
    XVR_REG0A = 0X9C03786F;//0X9C275847; // REG_A
#endif
    
    XVR_REG0B = 0X0E67BF23;//0X0FD93F23; // REG_B
*/
}



void CLK32K_AutoCali_init(void)
{

    XVR_REG0C=0x80005008;  //0x8000D008  0x80009008

    XVR_REG0C=0x8000D008;  //0x8000D008  0x80009008

    Delay_ms(20);

}


//õز
//freq:Ƶã˫Ƶ(2-80)
//power:ʵȼ(0x1-0xf)
void bk3432_singleWaveCfg(u_int8 freq, u_int8 power_level)
{
	u_int32 val = 0;

	val |= freq;
	val |= (power_level<< 7);
	XVR_REG24 = val;
	XVR_REG25 |= (0x1<<12) |(0x1<<13);

	while(1);
}






void xver_soft_reset(void)
{

    #if 0
    (*((volatile unsigned long *)BEKEN_xver_soft_reset_ADDR)) &= 0x7fffffff;
    delay_us(10);

    (*((volatile unsigned long *)BEKEN_xver_soft_reset_ADDR)) |= 0x80000000;
    delay_us(10);

    (*((volatile unsigned long *)BEKEN_xver_soft_reset_ADDR)) &= 0x7fffffff;
    delay_us(10);
    #endif
}
