//======================================================
// File Name:     target.c
// Author:        Zhou Guofei
// Created Date:  @2015-01-12
// Description:   Interrupt vectors mapping 
//                2015.01.12 modified for BK3231S. 
//======================================================

#include "include.h"



//================================================================================
void FIQ_Exception(void) 
{
    unsigned int IntStat ;

    IntStat = REG_AHB0_ICU_INT_FLAG;

    if(IntStat & INT_STATUS_CEVA_bit)          //BLE XVR Int Assert
    {
//        Beken_CEVA_IntService();
    }

    if(IntStat & INT_STATUS_PWM_bit)
    {
//        Beken_PWM_IntService();
    }


    if(IntStat & INT_STATUS_BK24_bit)
    {
        // TBD Beken_BK24_IntService();
    }

    REG_AHB0_ICU_INT_FLAG = IntStat;
}
//================================================================================




//================================================================================
void IRQ_Exception(void)
{
    unsigned int IntStat;
    
    IntStat = REG_AHB0_ICU_INT_FLAG;
    
    if(IntStat & INT_STATUS_UART_bit)          //Uart1 Int Assert
    {
//        Beken_Uart_IntService();
    }
    
    if(IntStat & INT_STATUS_RTC_bit)           //RTC Int Assert
    {
//        Beken_RTC_IntService();
    }    
    
    if(IntStat & INT_STATUS_GPIO_bit)           //GPIO Int Assert
    {
//        Beken_GPIO_IntService();
    }       
    
    if(IntStat & INT_STATUS_ADC_bit)            //ADC Int Assert
    {
//        Beken_ADC_IntService();
    }
    
    if(IntStat & INT_STATUS_EXT_TIME_bit)      //External Timer (Sub-DeepSleep Timer) Int Assert
    {
//        SubDeepSleep_Timer_IntService();
    }

    if(IntStat & INT_STATUS_I2C_bit)           //I2c1 Int Assert
    {
        //BKI2cIntService(0);
    }

    if(IntStat & INT_STATUS_SPI_bit)           //Spi1 Int Assert
    {
        //BKSpiIntService(0);
    }

    REG_AHB0_ICU_INT_FLAG = IntStat;
}
//================================================================================
