
#ifndef _BK_CHIP_H_
#define _BK_CHIP_H_
//#include "include.h"

#define REG32(x)            (*((volatile uint32 *)(x)))


#define BIT_0               0x00000001
#define BIT_1               0x00000002
#define BIT_2               0x00000004
#define BIT_3               0x00000008
#define BIT_4               0x00000010
#define BIT_5               0x00000020
#define BIT_6               0x00000040
#define BIT_7               0x00000080
#define BIT_8               0x00000100
#define BIT_9               0x00000200
#define BIT_10              0x00000400
#define BIT_11              0x00000800
#define BIT_12              0x00001000
#define BIT_13              0x00002000
#define BIT_14              0x00004000
#define BIT_15              0x00008000
#define BIT_16              0x00010000
#define BIT_17              0x00020000
#define BIT_18              0x00040000
#define BIT_19              0x00080000
#define BIT_20              0x00100000
#define BIT_21              0x00200000
#define BIT_22              0x00400000
#define BIT_23              0x00800000
#define BIT_24              0x01000000
#define BIT_25              0x02000000
#define BIT_26              0x04000000
#define BIT_27              0x08000000
#define BIT_28              0x10000000
#define BIT_29              0x20000000
#define BIT_30              0x40000000
#define BIT_31              0x80000000



#define AHB_ICU_BASE             0x00800000
#define AHB_BK24_BASE            0x00810000


#define APB_WDT_BASE             0x00806000
#define APB_PWM_BASE             0x00806100
#define APB_SPI_BASE             0x00806200
#define APB_UART_BASE            0x00806300
#define APB_I2C_BASE             0x00806400
#define APB_GPIO_BASE            0x00806500
#define APB_RTC_BASE             0x00806600
#define APB_ADC_BASE             0x00806700
#define APB_TIMER_BASE           0x00806800
#define APB_RNG_BASE             0x00806900
#define APB_UART2_BASE           0x00806A00
#define APB_XVER_BASE            0x00801400
#define APB_CEVA_BASE            0x00820000

#define p_AHB0_ICU_BASE          (*((volatile unsigned long *)  0x00800000))
#define p_AHB1_CEVA_BASE         (*((volatile unsigned long *)  0x00820000))


#define BLE_RW_CTRL                 (*((volatile unsigned long *)  0x810000))
#define BLE_DEEPSLCNTL_ADDR         (*((volatile unsigned long *)  0x810030))
#define BLE_DEEPSLWKUP_ADDR         (*((volatile unsigned long *)  0x810034))




/////////////////////////////////////////////////////////////////////////////
//ICU register definitions
#define REG_AHB0_ICU_CLKSRCSEL             (*((volatile unsigned long *)   (AHB_ICU_BASE + 0x00) ))
#define SET_CLK_SEL_32K                    0x0
#define SET_CLK_SEL_16M                    0x1
#define SET_CLK_SEL_96M                    0x3

#define REG_AHB0_ICU_CORECLKCON            (*((volatile unsigned long *)   (AHB_ICU_BASE + 0x04) ))
#define BIT_CORE_CLK_DIV                   1

#define REG_AHB0_ICU_ADCCLKCON             (*((volatile unsigned long *)   (AHB_ICU_BASE + 0x08) ))
#define REG_AHB0_ICU_UARTCLKCON            (*((volatile unsigned long *)   (AHB_ICU_BASE + 0x0c) ))
#define REG_AHB0_ICU_I2CCLKCON             (*((volatile unsigned long *)   (AHB_ICU_BASE + 0x10) ))
#define REG_AHB0_ICU_SPICLKCON             (*((volatile unsigned long *)   (AHB_ICU_BASE + 0x14) ))
#define REG_AHB0_ICU_BLE_CLKCON            (*((volatile unsigned long *)   (AHB_ICU_BASE + 0x18) ))
#define REG_AHB0_ICU_WDTCLKCON             (*((volatile unsigned long *)   (AHB_ICU_BASE + 0x1c) ))
#define REG_AHB0_ICU_TIMER_CLKCON          (*((volatile unsigned long *)   (AHB_ICU_BASE + 0x20) ))
#define REG_AHB0_ICU_PWMCLKCON            (*((volatile unsigned long *)   (AHB_ICU_BASE + 0x24) ))
#define REG_AHB0_ICU_RTCCLKCON             (*((volatile unsigned long *)   (AHB_ICU_BASE + 0x28) ))

#define REG_AHB0_ICU_LPO_CLK_ON            (*((volatile unsigned long *)   (AHB_ICU_BASE + 0x2C) ))

#define REG_AHB0_ICU_CEVA_CLKCON            (*((volatile unsigned long *)   (AHB_ICU_BASE + 0x30) ))

#define REG_AHB0_ICU_ANA_CTL            (*((volatile unsigned long *)   (AHB_ICU_BASE + 0x34) ))

#define REG_AHB0_ICU_CPU_STATUS            (*((volatile unsigned long *)   (AHB_ICU_BASE + 0x38) ))

#define REG_AHB0_ICU_PWM4CLKCON            (*((volatile unsigned long *)   (AHB_ICU_BASE + 0x3C) ))

#define BIT_PWM4_CLK_SEL                   1
#define SET_PWM4_CLK_32K                   (0x0 << BIT_PWM4_CLK_SEL)
#define SET_PWM4_CLK_16M                   (0x1 << BIT_PWM4_CLK_SEL)
#define SET_PWM4_CLK_96M                   (0x2 << BIT_PWM4_CLK_SEL)
#define BIT_PWM5_CLK_SEL                   5
#define SET_PWM5_CLK_32K                   (0x0 << BIT_PWM5_CLK_SEL)
#define SET_PWM5_CLK_16M                   (0x1 << BIT_PWM5_CLK_SEL)
#define SET_PWM5_CLK_96M                   (0x2 << BIT_PWM5_CLK_SEL)
#define BIT_TIMER_CLK_PWD                  4
#define BIT_TIMER_CLK_SEL                  5
#define SET_TIMER_CLK_32K                  (0x0 << BIT_TIMER_CLK_SEL)
#define SET_TIMER_CLK_16M                  (0x1 << BIT_TIMER_CLK_SEL)

#define REG_AHB0_ICU_INT_ENABLE            (*((volatile unsigned long *)   (AHB_ICU_BASE + 0x40) ))
#define INT_STATUS_CEVA                (0x01<< 23)
#define INT_STATUS_PWM0                (0x01<< 0)
#define INT_STATUS_PWM1                (0x01<< 1)
#define INT_STATUS_PWM2                (0x01<< 2)
#define INT_STATUS_PWM3                (0x01<< 3)
#define INT_STATUS_PWM4                (0x01<< 4)
#define INT_STATUS_UART                (0x01<< 5)
#define INT_STATUS_SPI                 (0x01<< 6)
#define INT_STATUS_I2C                 (0x01<< 7)
#define INT_STATUS_ADC                 (0x01<< 8)
#define INT_STATUS_GPIO                (0x01<< 9)
#define INT_STATUS_TIMER0              (0x01<<10)
#define INT_STATUS_RTC                 (0x01<<12)

#define INT_STATUS_TIMER1              (0x01<<19)
#define INT_STATUS_TIMER2              (0x01<<20)





#define REG_AHB0_ICU_IRQ_ENABLE            (*((volatile unsigned long *)   (AHB_ICU_BASE + 0x44) ))
#define INT_IRQ_BIT                        (0x01<<0)
#define FIQ_IRQ_BIT                        (0x01<<1)

#define REG_AHB0_ICU_INT_STATUS_FLAG       (*((volatile unsigned long *)   (AHB_ICU_BASE + 0x48) ))

#define REG_AHB0_ICU_FLASH           (*((volatile unsigned long *)   (AHB_ICU_BASE + 0x4c) ))
#define REG_AHB0_ICU_ANALOG_MODE           (*((volatile unsigned long *)   (AHB_ICU_BASE + 0x50) ))
#define REG_AHB0_ICU_ANALOG0_PWD           (*((volatile unsigned long *)   (AHB_ICU_BASE + 0x54) ))
#define REG_AHB0_ICU_ANALOG1_PWD           (*((volatile unsigned long *)   (AHB_ICU_BASE + 0x58) ))
#define REG_AHB0_ICU_DIGITAL_PWD           (*((volatile unsigned long *)   (AHB_ICU_BASE + 0x5c) ))

//Digital PWD Bit
#define BIT_CLK16M_PWD                     3
#define BIT_HP_LDO_PWD                     2
#define BIT_CLK48M_PWD                     1
#define BIT_CB_BAIS_PWD                    0


#define BIT_REF1V_PWD                      4
#define SET_CLK16M_PWD                     (0x01 << BIT_CLK16M_PWD )
#define SET_CLK48M_PWD                     (0x01 << BIT_CLK48M_PWD )
#define SET_CB_BAIS_PWD                    (0x01 << BIT_CB_BAIS_PWD)
#define SET_HP_LDO_PWD                     (0x01 << BIT_HP_LDO_PWD )
#define SET_REF1V_PWD                      (0x01 << BIT_REF1V_PWD  )
#define SET_CLK16M_INT_WAKE                (0x01 << 7 )



// DEEP_SLEEP0 is GPIO-A to GPIO-D deep sleep wake-en
// DEEP_SLEEP1 is GPIO-E deep sleep wake-en and deep sleep word
#define REG_AHB0_ICU_DEEP_SLEEP_WAKEN           (*((volatile unsigned long *)   (AHB_ICU_BASE + 0x60) ))
#define BIT_GPIOA_WAKE_EN                  0
#define BIT_GPIOB_WAKE_EN                  8
#define BIT_GPIOC_WAKE_EN                  16
#define BIT_GPIOD_WAKE_EN                  24

#define REG_AHB0_ICU_DEEP_SLEEP_WORD           (*((volatile unsigned long *)   (AHB_ICU_BASE + 0x64) ))
#define BIT_GPIOE_WAKE_EN                  0
#define BIT_DEEP_SLEEP_WORD                16

#define REG_AHB0_ICU_DEEP_SLEEP_SEL           (*((volatile unsigned long *)   (AHB_ICU_BASE + 0x68) ))
#define REG_AHB0_ICU_SLEEP_TIME            (*((volatile unsigned long *)   (AHB_ICU_BASE + 0x6C) ))
#define BIT_MANU_FIN                       8
#define BIT_MANU_CIN                       3
#define BIT_MANU_EN                        2
#define BIT_CALI_MODE                      1
#define BIT_SPI_TRIG                       0
#define SET_MANU_FIN                       (0x1FF<< BIT_MANU_FIN )
#define SET_MANU_CIN                       (0x1F << BIT_MANU_CIN )
#define SET_MANU_EN                        (0x1  << BIT_MANU_EN  )
#define SET_CALI_MODE                      (0x1  << BIT_CALI_MODE)
#define SET_SPI_TRIG                       (0x1  << BIT_SPI_TRIG )

#define REG_AHB0_BOOST_READY_DLY           (*((volatile unsigned long *)   (AHB_ICU_BASE + 0x70) ))
#define REG_AHB0_RSTNREG_LATCH             (*((volatile unsigned long *)   (AHB_ICU_BASE + 0x74) ))
#define REG_AHB0_EXT_TIMER_CTRL            (*((volatile unsigned long *)   (AHB_ICU_BASE + 0x78) ))
#define REG_AHB0_FIQ_PRIORITY_EN           (*((volatile unsigned long *)   (AHB_ICU_BASE + 0x7C) ))
#define REG_AHB0_DCO16M_PWD                (*((volatile unsigned long *)   (AHB_ICU_BASE + 0x80) ))
#define REG_AHB0_OTP_PWD                   (*((volatile unsigned long *)   (AHB_ICU_BASE + 0x84) ))
#define REG_AHB0_OTP_CSTM_CFG0             (*((volatile unsigned long *)   (AHB_ICU_BASE + 0x88) ))
#define REG_AHB0_OTP_CSTM_CFG1             (*((volatile unsigned long *)   (AHB_ICU_BASE + 0x8C) ))
#define REG_AHB0_OTP_CSTM_CFG2             (*((volatile unsigned long *)   (AHB_ICU_BASE + 0x90) ))
#define REG_AHB0_OTP_CSTM_CFG3             (*((volatile unsigned long *)   (AHB_ICU_BASE + 0x94) ))
#define REG_AHB0_JTAG_MODE                 (*((volatile unsigned long *)   (AHB_ICU_BASE + 0x98) ))



//=====================================================================================
//BK24 baseband
#define  bk2401_config                  (*((volatile unsigned long *)   AHB_BK24_BASE +  0))
#define  bk2401_enaa                    (*((volatile unsigned long *)   AHB_BK24_BASE +  1))
#define  bk2401_enrx                    (*((volatile unsigned long *)   AHB_BK24_BASE +  2))
#define  bk2401_aw                      (*((volatile unsigned long *)   AHB_BK24_BASE +  3))
#define  bk2401_retr                    (*((volatile unsigned long *)   AHB_BK24_BASE +  4))
#define  bk2401_rfch                    (*((volatile unsigned long *)   AHB_BK24_BASE +  5))
#define  bk2401_setup                   (*((volatile unsigned long *)   AHB_BK24_BASE +  6))
#define  bk2401_r0_addr_0               (*((volatile unsigned long *)   AHB_BK24_BASE +  7))
#define  bk2401_r0_addr_1               (*((volatile unsigned long *)   AHB_BK24_BASE +  8))
#define  bk2401_r0_addr_2               (*((volatile unsigned long *)   AHB_BK24_BASE +  9))
#define  bk2401_r0_addr_3               (*((volatile unsigned long *)   AHB_BK24_BASE + 10))
#define  bk2401_r0_addr_4               (*((volatile unsigned long *)   AHB_BK24_BASE + 11))
#define  bk2401_r1_addr_0               (*((volatile unsigned long *)   AHB_BK24_BASE + 12))
#define  bk2401_r1_addr_1               (*((volatile unsigned long *)   AHB_BK24_BASE + 13))
#define  bk2401_r1_addr_2               (*((volatile unsigned long *)   AHB_BK24_BASE + 14))
#define  bk2401_r1_addr_3               (*((volatile unsigned long *)   AHB_BK24_BASE + 15))
#define  bk2401_r1_addr_4               (*((volatile unsigned long *)   AHB_BK24_BASE + 16))
#define  bk2401_r2_addr                 (*((volatile unsigned long *)   AHB_BK24_BASE + 17))
#define  bk2401_r3_addr                 (*((volatile unsigned long *)   AHB_BK24_BASE + 18))
#define  bk2401_r4_addr                 (*((volatile unsigned long *)   AHB_BK24_BASE + 19))
#define  bk2401_r5_addr                 (*((volatile unsigned long *)   AHB_BK24_BASE + 20))
#define  bk2401_tx_addr_0               (*((volatile unsigned long *)   AHB_BK24_BASE + 21))
#define  bk2401_tx_addr_1               (*((volatile unsigned long *)   AHB_BK24_BASE + 22))
#define  bk2401_tx_addr_2               (*((volatile unsigned long *)   AHB_BK24_BASE + 23))
#define  bk2401_tx_addr_3               (*((volatile unsigned long *)   AHB_BK24_BASE + 24))
#define  bk2401_tx_addr_4               (*((volatile unsigned long *)   AHB_BK24_BASE + 25))
#define  bk2401_r0_pw                   (*((volatile unsigned long *)   AHB_BK24_BASE + 26))
#define  bk2401_r1_pw                   (*((volatile unsigned long *)   AHB_BK24_BASE + 27))
#define  bk2401_r2_pw                   (*((volatile unsigned long *)   AHB_BK24_BASE + 28))
#define  bk2401_r3_pw                   (*((volatile unsigned long *)   AHB_BK24_BASE + 29))
#define  bk2401_r4_pw                   (*((volatile unsigned long *)   AHB_BK24_BASE + 30))
#define  bk2401_r5_pw                   (*((volatile unsigned long *)   AHB_BK24_BASE + 31))
#define  bk2401_dynpd                   (*((volatile unsigned long *)   AHB_BK24_BASE + 32))
#define  bk2401_feature                 (*((volatile unsigned long *)   AHB_BK24_BASE + 33))
#define  bk2401_cfg0c_0                 (*((volatile unsigned long *)   AHB_BK24_BASE + 34))
#define  bk2401_cfg0c_1                 (*((volatile unsigned long *)   AHB_BK24_BASE + 35))
#define  bk2401_cfg0c_2                 (*((volatile unsigned long *)   AHB_BK24_BASE + 36))
#define  bk2401_cfg0c_3                 (*((volatile unsigned long *)   AHB_BK24_BASE + 37))
#define  bk2401_cfg0d_0                 (*((volatile unsigned long *)   AHB_BK24_BASE + 38))
#define  bk2401_cfg0d_1                 (*((volatile unsigned long *)   AHB_BK24_BASE + 39))
#define  bk2401_cfg0d_2                 (*((volatile unsigned long *)   AHB_BK24_BASE + 40))
#define  bk2401_cfg0d_3                 (*((volatile unsigned long *)   AHB_BK24_BASE + 41))
#define  bk2401_table_0                 (*((volatile unsigned long *)   AHB_BK24_BASE + 42))
#define  bk2401_table_1                 (*((volatile unsigned long *)   AHB_BK24_BASE + 43))
#define  bk2401_table_2                 (*((volatile unsigned long *)   AHB_BK24_BASE + 44))
#define  bk2401_table_3                 (*((volatile unsigned long *)   AHB_BK24_BASE + 45))
#define  bk2401_table_4                 (*((volatile unsigned long *)   AHB_BK24_BASE + 46))
#define  bk2401_table_5                 (*((volatile unsigned long *)   AHB_BK24_BASE + 47))
#define  bk2401_table_6                 (*((volatile unsigned long *)   AHB_BK24_BASE + 48))
#define  bk2401_table_7                 (*((volatile unsigned long *)   AHB_BK24_BASE + 49))
#define  bk2401_table_8                 (*((volatile unsigned long *)   AHB_BK24_BASE + 50))
#define  bk2401_table_9                 (*((volatile unsigned long *)   AHB_BK24_BASE + 51))
#define  bk2401_table_A                 (*((volatile unsigned long *)   AHB_BK24_BASE + 52))
#define  bk2401_ce                      (*((volatile unsigned long *)   AHB_BK24_BASE + 53))
#define  bk2401_cmd                     (*((volatile unsigned long *)   AHB_BK24_BASE + 54))
#define  bk2401_fifo                    (*((volatile unsigned long *)   AHB_BK24_BASE + 55))
#define  bk2401_sdata_0                 (*((volatile unsigned long *)   AHB_BK24_BASE + 56))
#define  bk2401_sdata_1                 (*((volatile unsigned long *)   AHB_BK24_BASE + 57))
#define  bk2401_sdata_2                 (*((volatile unsigned long *)   AHB_BK24_BASE + 58))
#define  bk2401_sdata_3                 (*((volatile unsigned long *)   AHB_BK24_BASE + 59))
#define  bk2401_sctrl                   (*((volatile unsigned long *)   AHB_BK24_BASE + 60))
#define  bk2401_status                  (*((volatile unsigned long *)   AHB_BK24_BASE + 64))
#define  bk2401_observetx               (*((volatile unsigned long *)   AHB_BK24_BASE + 65))
#define  bk2401_cdstatus                (*((volatile unsigned long *)   AHB_BK24_BASE + 66))
#define  bk2401_fifostatus              (*((volatile unsigned long *)   AHB_BK24_BASE + 67))
#define  bk2401_rpl_width               (*((volatile unsigned long *)   AHB_BK24_BASE + 68))
#define  bk2401_mbist_st                (*((volatile unsigned long *)   AHB_BK24_BASE + 69))
#define  bk2401_bit_cnt_0               (*((volatile unsigned long *)   AHB_BK24_BASE + 72))
#define  bk2401_bit_cnt_1               (*((volatile unsigned long *)   AHB_BK24_BASE + 73))
#define  bk2401_bit_cnt_2               (*((volatile unsigned long *)   AHB_BK24_BASE + 74))
#define  bk2401_bit_cnt_3               (*((volatile unsigned long *)   AHB_BK24_BASE + 75))
#define  bk2401_err_cnt_0               (*((volatile unsigned long *)   AHB_BK24_BASE + 76))
#define  bk2401_err_cnt_1               (*((volatile unsigned long *)   AHB_BK24_BASE + 77))
#define  bk2401_err_cnt_2               (*((volatile unsigned long *)   AHB_BK24_BASE + 78))
#define  bk2401_err_cnt_3               (*((volatile unsigned long *)   AHB_BK24_BASE + 79))



//=====================================================================================
//MFC
//=====================================================================================
#define REG_AHB3_MFC_KEYWORD             (*((volatile unsigned long *)   0x00803000))
#define REG_AHB3_MFC_CONTROL             (*((volatile unsigned long *)   0x00803004))
#define REG_AHB3_MFC_ADDR                (*((volatile unsigned long *)   0x00803008))
#define REG_AHB3_MFC_DATA                (*((volatile unsigned long *)   0x0080300C))
#define REG_AHB3_MFC_WP0                 (*((volatile unsigned long *)   0x00803010))
#define REG_AHB3_MFC_WP1                 (*((volatile unsigned long *)   0x00803014))
#define REG_AHB3_MFC_WP2                 (*((volatile unsigned long *)   0x00803018))
#define REG_AHB3_MFC_WP3                 (*((volatile unsigned long *)   0x0080301c))

//// MFC INTRN ////
#define MFC_CONTROL_READ                (0x00)
#define MFC_CONTROL_WRITE               (0x01<<2)
#define MFC_CONTROL_SECT_ERASE          (0x02<<2)
#define MFC_CONTROL_BLOCK_ERASE         (0x03<<2)
#define MFC_CONTROL_CHIP_ERASE          (0x07<<2)
#define MFC_CONTROL_MAIN_SPACE          (0x00<<5)
#define MFC_CONTROL_NVR_SPACE           (0x01<<5)
#define MFC_CONTROL_RDN_SPACE           (0x02<<5)





//=====================================================================================
//WDT
#define REG_APB0_WDT_CFG                (*((volatile unsigned long *)   APB_WDT_BASE))
//=====================================================================================



//=====================================================================================
// 16bit PWM & Timer
//=====================================================================================
#define REG_APB_BK_PWM_CTRL    (*( (volatile unsigned long *)   (APB_PWM_BASE + (0x0*4)) ))
#define REG_APB_BK_PWM_INTR    (*( (volatile unsigned long *)   (APB_PWM_BASE + (0x1*4)) ))
#define REG_APB_BK_PWM0_CNT    (*( (volatile unsigned long *)   (APB_PWM_BASE + (0x2*4)) ))
#define REG_APB_BK_PWM0_CAP    (*( (volatile unsigned long *)   (APB_PWM_BASE + (0x3*4)) ))
#define REG_APB_BK_PWM1_CNT    (*( (volatile unsigned long *)   (APB_PWM_BASE + (0x4*4)) ))
#define REG_APB_BK_PWM1_CAP    (*( (volatile unsigned long *)   (APB_PWM_BASE + (0x5*4)) ))
#define REG_APB_BK_PWM2_CNT    (*( (volatile unsigned long *)   (APB_PWM_BASE + (0x6*4)) ))
#define REG_APB_BK_PWM2_CAP    (*( (volatile unsigned long *)   (APB_PWM_BASE + (0x7*4)) ))
#define REG_APB_BK_PWM3_CNT    (*( (volatile unsigned long *)   (APB_PWM_BASE + (0x8*4)) ))
#define REG_APB_BK_PWM3_CAP    (*( (volatile unsigned long *)   (APB_PWM_BASE + (0x9*4)) ))
#define REG_APB_BK_PWM4_CNT    (*( (volatile unsigned long *)   (APB_PWM_BASE + (0xA*4)) ))
#define REG_APB_BK_PWM4_CAP    (*( (volatile unsigned long *)   (APB_PWM_BASE + (0xB*4)) ))
#define REG_APB_BK_PWM5_CNT    (*( (volatile unsigned long *)   (APB_PWM_BASE + (0xC*4)) ))
#define REG_APB_BK_PWM5_CAP    (*( (volatile unsigned long *)   (APB_PWM_BASE + (0xD*4)) ))
#define REG_APB_BK_PWM6_CNT    (*( (volatile unsigned long *)   (APB_PWM_BASE + (0xE*4)) ))
#define REG_APB_BK_PWM6_CAP    (*( (volatile unsigned long *)   (APB_PWM_BASE + (0xF*4)) ))


// 16bit Timer
#define REG_APB_TIMER0_TIMETO     (*( (volatile unsigned long *)   (APB_TIMER_BASE + (0x0*4)) ))
#define REG_APB_TIMER1_TIMETO     (*( (volatile unsigned long *)   (APB_TIMER_BASE + (0x1*4)) ))
#define REG_APB_TIMER_CTRL        (*( (volatile unsigned long *)   (APB_TIMER_BASE + (0x2*4)) ))
#define REG_APB_TIMER2_TIMETO     (*( (volatile unsigned long *)   (APB_TIMER_BASE + (0x3*4)) ))

#define bit_PT0_ENABLE                        BIT_4
#define bit_PT1_ENABLE                        BIT_5
#define bit_PT2_ENABLE                        BIT_20

#define bit_PT0_INT_FLAG                      BIT_12
#define bit_PT1_INT_FLAG                      BIT_13
#define bit_PT2_INT_FLAG                      BIT_21


//=====================================================================================
//SPI
//=====================================================================================
#define REG_APB2_SPI_CTRL               (*((volatile unsigned long *)   (APB_SPI_BASE + 0x00) ))
#define REG_APB2_SPI_STAT               (*((volatile unsigned long *)   (APB_SPI_BASE + 0x04) ))
#define REG_APB2_SPI_DAT                (*((volatile unsigned long *)   (APB_SPI_BASE + 0x08) ))
//=====================================================================================



//=====================================================================================
// UART
//=====================================================================================
#define REG_APB3_UART_CFG               (*((volatile unsigned long *)   (APB_UART_BASE + 0x00) ))
#define REG_APB3_UART_FIFO_THRESHOLD    (*((volatile unsigned long *)   (APB_UART_BASE + 0x04) ))
#define REG_APB3_UART_FIFO_COUNT        (*((volatile unsigned long *)   (APB_UART_BASE + 0x08) ))
#define REG_APB3_UART_DATA              (*((volatile unsigned long *)   (APB_UART_BASE + 0x0C) ))
#define REG_APB3_UART_INT_ENABLE        (*((volatile unsigned long *)   (APB_UART_BASE + 0x10) ))
#define REG_APB3_UART_INT_FLAG          (*((volatile unsigned long *)   (APB_UART_BASE + 0x14) ))
#define REG_APB3_UART_FLOW_CTRL         (*((volatile unsigned long *)   (APB_UART_BASE + 0x18) ))
#define REG_APB3_UART_WAKE_CTRL         (*((volatile unsigned long *)   (APB_UART_BASE + 0x1c) ))
#define REG_APB3_UART2_CFG               (*((volatile unsigned long *)   0x00806a00))
#define REG_APB3_UART2_FIFO_CFG    		(*((volatile unsigned long *)   0x00806a04))
#define REG_APB3_UART2_FIFO_STAT        (*((volatile unsigned long *)   0x00806a08))
#define REG_APB3_UART2_PORT              (*((volatile unsigned long *)   0x00806a0C))
#define REG_APB3_UART2_INT_ENABLE        (*((volatile unsigned long *)   0x00806a10))
#define REG_APB3_UART2_INT_STAT          (*((volatile unsigned long *)   0x00806a14))
#define REG_APB3_UART2_FLOW_CFG         (*((volatile unsigned long *)   0x00806a18))
#define REG_APB3_UART2_WAKE_CFG         (*((volatile unsigned long *)   0x00806a1c))
	
#define BIT_UART_TX_ENABLE              0
#define BIT_UART_RX_ENABLE              1
#define BIT_UART_IRDA                   2
#define BIT_UART_LEN                    3
#define BIT_UART_PAR_EN                 5
#define BIT_UART_PAR_MODE               6
#define BIT_UART_STOP_LEN               7
#define BIT_UART_CLK_DIVID              8
#define SET_UART_TX_ENABLE              (0x1 << BIT_UART_TX_ENABLE)
#define SET_UART_RX_ENABLE              (0x1 << BIT_UART_RX_ENABLE)
#define SET_UART_IRDA                   (0x1 << BIT_UART_IRDA     )
#define SET_UART_LEN                    (0x3 << BIT_UART_LEN      )
#define SET_UART_PAR_EN                 (0x1 << BIT_UART_PAR_EN   )
#define SET_UART_PAR_MODE               (0x1 << BIT_UART_PAR_MODE )
#define SET_UART_STOP_LEN               (0x1 << BIT_UART_STOP_LEN )
#define SET_UART_CLK_DIVID              (0x1FFF<<BIT_UART_CLK_DIVID)

#define BIT_TX_FIFO_THRESHOLD           0
#define BIT_RX_FIFO_THRESHOLD           8
#define BIT_STOP_DETECT_TIME            16
#define SET_TX_FIFO_THRESHOLD           (0xFF<< BIT_TX_FIFO_THRESHOLD)
#define SET_RX_FIFO_THRESHOLD           (0xFF<< BIT_RX_FIFO_THRESHOLD)
#define SET_STOP_DETECT_TIME            (0x3 << BIT_STOP_DETECT_TIME)


// FIFO Read-Only Status:
#define BIT_TX_FIFO_COUNT               0
#define BIT_RX_FIFO_COUNT               8
#define BIT_TX_FIFO_FULL                16
#define BIT_TX_FIFO_EMPTY               17
#define BIT_RX_FIFO_FULL                18
#define BIT_RX_FIFO_EMPTY               19
#define BIT_FIFO_WR_READY               20
#define BIT_FIFO_RD_READY               21

#define BIT_UART_TX_FIFO_DIN            0
#define BIT_UART_RX_FIFO_DOUT           8
#define SET_UART_TX_FIFO_DIN            (0xFF<< BIT_UART_TX_FIFO_DIN )
#define SET_UART_RX_FIFO_DOUT           (0xFF<< BIT_UART_RX_FIFO_DOUT)


// UART Interrupts enable and flags
#define BIT_TX_FIFO_NEED_WRITE_EN       0
#define BIT_RX_FIFO_NEED_READ_EN        1
#define BIT_RX_FIFO_OVER_FLOW_EN        2
#define BIT_UART_RX_PARITY_ERR_EN       3
#define BIT_UART_RX_STOP_ERR_EN         4
#define BIT_UART_TX_STOP_END_EN         5
#define BIT_UART_RX_STOP_END_EN         6
#define BIT_UART_RXD_WAKEUP_EN          7
#define SET_TX_FIFO_NEED_WRITE_EN       (0x1 << BIT_TX_FIFO_NEED_WRITE_EN)
#define SET_RX_FIFO_NEED_READ_EN        (0x1 << BIT_RX_FIFO_NEED_READ_EN )
#define SET_RX_FIFO_OVER_FLOW_EN        (0x1 << BIT_RX_FIFO_OVER_FLOW_EN )
#define SET_UART_RX_PARITY_ERR_EN       (0x1 << BIT_UART_RX_PARITY_ERR_EN)
#define SET_UART_RX_STOP_ERR_EN         (0x1 << BIT_UART_RX_STOP_ERR_EN  )
#define SET_UART_TX_STOP_END_EN         (0x1 << BIT_UART_TX_STOP_END_EN  )
#define SET_UART_RX_STOP_END_EN         (0x1 << BIT_UART_RX_STOP_END_EN  )
#define SET_UART_RXD_WAKEUP_EN          (0x1 << BIT_UART_RXD_WAKEUP_EN   )

#define BIT_TX_FIFO_NEED_WRITE_FLAG     (0x1<<0)
#define BIT_RX_FIFO_NEED_READ_FLAG      (0x1<<1)
#define BIT_RX_FIFO_OVER_FLOW_FLAG      (0x1<<2)
#define BIT_UART_RX_PARITY_ERR_FLAG     (0x1<<3)
#define BIT_UART_RX_STOP_ERR_FLAG       (0x1<<4)
#define BIT_UART_TX_STOP_END_FLAG       (0x1<<5)
#define BIT_UART_RX_STOP_END_FLAG       (0x1<<6)
#define BIT_UART_RXD_WAKEUP_FLAG        (0x1<<7)
//=====================================================================================



//=====================================================================================
//IIC0
//=====================================================================================
#define REG_APB4_I2C_CN                 (*((volatile unsigned long *)   (APB_I2C_BASE + 0x00) ))
#define REG_APB4_I2C_STAT               (*((volatile unsigned long *)   (APB_I2C_BASE + 0x04) ))
#define REG_APB4_I2C_DAT                (*((volatile unsigned long *)   (APB_I2C_BASE + 0x08) ))

#define I2C_INTR_BIT                    (0x01<<9)
#define I2C_INTR_TX                     (0x01<<1)
//=====================================================================================

//=====================================================================================
//IIC1
//=====================================================================================
#define REG_APB4_I2C1_CN                 (*((volatile unsigned long *)   (APB_I2C1_BASE + 0x00) ))
#define REG_APB4_I2C1_STAT               (*((volatile unsigned long *)   (APB_I2C1_BASE + 0x04) ))
#define REG_APB4_I2C1_DAT                (*((volatile unsigned long *)   (APB_I2C1_BASE + 0x08) ))

#define I2C1_INTR_BIT                    (0x01<<9)
#define I2C1_INTR_TX                     (0x01<<1)
//=====================================================================================

//=====================================================================================
// GPIO
//=====================================================================================
#define REG_APB5_GPIO0_CFG              (*((volatile unsigned long *)   (APB_GPIO_BASE + 0x00) ))
#define REG_APB5_GPIO0_DATA             (*((volatile unsigned long *)   (APB_GPIO_BASE + 0x04) ))
#define REG_APB5_GPIO1_CFG              (*((volatile unsigned long *)   (APB_GPIO_BASE + 0x08) ))
#define REG_APB5_GPIO1_DATA             (*((volatile unsigned long *)   (APB_GPIO_BASE + 0x0C) ))
#define REG_APB5_GPIO2_CFG              (*((volatile unsigned long *)   (APB_GPIO_BASE + 0x10) ))
#define REG_APB5_GPIO2_DATA             (*((volatile unsigned long *)   (APB_GPIO_BASE + 0x14) ))
#define REG_APB5_GPIO3_CFG              (*((volatile unsigned long *)   (APB_GPIO_BASE + 0x18) ))
#define REG_APB5_GPIO3_DATA             (*((volatile unsigned long *)   (APB_GPIO_BASE + 0x1C) ))
#define REG_APB5_GPIO4_CFG              (*((volatile unsigned long *)   (APB_GPIO_BASE + 0x20) ))
#define REG_APB5_GPIO4_DATA             (*((volatile unsigned long *)   (APB_GPIO_BASE + 0x24) ))

#define REG_APB5_GPIO_WUATOD_TYPE       (*((volatile unsigned long *)   (APB_GPIO_BASE + 0x40) ))
#define REG_APB5_GPIO_WUE_TYPE          (*((volatile unsigned long *)   (APB_GPIO_BASE + 0x44) ))
#define REG_APB5_GPIO_WUATOD_ENABLE     (*((volatile unsigned long *)   (APB_GPIO_BASE + 0x48) ))
#define REG_APB5_GPIO_WUE_ENABLE        (*((volatile unsigned long *)   (APB_GPIO_BASE + 0x4C) ))
#define REG_APB5_GPIO_WUATOD_STAT       (*((volatile unsigned long *)   (APB_GPIO_BASE + 0x50) ))
#define REG_APB5_GPIO_WUE_STAT          (*((volatile unsigned long *)   (APB_GPIO_BASE + 0x54) ))

// GPIO config[7:0] are peripheral function enable low active. 0-Peri Function enable. 1-Normal GPIO.
#define BIT_GPIO_NORMAL                 0
#define BIT_GPIO_OUT_EN_N               8
#define BIT_GPIO_PULL_UP                16
#define BIT_GPIO_PULL_DOWN              24
#define BIT_GPIO_OUT_BUFFER             0
#define BIT_GPIO_IN_BUFFER              8
#define BIT_GPIO_INPUT_EN               16

#define BIT_GPIOA_WU_TYPE               0
#define BIT_GPIOB_WU_TYPE               8
#define BIT_GPIOC_WU_TYPE               16
#define BIT_GPIOD_WU_TYPE               24
#define BIT_GPIOE_WU_TYPE               0


//=====================================================================================
//RTC
//=====================================================================================
#define REG_APB6_RTC_CFG                (*((volatile unsigned long *)   (APB_RTC_BASE + 0x00) ))
#define BIT_RTC_ENABLE                  0
#define BIT_RTC_CLEAR                   1
#define BIT_RTC_ALARM_EN                2
#define BIT_RTC_ALARM_MODE              3
#define SET_RTC_ENABLE                  (0x1 << BIT_RTC_ENABLE     )
#define SET_RTC_CLEAR                   (0x1 << BIT_RTC_CLEAR      )
#define SET_RTC_ALARM_EN                (0x1 << BIT_RTC_ALARM_EN   )
#define SET_RTC_ALARM_MODE              (0x1 << BIT_RTC_ALARM_MODE )

#define REG_APB6_RTC_UNIT               (*((volatile unsigned long *)   (APB_RTC_BASE + 0x04) ))
#define BIT_RTC_DIV                     0
#define BIT_RTC_MSUNIT                  2
#define BIT_RTC_SUNIT                   8
#define SET_RTC_DIV                     (0x3    << BIT_RTC_DIV   )
#define SET_RTC_MSUNIT                  (0x3F   << BIT_RTC_MSUNIT)
#define SET_RTC_SUNIT                   (0xFFFF << BIT_RTC_SUNIT )

#define REG_APB6_RTC_SET                (*((volatile unsigned long *)   (APB_RTC_BASE + 0x08) ))
#define BIT_RTC_SECOND                  0
#define BIT_RTC_MINUTE                  6
#define BIT_RTC_HOUR                    12
#define BIT_RTC_WEEK                    17
#define SET_RTC_SECOND                  (0x3F << BIT_RTC_SECOND )
#define SET_RTC_MINUTE                  (0x3F << BIT_RTC_MINUTE )
#define SET_RTC_HOUR                    (0x1F << BIT_RTC_HOUR   )
#define SET_RTC_WEEK                    (0x7  << BIT_RTC_WEEK   )

#define REG_APB6_RTC_ALM_TIME           (*((volatile unsigned long *)   (APB_RTC_BASE + 0x0C) ))
#define BIT_RTC_ALARM_SECOND            0
#define BIT_RTC_ALARM_MINUTE            6
#define BIT_RTC_ALARM_HOUR              12
#define BIT_RTC_ALARM_MILLISEC          17
#define SET_RTC_ALARM_SECOND            (0x3F  << BIT_RTC_ALARM_SECOND   )
#define SET_RTC_ALARM_MINUTE            (0x3F  << BIT_RTC_ALARM_MINUTE   )
#define SET_RTC_ALARM_HOUR              (0x1F  << BIT_RTC_ALARM_HOUR     )
#define SET_RTC_ALARM_MILLISEC          (0x3FF << BIT_RTC_ALARM_MILLISEC )

#define REG_APB6_RTC_ALM_FLAG           (*((volatile unsigned long *)   (APB_RTC_BASE + 0x10) ))

// RTC Test Firmware Definition
#define BK_RTC_CLOCK_MODE         0
#define BK_RTC_MILLISEC_MODE      1
//=====================================================================================




//=====================================================================================
// ADC
//=====================================================================================
// TBD
#define REG_APB7_ADC_CFG                (*((volatile unsigned long *)   (APB_ADC_BASE + 0x00)))
#define REG_APB7_ADC_DAT                (*((volatile unsigned long *)   (APB_ADC_BASE + 0x04)))

#define BIT_ADC_MODE					0
#define BIT_ADC_EN						2
#define BIT_ADC_CHNL					3
#define BIT_ADC_WAIT_CLK_SETTING        7
#define BIT_ADC_INT_CLEAR				8
#define BIT_ADC_PRE_DIV                 9
#define BIT_ADC_DIV1_MODE				15
#define BIT_ADC_SAMPLE_RATE				16
#define BIT_ADC_FILTER					22
#define BIT_ADC_BUSY					29
#define BIT_ADC_FIFO_EMPTY				30
#define BIT_ADC_FIFO_FULL				31

#define SET_ADC_MODE                    (0x3 << BIT_ADC_MODE            )
#define SET_ADC_EN                      (0x1 << BIT_ADC_EN              )
#define SET_ADC_CHNL                    (0x7 << BIT_ADC_CHNL            )
#define SET_ADC_FIFO_EMPTY              (0x1 << BIT_ADC_FIFO_EMPTY      )
#define SET_ADC_FIFO_FULL               (0x1 << BIT_ADC_FIFO_FULL       )
#define SET_ADC_SAMPLE_RATE             (0x3 << BIT_ADC_SAMPLE_RATE     )
#define SET_ADC_WAIT_CLK_SETTING        (0x1 << BIT_ADC_WAIT_CLK_SETTING)
#define SET_ADC_INT_CLEAR               (0x1 << BIT_ADC_INT_CLEAR       )
//=====================================================================================

//===============================================================================
//BT_3DS
//===============================================================================
#define REG_APB8_3DS_CFG_0          (*((volatile unsigned long *)   (APB_3DS_BASE + 0x00)))
#define BIT_PWM0_ENABLE         8
#define BIT_PWM1_ENABLE         9
#define BIT_PWM2_ENABLE         10
#define BIT_PWM3_ENABLE         11
#define BIT_PWM0_START_SET      12
#define BIT_PWM1_START_SET      13
#define BIT_PWM2_START_SET      14
#define BIT_PWM3_START_SET      15

#define REG_APB8_3DS_CFG_1          (*((volatile unsigned long *)   (APB_3DS_BASE + 0x04)))
#define REG_APB8_3DS_CFG_2          (*((volatile unsigned long *)   (APB_3DS_BASE + 0x08)))
#define REG_APB8_3DS_CFG_3          (*((volatile unsigned long *)   (APB_3DS_BASE + 0x0C)))
#define REG_APB8_3DS_CFG_4          (*((volatile unsigned long *)   (APB_3DS_BASE + 0x10)))
#define REG_APB8_3DS_CFG_5          (*((volatile unsigned long *)   (APB_3DS_BASE + 0x14)))
#define REG_APB8_3DS_CFG_6          (*((volatile unsigned long *)   (APB_3DS_BASE + 0x18)))
#define REG_APB8_3DS_CFG_7          (*((volatile unsigned long *)   (APB_3DS_BASE + 0x1C)))
#define REG_APB8_3DS_CFG_8          (*((volatile unsigned long *)   (APB_3DS_BASE + 0x20)))
#define REG_APB8_3DS_CFG_9          (*((volatile unsigned long *)   (APB_3DS_BASE + 0x24)))
#define REG_APB8_3DS_CFG_A          (*((volatile unsigned long *)   (APB_3DS_BASE + 0x28)))
#define REG_APB8_3DS_CFG_B          (*((volatile unsigned long *)   (APB_3DS_BASE + 0x2C)))
#define REG_APB8_3DS_CFG_C          (*((volatile unsigned long *)   (APB_3DS_BASE + 0x30)))
#define REG_APB8_3DS_CFG_D          (*((volatile unsigned long *)   (APB_3DS_BASE + 0x34)))
#define REG_APB8_3DS_CFG_E          (*((volatile unsigned long *)   (APB_3DS_BASE + 0x38)))
#define REG_APB8_3DS_CFG_F          (*((volatile unsigned long *)   (APB_3DS_BASE + 0x3C)))

#define REG_APB8_3DS_CFG_10          (*((volatile unsigned long *)   (APB_3DS_BASE + 0x40)))
#define REG_APB8_3DS_CFG_11          (*((volatile unsigned long *)   (APB_3DS_BASE + 0x44)))
#define REG_APB8_3DS_CFG_12          (*((volatile unsigned long *)   (APB_3DS_BASE + 0x48)))
#define REG_APB8_3DS_CFG_13          (*((volatile unsigned long *)   (APB_3DS_BASE + 0x4C)))

#define REG_APB8_3DS_CFG_14          (*((volatile unsigned long *)   (APB_3DS_BASE + 0x50)))
#define REG_APB8_3DS_CFG_15          (*((volatile unsigned long *)   (APB_3DS_BASE + 0x54)))
#define REG_APB8_3DS_CFG_16          (*((volatile unsigned long *)   (APB_3DS_BASE + 0x58)))
#define REG_APB8_3DS_CFG_17          (*((volatile unsigned long *)   (APB_3DS_BASE + 0x5C)))
#define REG_APB8_3DS_CFG_18          (*((volatile unsigned long *)   (APB_3DS_BASE + 0x60)))
#define REG_APB8_3DS_CFG_19          (*((volatile unsigned long *)   (APB_3DS_BASE + 0x64)))
#define REG_APB8_3DS_CFG_1A          (*((volatile unsigned long *)   (APB_3DS_BASE + 0x68)))
#define REG_APB8_3DS_CFG_1B          (*((volatile unsigned long *)   (APB_3DS_BASE + 0x6C)))
#define REG_APB8_3DS_CFG_1C          (*((volatile unsigned long *)   (APB_3DS_BASE + 0x70)))
#define REG_APB8_3DS_CFG_1D          (*((volatile unsigned long *)   (APB_3DS_BASE + 0x74)))
#define REG_APB8_3DS_CFG_1E          (*((volatile unsigned long *)   (APB_3DS_BASE + 0x78)))
#define REG_APB8_3DS_CFG_1F          (*((volatile unsigned long *)   (APB_3DS_BASE + 0x7C)))

//XVR
#define XVR_REG00               (*((volatile unsigned int *)   (APB_XVER_BASE+0x0)))
#define XVR_REG01               (*((volatile unsigned int *)   (APB_XVER_BASE+0x4)))
#define XVR_REG02               (*((volatile unsigned int *)   (APB_XVER_BASE+0x8)))
#define XVR_REG03               (*((volatile unsigned int *)   (APB_XVER_BASE+0xC)))

#define XVR_REG04               (*((volatile unsigned int *)   (APB_XVER_BASE+0x10)))
#define XVR_REG05               (*((volatile unsigned int *)   (APB_XVER_BASE+0x14)))
#define XVR_REG06               (*((volatile unsigned int *)   (APB_XVER_BASE+0x18)))
#define XVR_REG07               (*((volatile unsigned int *)   (APB_XVER_BASE+0x1C)))

#define XVR_REG08               (*((volatile unsigned int *)   (APB_XVER_BASE+0x20)))
#define XVR_REG09               (*((volatile unsigned int *)   (APB_XVER_BASE+0x24)))
#define XVR_REG0A               (*((volatile unsigned int *)   (APB_XVER_BASE+0x28)))
#define XVR_REG0B               (*((volatile unsigned int *)   (APB_XVER_BASE+0x2C)))

#define XVR_REG0C               (*((volatile unsigned int *)   (APB_XVER_BASE+0x30)))
#define XVR_REG0D               (*((volatile unsigned int *)   (APB_XVER_BASE+0x34)))
#define XVR_REG0E               (*((volatile unsigned int *)   (APB_XVER_BASE+0x38)))
#define XVR_REG0F               (*((volatile unsigned int *)   (APB_XVER_BASE+0x3C)))

// Read-Back Registers
#define XVR_REG10                (*((volatile unsigned int *)   (APB_XVER_BASE+0x40)))
#define XVR_REG11                (*((volatile unsigned int *)   (APB_XVER_BASE+0x44)))
#define XVR_REG12                (*((volatile unsigned int *)   (APB_XVER_BASE+0x48)))
#define XVR_REG13                (*((volatile unsigned int *)   (APB_XVER_BASE+0x4C)))

#define XVR_REG14                (*((volatile unsigned int *)   (APB_XVER_BASE+0x50)))
#define XVR_REG15                (*((volatile unsigned int *)   (APB_XVER_BASE+0x54)))
#define XVR_REG16                (*((volatile unsigned int *)   (APB_XVER_BASE+0x58)))
#define XVR_REG17                (*((volatile unsigned int *)   (APB_XVER_BASE+0x5C)))

#define XVR_REG18                (*((volatile unsigned int *)   (APB_XVER_BASE+0x60)))
#define XVR_REG19                (*((volatile unsigned int *)   (APB_XVER_BASE+0x64)))
#define XVR_REG1A                (*((volatile unsigned int *)   (APB_XVER_BASE+0x68)))
#define XVR_REG1B                (*((volatile unsigned int *)   (APB_XVER_BASE+0x6C)))

#define XVR_REG1C                (*((volatile unsigned int *)   (APB_XVER_BASE+0x70)))
#define XVR_REG1D                (*((volatile unsigned int *)   (APB_XVER_BASE+0x74)))
#define XVR_REG1E                (*((volatile unsigned int *)   (APB_XVER_BASE+0x78)))
#define XVR_REG1F                (*((volatile unsigned int *)   (APB_XVER_BASE+0x7C)))

// XVR Config Registers
#define XVR_REG20                      (*((volatile unsigned int *)   (APB_XVER_BASE+0x80)))
#define XVR_REG21                      (*((volatile unsigned int *)   (APB_XVER_BASE+0x84)))
#define XVR_REG22                      (*((volatile unsigned int *)   (APB_XVER_BASE+0x88)))
#define XVR_REG23                      (*((volatile unsigned int *)   (APB_XVER_BASE+0x8C)))

#define XVR_REG24                      (*((volatile unsigned int *)   (APB_XVER_BASE+0x90)))
#define XVR_REG25                      (*((volatile unsigned int *)   (APB_XVER_BASE+0x94)))
#define XVR_REG26                      (*((volatile unsigned int *)   (APB_XVER_BASE+0x98)))
#define XVR_REG27                      (*((volatile unsigned int *)   (APB_XVER_BASE+0x9C)))

#define XVR_REG28                      (*((volatile unsigned int *)   (APB_XVER_BASE+0xA0)))
#define XVR_REG29                      (*((volatile unsigned int *)   (APB_XVER_BASE+0xA4)))
#define XVR_REG2A                      (*((volatile unsigned int *)   (APB_XVER_BASE+0xA8)))
#define XVR_REG2B                      (*((volatile unsigned int *)   (APB_XVER_BASE+0xAC)))

#define XVR_REG2C                      (*((volatile unsigned int *)   (APB_XVER_BASE+0xB0)))
#define XVR_REG2D                      (*((volatile unsigned int *)   (APB_XVER_BASE+0xB4)))
#define XVR_REG2E                      (*((volatile unsigned int *)   (APB_XVER_BASE+0xB8)))
#define XVR_REG2F                      (*((volatile unsigned int *)   (APB_XVER_BASE+0xBC)))

#define XVR_REG30                      (*((volatile unsigned int *)   (APB_XVER_BASE+0xC0)))
#define XVR_REG31                      (*((volatile unsigned int *)   (APB_XVER_BASE+0xC4)))
#define XVR_REG32                      (*((volatile unsigned int *)   (APB_XVER_BASE+0xC8)))
#define XVR_REG33                      (*((volatile unsigned int *)   (APB_XVER_BASE+0xCC)))

#define XVR_REG34                      (*((volatile unsigned int *)   (APB_XVER_BASE+0xD0)))
#define XVR_REG35                      (*((volatile unsigned int *)   (APB_XVER_BASE+0xD4)))
#define XVR_REG36                      (*((volatile unsigned int *)   (APB_XVER_BASE+0xD8)))
#define XVR_REG37                      (*((volatile unsigned int *)   (APB_XVER_BASE+0xDC)))

#define XVR_REG38                      (*((volatile unsigned int *)   (APB_XVER_BASE+0xE0)))
#define XVR_REG39                      (*((volatile unsigned int *)   (APB_XVER_BASE+0xE4)))
#define XVR_REG3A                      (*((volatile unsigned int *)   (APB_XVER_BASE+0xE8)))
#define XVR_REG3B                      (*((volatile unsigned int *)   (APB_XVER_BASE+0xEC)))

#define XVR_REG3C                      (*((volatile unsigned int *)   (APB_XVER_BASE+0xF0)))
#define XVR_REG3D                      (*((volatile unsigned int *)   (APB_XVER_BASE+0xF4)))
#define XVR_REG3E                      (*((volatile unsigned int *)   (APB_XVER_BASE+0xF8)))
#define XVR_REG3F                      (*((volatile unsigned int *)   (APB_XVER_BASE+0xFC)))

#define XVR_REG40                      (*((volatile unsigned int *)   (APB_XVER_BASE+0x100)))
#define XVR_REG41                      (*((volatile unsigned int *)   (APB_XVER_BASE+0x104)))
#define XVR_REG42                      (*((volatile unsigned int *)   (APB_XVER_BASE+0x108)))
#define XVR_REG43                      (*((volatile unsigned int *)   (APB_XVER_BASE+0x10C)))

#define XVR_REG44                      (*((volatile unsigned int *)   (APB_XVER_BASE+0x110)))
#define XVR_REG45                      (*((volatile unsigned int *)   (APB_XVER_BASE+0x114)))
#define XVR_REG46                      (*((volatile unsigned int *)   (APB_XVER_BASE+0x118)))
#define XVR_REG47                      (*((volatile unsigned int *)   (APB_XVER_BASE+0x11C)))

#define XVR_REG48                      (*((volatile unsigned int *)   (APB_XVER_BASE+0x120)))
#define XVR_REG49                      (*((volatile unsigned int *)   (APB_XVER_BASE+0x124)))
#define XVR_REG4A                      (*((volatile unsigned int *)   (APB_XVER_BASE+0x128)))
#define XVR_REG4B                      (*((volatile unsigned int *)   (APB_XVER_BASE+0x12C)))

#define XVR_REG4C                      (*((volatile unsigned int *)   (APB_XVER_BASE+0x130)))
#define XVR_REG4D                      (*((volatile unsigned int *)   (APB_XVER_BASE+0x134)))
#define XVR_REG4E                      (*((volatile unsigned int *)   (APB_XVER_BASE+0x138)))
#define XVR_REG4F                      (*((volatile unsigned int *)   (APB_XVER_BASE+0x13C)))





#endif

