#include "BK_reg.h"
#include "updata_driver_icu.h"
#include "updata_main.h"

void updata_switch_clk(uint8 clk)
{
    REG_AHB0_ICU_DIGITAL_PWD = REG_AHB0_ICU_DIGITAL_PWD & (~0X02);

    if (clk == MCU_CLK_16M )
    {
    	REG_AHB0_ICU_CORECLKCON = 0X00; //clk div 0

    	REG_AHB0_ICU_CLKSRCSEL = 0X000001F9; //usr 16m,VN=7,VD=3

    }
    else if (clk == MCU_CLK_64M )
    {
    	REG_AHB0_ICU_CORECLKCON = 0X00; //clk div 0

    	REG_AHB0_ICU_CLKSRCSEL = 0X000005FB; //usr PLL CLK SELT 64M

     }

    else if (clk == MCU_CLK_32M )
    {
    	REG_AHB0_ICU_CORECLKCON = 0x04; //clk div 2

    	REG_AHB0_ICU_CLKSRCSEL = 0X000005FB; //usr PLL CLK SELT 64M

    }

}

void updata_icu_init(void)
{
#if DEBUG_HW
	REG_AHB0_ICU_LPO_CLK_ON |= (0x01 << 2);
#endif

    REG_AHB0_ICU_FLASH &= ~(0xff << 16);
    REG_AHB0_ICU_FLASH |= (0x15 << 16);

    REG_AHB0_ICU_CPU_STATUS  = 0x771;


	REG_AHB0_ICU_DIGITAL_PWD = REG_AHB0_ICU_DIGITAL_PWD & (~0X02);

	REG_AHB0_ICU_CORECLKCON = 0X00;

	REG_AHB0_ICU_CLKSRCSEL = 0X000001F9; //usr 16M,

	REG_AHB0_ICU_ANA_CTL |= (0X01 << 6);

    REG_AHB0_ICU_BLE_CLKCON=0x01;
    REG_AHB0_ICU_CEVA_CLKCON=0x02;

    updata_switch_clk(MCU_CLK_64M);

}


