

; AEB1 Specific Definitions

SRAM_LIMIT  EQU    0x00403FFC 
	

IRQ_STACK   EQU    SRAM_LIMIT-64                ;IRQ: 0x004077Ff- 0x00407FFC
FIQ_STACK   EQU    IRQ_STACK-256             ;FIQ: 0x00406fFf- 0x004077Ff
SVC_STACK   EQU    FIQ_STACK-512-256             ;SVC: 0x004063Ff -0x00406fFf
USR_STACK   EQU    SVC_STACK-1024-512-256
SYS_STACK   EQU    USR_STACK-12

    EXPORT IRQ_STACK
    EXPORT FIQ_STACK
    EXPORT SVC_STACK
    EXPORT USR_STACK	
    

;
; FUNCTION:     _SYSboot_Setup_Stacks_Disable_Intr
; DESCRIPTION:  Setup stack pointers for IRQ Mode, FIQ Mode, SVC Mode 
;               ensuring all the time that IRQ and FIQ are disabled

_SYSboot_Setup_Stacks_Disable_Intr
        LDR     R0, =0xDEADBEEF
        LDR     R1, =USR_STACK
        STR     R0, [R1]

        ;MOV     R0, #MODE_IRQ:OR:I_BIT:OR:F_BIT
        ;MSR     CPSR_c, R0
        ;LDR     R13, =IRQ_STACK

        MOV     R0, #MODE_IRQ:OR:I_BIT:OR:F_BIT
        MSR     CPSR_c, R0
        LDR     R13, =IRQ_STACK
        LDR     R0, =0xDEADBEEF
        STR     R0, [R13]

        MOV     R0, #MODE_FIQ:OR:I_BIT:OR:F_BIT
        MSR     CPSR_c, R0
        LDR     R13, =FIQ_STACK
        LDR     R0, =0xDEADBEEF
        STR     R0, [R13]

        MOV     R0, #MODE_SYS:OR:I_BIT:OR:F_BIT
        MSR     CPSR_c, R0
        LDR     R13, =SYS_STACK
        LDR     R0, =0xDEADBEEF
        STR     R0, [R13]

        MOV     R0, #MODE_SVC:OR:I_BIT:OR:F_BIT
        MSR     CPSR_c, R0
        LDR     R13, =SVC_STACK
        LDR     R0, =0xDEADBEEF
        STR     R0, [R13]

		BX lr
    END
