
#include "updata_sys_irq.h"




__IRQ__ void  SYSirq_FIQ_Handler(void)

{
    unsigned int IntStat ;
    
    IntStat = REG_AHB0_ICU_INT_STATUS_FLAG;
   
    REG_AHB0_ICU_INT_STATUS_FLAG= IntStat;
}

 __IRQ__ void SYSirq_IRQ_Handler(void)

{
    unsigned int IntStat;
    
    IntStat = REG_AHB0_ICU_INT_STATUS_FLAG;
    if(IntStat & INT_STATUS_UART)          
    {
        UART_Interrupt_Handler();
    }

    REG_AHB0_ICU_INT_STATUS_FLAG= IntStat;
}




/******************************************************************************
 *
 * FUNCTION:  SYSirq_Disable_Interrupts_Save_Flags
 * PURPOSE:   Disables ARM IRQ and FIQ Interrupts, saves previous
 *            PSR
 *
 ******************************************************************************/
void SYSirq_Disable_Interrupts_Save_Flags(u_int32 *flags)
{
	   #pragma arm
#ifndef __GNUC__
    u_int32 current_flags,my_tmp_flags;
    __asm
    {
	    MRS current_flags, CPSR                 /* Get current CPSR */
        AND my_tmp_flags, current_flags, #0xc0  /* Clear all ex. IRQ and FIQ */
        STR my_tmp_flags, [flags]               /* "save" flags */
#if (PRH_BS_DEV_UART_FIQ_ALWAYS_ENABLED==1)
        ORR current_flags, current_flags, #0x80 /* Disable IRQ Only */
#else
        ORR current_flags, current_flags, #0xc0 /* Disable IRQ and FIQ */
#endif
        MSR CPSR_c, current_flags                 /* Write back */
    }
#else
    /* GNU C inline asm? */
#endif
}



/******************************************************************************
 *
 * FUNCTION:  SYSirq_Enable_Interrupts_Save_Flags
 * PURPOSE:   Enables ARM IRQ and FIQ Interrupts, saves previous
 *            PSR
 *
 ******************************************************************************/
void SYSirq_Enable_Interrupts_Save_Flags(u_int32 *flags)
{
	   #pragma arm
#ifndef __GNUC__
    u_int32 current_flags,my_tmp_flags;
    __asm
    {
	    MRS current_flags, CPSR                 /* Get current CPSR */
        AND my_tmp_flags, current_flags, #0xc0  /* Clear all ex. IRQ and FIQ */
        STR my_tmp_flags, [flags]               /* "save" flags */
        AND current_flags, current_flags, #0x3f /* Enable IRQ and FIQ */
        MSR CPSR_c, current_flags                 /* Write back */
    }
#else
    /* GNU C inline asm? */
#endif
}











